local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 15,["9"] = 15,["10"] = 24,["11"] = 25,["12"] = 26,["13"] = 24,["14"] = 29,["15"] = 30,["16"] = 31,["17"] = 31,["18"] = 31,["19"] = 32,["20"] = 33,["21"] = 34,["23"] = 31,["24"] = 31,["25"] = 38,["26"] = 39,["27"] = 38,["28"] = 29,["29"] = 16,["30"] = 17,["31"] = 18,["32"] = 44,["33"] = 44});
local ____exports = {}
local ____scheduler = require("systems.scheduler")
local scheduler = ____scheduler.scheduler
local AmbienceComponent = __TS__Class()
AmbienceComponent.name = "AmbienceComponent"
function AmbienceComponent.prototype.____constructor(self, ambience)
    self.sfx = ambience.sfx
    self.autostart = ambience.autostart or false
end
function AmbienceComponent.prototype.create(self, entity)
    self.event = audio.play(self.sfx)
    scheduler:add(
        1,
        function()
            self.event:setPosition(entity.transform.position)
            if self.autostart or entity.consumer ~= nil and entity.consumer.isRunning then
                self.event:start()
            end
        end
    )
    entity.onDestroy:listen(function(____, entity)
        self.event:stop(FMODStopMode.FMOD_STUDIO_STOP_ALLOWFADEOUT)
    end)
end
AmbienceComponent.type = "ambience"
AmbienceComponent.cid = hash.hash_str32(AmbienceComponent.type)
AmbienceComponent.serializable = false
____exports.AmbienceComponent = AmbienceComponent
____exports.component = AmbienceComponent
return ____exports
