local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local Map = ____lualib.Map
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["8"] = 1,["9"] = 1,["10"] = 17,["11"] = 17,["12"] = 26,["13"] = 23,["14"] = 24,["15"] = 27,["16"] = 28,["17"] = 29,["19"] = 26,["20"] = 33,["21"] = 34,["22"] = 34,["23"] = 34,["24"] = 34,["25"] = 33,["26"] = 37,["27"] = 38,["28"] = 37,["29"] = 18,["30"] = 19,["31"] = 20,["32"] = 42,["33"] = 42});
local ____exports = {}
local ____core = require("core")
local core = ____core.core
local GathererComponent = __TS__Class()
GathererComponent.name = "GathererComponent"
function GathererComponent.prototype.____constructor(self, gatherer)
    self.distance = 8
    self.ignored = __TS__New(Map)
    self.range = gatherer.range or 0
    if gatherer.distance then
        self.distance = gatherer.distance
    end
end
function GathererComponent.prototype.ignore(self, entity)
    self.ignored:set(
        entity.id,
        entity.onDestroy:listen(core.cb(self, "handleEntityDestroyed"))
    )
end
function GathererComponent.prototype.handleEntityDestroyed(self, entity)
    self.ignored:delete(entity.id)
end
GathererComponent.type = "gatherer"
GathererComponent.cid = hash.hash_str32(GathererComponent.type)
GathererComponent.serialization = SERIALIZATION_OFF
____exports.GathererComponent = GathererComponent
____exports.component = GathererComponent
return ____exports
