local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__New = ____lualib.__TS__New
local __TS__SetDescriptor = ____lualib.__TS__SetDescriptor
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["8"] = 1,["9"] = 1,["10"] = 14,["11"] = 14,["12"] = 34,["13"] = 31,["14"] = 32,["15"] = 36,["16"] = 38,["17"] = 39,["19"] = 41,["21"] = 34,["27"] = 21,["29"] = 24,["30"] = 25,["31"] = 26,["32"] = 27,["33"] = 28,["38"] = 45,["39"] = 46,["40"] = 45,["41"] = 15,["42"] = 16,["43"] = 17,["44"] = 50,["45"] = 50});
local ____exports = {}
local ____event = require("event")
local Event = ____event.Event
local NpcComponent = __TS__Class()
NpcComponent.name = "NpcComponent"
function NpcComponent.prototype.____constructor(self, npc)
    self.entityID = INVALID_ENTITYID
    self.onStateChange = __TS__New(Event)
    self.data:setUint8(0, 0)
    if npc.onStateChange then
        self.onStateChange = npc.onStateChange:copy()
    else
        self.onStateChange = __TS__New(Event)
    end
end
__TS__SetDescriptor(
    NpcComponent.prototype,
    "state",
    {
        get = function(self)
            return self.data:getUint8(0)
        end,
        set = function(self, value)
            local previous = self.state
            self.data:setUint8(0, value)
            local entity = EntityManager.get(self.entityID)
            self.onStateChange:invoke(entity, value, previous)
        end
    },
    true
)
function NpcComponent.prototype.create(self, entity)
    self.entityID = entity.id
end
NpcComponent.type = "npc"
NpcComponent.cid = hash.hash_str32(NpcComponent.type)
NpcComponent.serialization = 1
____exports.NpcComponent = NpcComponent
____exports.component = NpcComponent
return ____exports
