local ____lualib = require("lualib_bundle")
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["5"] = 1,["6"] = 1,["7"] = 1,["8"] = 1,["9"] = 1,["10"] = 1,["11"] = 1,["12"] = 9,["13"] = 9,["14"] = 9,["15"] = 9,["16"] = 9,["17"] = 9,["18"] = 9,["19"] = 17,["20"] = 17,["21"] = 17,["22"] = 17,["23"] = 17,["24"] = 17,["25"] = 17,["26"] = 25,["27"] = 33,["28"] = 34,["29"] = 33,["30"] = 37,["31"] = 38,["32"] = 37,["33"] = 41,["34"] = 42,["35"] = 41,["36"] = 45,["37"] = 46,["38"] = 45,["39"] = 49,["40"] = 50,["41"] = 50,["42"] = 51,["43"] = 51,["44"] = 52,["45"] = 52,["46"] = 53,["47"] = 53,["49"] = 54,["50"] = 49,["51"] = 57,["52"] = 57,["53"] = 57,["54"] = 57,["55"] = 57,["56"] = 57});
local ____exports = {}
local DIRECTION_VECTORS = {
    Vector.new(0, -1),
    Vector.new(1, 0),
    Vector.new(0, 1),
    Vector.new(-1, 0),
    Vector.new(-1, 0)
}
local DIRECTION_RECTS = {
    Rect.new(0, -1, 0, 1),
    Rect.new(0, 0, 1, 0),
    Rect.new(0, 0, 0, 1),
    Rect.new(-1, 0, 1, 0),
    Rect.new(-1, 0, 1, 0)
}
local OPPOSITE_DIRECTIONS = {
    FacingDirection.Down,
    FacingDirection.Left,
    FacingDirection.Up,
    FacingDirection.Right,
    FacingDirection.Left
}
local OPPOSITE_TILE_DIRECTIONS = {TileDirection.Down, TileDirection.Left, TileDirection.Up, TileDirection.Right}
local function getDirectionVector(self, direction)
    return DIRECTION_VECTORS[direction + 1]
end
local function getDirectionRect(self, direction)
    return DIRECTION_RECTS[direction + 1]
end
local function getOppositeDirection(self, direction)
    return OPPOSITE_DIRECTIONS[direction + 1]
end
local function getOppositeTileDirection(self, direction)
    return OPPOSITE_TILE_DIRECTIONS[direction + 1]
end
local function getFacingDirection(self, direction)
    if direction.x == 1 then
        return FacingDirection.Right
    elseif direction.y == 1 then
        return FacingDirection.Down
    elseif direction.x == -1 then
        return FacingDirection.Left
    elseif direction.y == -1 then
        return FacingDirection.Up
    end
    return FacingDirection.Right
end
____exports.FacingDirection = FacingDirection
____exports.getDirectionVector = getDirectionVector
____exports.getDirectionRect = getDirectionRect
____exports.getOppositeDirection = getOppositeDirection
____exports.getOppositeTileDirection = getOppositeTileDirection
____exports.getFacingDirection = getFacingDirection
return ____exports
