local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__SetDescriptor = ____lualib.__TS__SetDescriptor
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["8"] = 1,["9"] = 1,["10"] = 1,["11"] = 1,["12"] = 1,["13"] = 1,["14"] = 1,["15"] = 9,["16"] = 9,["17"] = 9,["18"] = 9,["19"] = 9,["20"] = 9,["21"] = 9,["22"] = 17,["23"] = 17,["24"] = 21,["25"] = 22,["26"] = 23,["27"] = 21,["32"] = 27,["40"] = 31,["44"] = 34,["45"] = 35,["46"] = 34,["47"] = 39,["48"] = 40,["49"] = 42,["50"] = 42,["52"] = 42,["57"] = 44,["65"] = 48,["73"] = 52,["77"] = 55,["78"] = 56,["79"] = 55,["80"] = 60,["81"] = 62,["82"] = 62});
local ____exports = {}
local FLUID_ICONS = {
    INVALID_ATLAS_HANDLE,
    atlases.get("icons_water"),
    atlases.get("icons_lava"),
    atlases.get("icons_miasma"),
    atlases.get("icons_aether")
}
local FLUID_NAMES = {
    "None",
    "material.water",
    "material.lava",
    "material.miasma",
    "material.aether"
}
local FluidItem = __TS__Class()
FluidItem.name = "FluidItem"
function FluidItem.prototype.____constructor(self, ____type, quantity)
    self.type = ____type
    self.quantity = quantity
end
__TS__SetDescriptor(
    FluidItem.prototype,
    "icon",
    {get = function(self)
        return FLUID_ICONS[self.type + 1]
    end},
    true
)
__TS__SetDescriptor(
    FluidItem.prototype,
    "prefab",
    {get = function(self)
        return FLUID_NAMES[self.type + 1]
    end},
    true
)
function FluidItem.prototype.isEmpty(self)
    return self.quantity == 0
end
local UNKNOWN_PREFAB = "Unknown"
local UNKNOWN_ICON_ATLAS = atlases.get("icons_unknown")
local UnknownItem = __TS__Class()
UnknownItem.name = "UnknownItem"
function UnknownItem.prototype.____constructor(self)
end
__TS__SetDescriptor(
    UnknownItem.prototype,
    "quantity",
    {get = function(self)
        return 1
    end},
    true
)
__TS__SetDescriptor(
    UnknownItem.prototype,
    "icon",
    {get = function(self)
        return UNKNOWN_ICON_ATLAS
    end},
    true
)
__TS__SetDescriptor(
    UnknownItem.prototype,
    "prefab",
    {get = function(self)
        return UNKNOWN_PREFAB
    end},
    true
)
function UnknownItem.prototype.isEmpty(self)
    return self.quantity == 0
end
local UNKNOWN_ITEM = __TS__New(UnknownItem)
____exports.FluidItem = FluidItem
____exports.UNKNOWN_ITEM = UNKNOWN_ITEM
return ____exports
