local ____lualib = require("lualib_bundle")
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["5"] = 1,["6"] = 1,["7"] = 2,["8"] = 2,["9"] = 4,["10"] = 5,["11"] = 9,["12"] = 11,["13"] = 15,["14"] = 19,["15"] = 19,["16"] = 19,["17"] = 19,["18"] = 19,["19"] = 19,["20"] = 25,["21"] = 26,["24"] = 30,["25"] = 31,["26"] = 32,["27"] = 33,["30"] = 37,["31"] = 38,["32"] = 39,["35"] = 42,["36"] = 43,["37"] = 44,["38"] = 45,["39"] = 46,["40"] = 47,["41"] = 48,["42"] = 49,["43"] = 50,["44"] = 51,["45"] = 19,["46"] = 19});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____world = require("world")
local World = ____world.World
local prefab = Prefab.getCurrent()
prefab:addTransform({origin = Vector.new(12, 12)})
prefab:addDropped()
prefab:addLocation({layer = LayerTypes.Foreground})
prefab:addRender("icons_soil", {layer = 128})
prefab:addPhysics({
    layer = PhysicsLayers.ITEM,
    body = Rect.new(0, 0, 16, 16),
    offset = Vector.new(-8, -8),
    terminalVelocity = Vector.new(6, 6),
    restitution = 0.35,
    onCollision = function(entity, collision)
        if bit.band(collision.direction, Direction.Bottom) ~= Direction.Bottom then
            return
        end
        local ground = World:get(entity.location.realm).ground.map
        local position = collision.body:center()
        local tile = ground:get(position:asTileVector())
        if tile:isEmpty() then
            return
        end
        local tileData = tile.foliage ~= INVALID_TILE_ID and Tile.get(tile.foliage) or tile:data()
        local itemEntity = entity.dropped.item:entity()
        if itemEntity.item == nil then
            return
        end
        local item = itemEntity.item
        local physics = entity.physics
        local volume = math.abs(physics.velocity.y) / physics.terminalVelocity.y
        local sfx = audio.play("event:/RESOURCE/RESOURCE_LAND")
        sfx:setPosition(position)
        sfx:setParameterByNameWithLabel("TERRAIN", tileData.terrainSound, false)
        sfx:setParameterByNameWithLabel("MATERIAL", item.materialSound, false)
        sfx:setVolume(volume)
        sfx:start()
        sfx:release()
    end
})
return ____exports
