local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 2,["9"] = 2,["10"] = 3,["11"] = 3,["12"] = 8,["13"] = 10,["14"] = 12,["15"] = 16,["16"] = 18,["17"] = 20,["18"] = 25,["19"] = 29,["20"] = 31,["21"] = 31,["22"] = 31,["23"] = 31,["24"] = 31,["25"] = 31,["26"] = 31,["27"] = 30,["28"] = 32,["29"] = 32,["30"] = 32,["31"] = 32,["32"] = 32,["33"] = 32,["34"] = 32,["35"] = 30,["36"] = 29,["37"] = 36,["38"] = 36,["39"] = 38,["40"] = 39,["41"] = 39,["42"] = 39,["43"] = 39,["44"] = 39,["45"] = 39,["46"] = 36,["47"] = 36,["48"] = 43,["49"] = 43,["50"] = 43,["51"] = 43,["52"] = 48,["53"] = 49,["54"] = 49,["55"] = 49,["56"] = 50,["57"] = 51,["58"] = 52,["60"] = 54,["62"] = 56,["63"] = 57,["64"] = 49,["65"] = 48,["66"] = 59,["67"] = 59,["68"] = 59,["69"] = 60,["70"] = 61,["71"] = 62,["72"] = 63,["73"] = 63,["74"] = 63,["75"] = 63,["76"] = 64,["77"] = 64,["78"] = 64,["79"] = 64,["80"] = 59,["81"] = 48,["82"] = 48});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("ancient_device_primary")
prefab:addIllumination(1)
prefab:addAnimation({start = "idle", loop = true})
prefab:addCollector({reach = 0})
prefab:addInventory({inventories = {
    {
        name = "input-0",
        size = 1,
        collectStack = 1000,
        stackOverride = 1000,
        filterPrefabs = {Prefab.getID("material.mana_fiber")},
        features = InventoryFeatures.Collect
    },
    {
        name = "input-1",
        size = 1,
        collectStack = 1000,
        stackOverride = 1000,
        filterPrefabs = {Prefab.getID("material.repair_tools")},
        features = InventoryFeatures.Collect
    }
}})
prefab:addPlacement({
    features = bit.bor(PlacementFeatures.Targetable, PlacementFeatures.Indestructible),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(4, 3),
            "ancient_device_primary-1"
        )}
    )}
})
prefab:addLight({
    intensity = 160,
    color = Color.new(158, 228, 255)
})
prefab:addEvent({
    interact = __TS__New(
        Event,
        function(player, entity)
            local ui
            if animator.isCurrentlyPlaying(entity, "interact_idle") then
                ui = UIManager.get("ending")
            else
                ui = UIManager.get("AncientComms")
            end
            ui:setEntity(entity)
            ui:show()
        end
    ),
    moved = __TS__New(
        Event,
        function(realm, entity)
            local collector = entity.collector
            collector:clearTiles()
            local area = entity.placement.axis.area
            collector:addTile(
                TileVector.new(area.x - 1, area.y + area.height - 1),
                TileDirection.Right
            )
            collector:addTile(
                TileVector.new(area.x + area.width, area.y + area.height - 1),
                TileDirection.Left
            )
        end
    )
})
return ____exports
