local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 2,["9"] = 2,["10"] = 3,["11"] = 3,["12"] = 8,["13"] = 10,["14"] = 12,["15"] = 16,["16"] = 18,["17"] = 20,["18"] = 25,["19"] = 29,["20"] = 31,["21"] = 31,["22"] = 31,["23"] = 31,["24"] = 31,["25"] = 31,["26"] = 29,["27"] = 35,["28"] = 40,["29"] = 40,["30"] = 42,["31"] = 43,["32"] = 43,["33"] = 43,["34"] = 43,["35"] = 43,["36"] = 43,["37"] = 40,["38"] = 40,["39"] = 47,["40"] = 47,["41"] = 47,["42"] = 47,["43"] = 52,["44"] = 53,["45"] = 53,["46"] = 53,["47"] = 54,["48"] = 55,["49"] = 56,["51"] = 58,["53"] = 60,["54"] = 61,["55"] = 53,["56"] = 52,["57"] = 63,["58"] = 63,["59"] = 63,["60"] = 64,["61"] = 65,["62"] = 66,["63"] = 67,["64"] = 67,["65"] = 67,["66"] = 67,["67"] = 69,["68"] = 70,["69"] = 71,["70"] = 72,["71"] = 73,["72"] = 74,["73"] = 74,["75"] = 63,["76"] = 52,["77"] = 52});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("ancient_device_tertiary")
prefab:addIllumination(1)
prefab:addAnimation({start = "idle", loop = true})
prefab:addCollector({reach = 0})
prefab:addInventory({inventories = {{
    name = "input-0",
    size = 1,
    collectStack = 1000,
    stackOverride = 1000,
    filterPrefabs = {Prefab.getID("material.technological_essence")},
    features = InventoryFeatures.Collect
}}})
prefab:addFluidSink({inputs = {FluidIO.new(FluidType.Aether, TileDirection.Right, 50000)}})
prefab:addPlacement({
    features = bit.bor(PlacementFeatures.Targetable, PlacementFeatures.Indestructible),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(4, 3),
            "ancient_device_tertiary-1"
        )}
    )}
})
prefab:addLight({
    intensity = 160,
    color = Color.new(158, 228, 255)
})
prefab:addEvent({
    interact = __TS__New(
        Event,
        function(player, entity)
            local ui
            if animator.isCurrentlyPlaying(entity, "interact_idle") then
                ui = UIManager.get("ending")
            else
                ui = UIManager.get("AncientComms")
            end
            ui:setEntity(entity)
            ui:show()
        end
    ),
    moved = __TS__New(
        Event,
        function(realm, entity)
            local collector = entity.collector
            collector:clearTiles()
            local area = entity.placement.axis.area
            collector:addTile(
                TileVector.new(area.x - 1, area.y + area.height - 1),
                TileDirection.Right
            )
            realm.fluid:removeSinkInputs(entity)
            local sink = entity.fluidSink
            local input = sink.inputs[1]
            input.position:set(area.x + area.width - 1, area.y + area.height - 1)
            input.direction = TileDirection.Left
            if realm ~= nil then
                realm.fluid:addSinkInputs(entity)
            end
        end
    )
})
return ____exports
