local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 2,["9"] = 2,["10"] = 3,["11"] = 3,["12"] = 4,["13"] = 4,["14"] = 6,["15"] = 8,["16"] = 10,["17"] = 14,["18"] = 16,["19"] = 18,["20"] = 23,["21"] = 28,["22"] = 28,["23"] = 30,["24"] = 31,["25"] = 31,["26"] = 31,["27"] = 31,["28"] = 31,["29"] = 31,["30"] = 31,["31"] = 30,["32"] = 32,["33"] = 32,["34"] = 32,["35"] = 32,["36"] = 32,["37"] = 32,["38"] = 32,["39"] = 32,["40"] = 30,["41"] = 33,["42"] = 33,["43"] = 33,["44"] = 33,["45"] = 33,["46"] = 33,["47"] = 33,["48"] = 33,["49"] = 30,["50"] = 34,["51"] = 34,["52"] = 34,["53"] = 34,["54"] = 34,["55"] = 34,["56"] = 34,["57"] = 34,["58"] = 30,["59"] = 28,["60"] = 28,["61"] = 38,["62"] = 38,["63"] = 38,["64"] = 38,["65"] = 43});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____utility = require("utility")
local interactTorch = ____utility.interactTorch
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("ancient_torch-1")
prefab:addIllumination(1)
prefab:addItem({icon = "icons_ancient_torch", stack = 99})
prefab:addAnimation({start = "running", loop = true})
prefab:addPlacement({
    drop = Prefab.getID("environment.ancient_torch"),
    axes = {
        PlacementAxis.new(
            PlacementAxisType.Floor,
            {PlacementDirection.new(
                FacingDirection.Right,
                TileVector.new(1, 1),
                "ancient_torch.running"
            )}
        ),
        PlacementAxis.new(
            PlacementAxisType.Backwall,
            {PlacementDirection.new(
                FacingDirection.Right,
                TileVector.new(1, 1),
                "ancient_torch.back_running"
            )},
            PixelVector.new(0, -8)
        ),
        PlacementAxis.new(
            PlacementAxisType.LeftWall,
            {PlacementDirection.new(
                FacingDirection.Left,
                TileVector.new(1, 1),
                "ancient_torch.left_running"
            )},
            PixelVector.new(0, -8)
        ),
        PlacementAxis.new(
            PlacementAxisType.RightWall,
            {PlacementDirection.new(
                FacingDirection.Right,
                TileVector.new(1, 1),
                "ancient_torch.right_running"
            )},
            PixelVector.new(0, -8)
        )
    }
})
prefab:addLight({
    intensity = 200,
    color = Color.new(100, 220, 255)
})
prefab:addEvent({interact = __TS__New(Event, interactTorch)})
return ____exports
