local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 2,["9"] = 2,["10"] = 3,["11"] = 3,["12"] = 4,["13"] = 4,["14"] = 5,["15"] = 5,["16"] = 7,["17"] = 8,["18"] = 10,["19"] = 12,["20"] = 16,["21"] = 20,["22"] = 22,["23"] = 22,["24"] = 22,["25"] = 22,["26"] = 27,["27"] = 31,["28"] = 32,["29"] = 33,["30"] = 33,["31"] = 33,["32"] = 33,["33"] = 33,["34"] = 33,["35"] = 33,["36"] = 33,["37"] = 33,["38"] = 32,["39"] = 34,["40"] = 34,["41"] = 34,["42"] = 34,["43"] = 34,["44"] = 34,["45"] = 34,["46"] = 34,["47"] = 34,["48"] = 32,["49"] = 31,["50"] = 31,["51"] = 31,["52"] = 31,["53"] = 31,["54"] = 31,["55"] = 42,["56"] = 42,["57"] = 42,["58"] = 45,["59"] = 46,["60"] = 46,["61"] = 46,["62"] = 46,["63"] = 46,["64"] = 46,["65"] = 42,["66"] = 42});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____Sizes = require("Sizes")
local Sizes = ____Sizes.Sizes
local ____utility = require("utility")
local harvestPlant = ____utility.harvestPlant
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addItem({icon = "fire_garnish_coolrock-1"})
prefab:addLocation({layer = LayerTypes.Back})
prefab:addRender("fire_garnish_coolrock-1", {layer = 5})
prefab:addIllumination(1)
prefab:addLight({
    intensity = 120,
    color = Color.new(255, 255, 180)
})
prefab:addEvent({harvest = __TS__New(Event, harvestPlant)})
prefab:addPlant({
    stages = {
        PlantStage.new(
            "fire_garnish_coolrock-1",
            -1,
            0,
            {{
                type = PlantHarvestTypes.Manual,
                loot = "rocks_small",
                time = seconds(5)
            }}
        ),
        PlantStage.new(
            "fire_garnish_coolrock-2",
            -1,
            0,
            {{
                type = PlantHarvestTypes.Manual,
                loot = "rocks_small",
                time = seconds(5)
            }}
        )
    },
    area = Vector.new(16, 16),
    variations = 1,
    life = 15,
    dropPosition = Vector.new(0, -Sizes.TILE)
})
prefab:addPlacement({
    supportTags = {"natural"},
    features = bit.bor(PlacementFeatures.TileOverlapable, PlacementFeatures.Targetable),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(3, 3),
            "fire_garnish_coolrock-1"
        )}
    )}
})
return ____exports
