local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 2,["9"] = 2,["10"] = 3,["11"] = 3,["12"] = 4,["13"] = 4,["14"] = 6,["15"] = 8,["16"] = 10,["17"] = 14,["18"] = 16,["19"] = 18,["20"] = 23,["21"] = 25,["22"] = 27,["23"] = 27,["24"] = 27,["25"] = 27,["26"] = 27,["27"] = 27,["28"] = 25,["29"] = 31,["30"] = 31,["31"] = 31,["32"] = 31,["33"] = 31,["34"] = 37,["35"] = 37,["36"] = 37,["37"] = 40,["38"] = 40,["39"] = 40,["40"] = 41,["41"] = 42,["42"] = 40,["43"] = 37,["44"] = 45,["45"] = 45,["46"] = 45,["47"] = 46,["48"] = 45,["49"] = 37,["50"] = 37,["51"] = 50,["52"] = 51,["53"] = 52,["54"] = 53,["55"] = 54,["56"] = 55,["57"] = 56,["59"] = 52,["60"] = 50});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____base = require("ui.base")
local showDialogWithInventory = ____base.showDialogWithInventory
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("mainframe_broken-1")
prefab:addIllumination(1)
prefab:addAnimation({start = "idle", loop = true})
prefab:addInventory({inventories = {{size = 5, collectSize = 5}}})
prefab:addPlacement({axes = {PlacementAxis.new(
    PlacementAxisType.Floor,
    {PlacementDirection.new(
        FacingDirection.Right,
        TileVector.new(2, 3),
        "mainframe_broken.idle"
    )}
)}})
prefab:addLight({
    intensity = 20,
    color = Color.new(225, 255, 240),
    needsExploration = false
})
prefab:addEvent({
    interactCursor = CursorType.Container,
    interactText = "ACTIVATE?",
    interact = __TS__New(
        Event,
        function(player, entity)
            audio.start("event:/APOTHEOS/APO_HOLOGRAM_OPEN", entity.transform.position)
            showDialogWithInventory(nil, "Container", entity)
        end
    ),
    withdraw = __TS__New(
        Event,
        function(player, entity)
            audio.start("event:/APOTHEOS/APO_HOLOGRAM_CLOSE", entity.transform.position)
        end
    )
})
prefab.onCreate:listen(function(entity)
    local entityID = entity.id
    entity.inventory.onChange:listen(function(name, index, item)
        local entity = EntityManager.get(entityID)
        local inventory = entity.inventory:get()
        if inventory:isEmpty() then
            animator.play(entity, "idle")
        end
    end)
end)
return ____exports
