local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 2,["9"] = 2,["10"] = 3,["11"] = 3,["12"] = 4,["13"] = 4,["14"] = 5,["15"] = 5,["16"] = 7,["17"] = 8,["18"] = 10,["19"] = 12,["20"] = 16,["21"] = 20,["22"] = 24,["23"] = 25,["24"] = 26,["25"] = 26,["26"] = 26,["27"] = 26,["28"] = 26,["29"] = 26,["30"] = 26,["31"] = 26,["32"] = 26,["33"] = 25,["34"] = 27,["35"] = 27,["36"] = 27,["37"] = 27,["38"] = 27,["39"] = 27,["40"] = 27,["41"] = 27,["42"] = 27,["43"] = 25,["44"] = 24,["45"] = 24,["46"] = 24,["47"] = 24,["48"] = 24,["49"] = 24,["50"] = 35,["51"] = 35,["52"] = 35,["53"] = 38,["54"] = 39,["55"] = 39,["56"] = 39,["57"] = 39,["58"] = 39,["59"] = 39,["60"] = 35,["61"] = 35});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____Sizes = require("Sizes")
local Sizes = ____Sizes.Sizes
local ____utility = require("utility")
local harvestPlant = ____utility.harvestPlant
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addItem({icon = "mana_garnish_rocks_1"})
prefab:addLocation({layer = LayerTypes.Back})
prefab:addRender("mana_garnish_rocks_1", {layer = 5})
prefab:addEvent({harvest = __TS__New(Event, harvestPlant)})
prefab:addPlant({
    stages = {
        PlantStage.new(
            "mana_garnish_rocks_1",
            -1,
            0,
            {{
                type = PlantHarvestTypes.Manual,
                loot = "rocks_small",
                time = seconds(5)
            }}
        ),
        PlantStage.new(
            "mana_garnish_rocks_2",
            -1,
            0,
            {{
                type = PlantHarvestTypes.Manual,
                loot = "rocks_small",
                time = seconds(5)
            }}
        )
    },
    area = Vector.new(16, 16),
    variations = 1,
    life = 12,
    dropPosition = Vector.new(0, -Sizes.TILE)
})
prefab:addPlacement({
    supportTags = {"natural"},
    features = bit.bor(PlacementFeatures.TileOverlapable, PlacementFeatures.Targetable),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(1, 1),
            "mana_garnish_rocks_1"
        )}
    )}
})
return ____exports
