local ____lualib = require("lualib_bundle")
local Map = ____lualib.Map
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 5,["16"] = 5,["17"] = 7,["18"] = 8,["19"] = 11,["20"] = 15,["21"] = 19,["22"] = 23,["23"] = 23,["24"] = 23,["25"] = 23,["26"] = 23,["27"] = 23,["28"] = 23,["29"] = 31,["30"] = 31,["31"] = 31,["32"] = 31,["33"] = 35,["34"] = 36,["35"] = 36,["36"] = 36,["37"] = 36,["38"] = 36,["39"] = 36,["40"] = 31,["41"] = 31});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____farming = require("farming")
local FarmingData = ____farming.FarmingData
local ____utility = require("utility")
local harvestPlant = ____utility.harvestPlant
local prefab = Prefab.getCurrent()
prefab:addTransform({origin = Vector.new(64, 160)})
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("burnt_tree", {layer = 5})
prefab:addEvent({harvest = __TS__New(Event, harvestPlant)})
prefab:addPlant({
    stages = FarmingData:get("Burnt Tree"),
    area = Vector.new(24, 24),
    variations = 4,
    life = 15,
    dropPosition = Vector.new(0, -32)
})
prefab:addPlacement({
    created = HashString("flora.burnt_tree"),
    supportTags = {"natural"},
    features = PlacementFeatures.Targetable,
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(1, 1),
            "burnt_tree-1"
        )}
    )}
})
return ____exports
