local ____lualib = require("lualib_bundle")
local Map = ____lualib.Map
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 4,["16"] = 4,["17"] = 5,["18"] = 5,["19"] = 7,["20"] = 8,["21"] = 12,["22"] = 16,["23"] = 20,["24"] = 24,["25"] = 24,["26"] = 24,["27"] = 24,["28"] = 24,["29"] = 24,["30"] = 24,["31"] = 24,["32"] = 24,["33"] = 34,["34"] = 34,["35"] = 34,["36"] = 34,["37"] = 38,["38"] = 39,["39"] = 39,["40"] = 39,["41"] = 39,["42"] = 39,["43"] = 39,["44"] = 34,["45"] = 34});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____farming = require("farming")
local FarmingData = ____farming.FarmingData
local FarmingFluids = ____farming.FarmingFluids
local FarmingRevives = ____farming.FarmingRevives
local ____utility = require("utility")
local harvestPlant = ____utility.harvestPlant
local prefab = Prefab.getCurrent()
prefab:addTransform({origin = Vector.new(24, 64)})
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("cedo_tree-1", {layer = 1})
prefab:addEvent({harvest = __TS__New(Event, harvestPlant)})
prefab:addPlant({
    stages = FarmingData:get("Cedo Tree"),
    fluids = FarmingFluids:get("Cedo Tree"),
    revives = FarmingRevives:get("Cedo Tree"),
    area = Vector.new(24, 24),
    variations = 1,
    life = 12,
    dropPosition = Vector.new(0, -32)
})
prefab:addPlacement({
    created = HashString("flora.cedo_tree"),
    supportTags = {"natural"},
    features = PlacementFeatures.Targetable,
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(1, 1),
            "cedo_tree-1"
        )}
    )}
})
return ____exports
