local ____lualib = require("lualib_bundle")
local Map = ____lualib.Map
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 5,["16"] = 5,["17"] = 5,["18"] = 5,["19"] = 6,["20"] = 6,["21"] = 8,["22"] = 9,["23"] = 13,["24"] = 19,["25"] = 23,["26"] = 25,["27"] = 29,["28"] = 29,["29"] = 29,["30"] = 29,["31"] = 29,["32"] = 29,["33"] = 29,["34"] = 29,["35"] = 29,["36"] = 39,["37"] = 39,["38"] = 39,["39"] = 39,["40"] = 43,["41"] = 44,["42"] = 44,["43"] = 44,["44"] = 44,["45"] = 44,["46"] = 44,["47"] = 39,["48"] = 39,["49"] = 48});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____matter = require("components.matter")
local MatterType = ____matter.MatterType
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____farming = require("farming")
local FarmingData = ____farming.FarmingData
local FarmingFluids = ____farming.FarmingFluids
local FarmingRevives = ____farming.FarmingRevives
local ____utility = require("utility")
local harvestPlant = ____utility.harvestPlant
local prefab = Prefab.getCurrent()
prefab:addTransform({origin = Vector.new(16, 32)})
prefab:addItem({icon = "icons_quartz", stack = 100, categories = {"seed", "mineral"}})
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("icons_quartz")
prefab:addEvent({harvest = __TS__New(Event, harvestPlant)})
prefab:addPlant({
    stages = FarmingData:get("Quartz"),
    fluids = FarmingFluids:get("Quartz"),
    revives = FarmingRevives:get("Quartz"),
    area = Vector.new(24, 24),
    variations = 3,
    life = 15,
    dropPosition = Vector.new(0, -32)
})
prefab:addPlacement({
    created = HashString("material.quartz"),
    supportTags = {"natural"},
    features = PlacementFeatures.None,
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(2, 2),
            "quartz-1"
        )}
    )}
})
prefab:addMatter({type = MatterType.Mineral, amount = 2})
return ____exports
