local ____lualib = require("lualib_bundle")
local Map = ____lualib.Map
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 4,["12"] = 6,["13"] = 10,["14"] = 14,["15"] = 16,["16"] = 18,["17"] = 23,["18"] = 23,["19"] = 23,["20"] = 23,["21"] = 23,["22"] = 23,["23"] = 23,["24"] = 23,["25"] = 32,["26"] = 33,["27"] = 33,["28"] = 34,["29"] = 34,["30"] = 34,["31"] = 33,["32"] = 35,["33"] = 35,["34"] = 35,["35"] = 33,["36"] = 36,["37"] = 36,["38"] = 36,["39"] = 33,["40"] = 33,["41"] = 32,["42"] = 40,["43"] = 44,["44"] = 44,["45"] = 41,["46"] = 64,["47"] = 64,["48"] = 64,["49"] = 64,["50"] = 64,["51"] = 62,["52"] = 72,["53"] = 72,["54"] = 72,["55"] = 72,["56"] = 72,["57"] = 72,["58"] = 72,["59"] = 72,["60"] = 72,["61"] = 72,["62"] = 72,["63"] = 72,["64"] = 72,["65"] = 72,["66"] = 72,["67"] = 72,["68"] = 62,["69"] = 92,["70"] = 92,["71"] = 92,["72"] = 92,["73"] = 92,["74"] = 92,["75"] = 92,["76"] = 92,["77"] = 92,["78"] = 62,["79"] = 100,["80"] = 100,["81"] = 62,["82"] = 101,["83"] = 101,["84"] = 101,["85"] = 101,["86"] = 101,["87"] = 41,["88"] = 110,["89"] = 110,["90"] = 110,["91"] = 110,["92"] = 110,["93"] = 110,["94"] = 108,["95"] = 115,["96"] = 115,["97"] = 115,["98"] = 115,["99"] = 115,["100"] = 115,["101"] = 115,["102"] = 115,["103"] = 115,["104"] = 115,["105"] = 115,["106"] = 115,["107"] = 115,["108"] = 115,["109"] = 115,["110"] = 108,["111"] = 130,["112"] = 130,["113"] = 40,["114"] = 135,["115"] = 135,["116"] = 135,["117"] = 135,["118"] = 135,["119"] = 135,["120"] = 135,["121"] = 143});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____Sizes = require("Sizes")
local Sizes = ____Sizes.Sizes
local prefab = Prefab.getCurrent()
prefab:addTransform({origin = Vector.new(24, 48)})
prefab:addLocation({layer = LayerTypes.Monster})
prefab:addRender("mycosiph", {layer = 1})
prefab:addIllumination(1)
prefab:addAnimation({start = "idle", loop = true})
prefab:addPhysics({
    offset = Vector.new(-10, -21),
    body = Rect.new(0, 0, 20, 20),
    layer = PhysicsLayers.MONSTER,
    filter = PhysicsLayers.GROUND,
    friction = 1,
    restitution = 0
})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(16, 99, 16)
        },
        {
            "ATK",
            Stat.new(1, 99)
        },
        {
            "DEF",
            Stat.new(1, 99)
        }
    }
)})
prefab:addBehavior({tree = BehaviorTree.new("mycosiph"):root(ReactiveSelectorNode.new("root"):add(SequenceNode.new("idle"):add(CanIdleNode.new("can_idle")):add(WaitNode.new(
    "idle_wait",
    seconds(2)
))):add(SequenceNode.new("create_block"):add(HasEntryNode.new("create_block_check", {entry = "createBlock"})):add(CreateBlockNode.new("create_block", {tile = "tile.soil", frequency = 500, amount = 1}))):add(SequenceNode.new("destroy_block"):add(HasEntryNode.new("destroy_block_check", {entry = "destroyBlock"})):add(DestroyBlockNode.new("destroy_block", {frequency = 1000, amount = 1}))):add(SequenceNode.new("pathing"):add(HasExpiredNode.new("wait_cooldown", {entry = "cooldown"})):add(FindTargetNode.new("find_target", {
    team = CombatTeamTarget.Enemy,
    distance = Sizes.SEGMENT,
    distanceWeight = 1,
    stickyWeight = 0.5,
    healthWeight = 0.3
})):add(PathToNode.new("path_to", {entry = "target"})):add(MoveToNode.new(
    "move",
    {
        movement = MovementType.WalkJump,
        acceleration = Vector.new(0.1, 0.45),
        speed = Vector.new(0.45, 5),
        acceptableRadius = Sizes.TILE * 2,
        liftTime = 100,
        jumpTime = 350,
        timeout = seconds(4),
        timeoutResult = BehaviorStatus.Failure,
        canCreateBlocks = true,
        canDestroyBlocks = true,
        moveSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_MOVE",
        jumpSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_JUMP",
        landSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_LAND"
    }
)):add(FaceEntityNode.new("face_target", {entry = "target"})):add(PlayAnimationNode.new("disperse_spores", {name = "attack"})):add(QueueAnimationNode.new("enjoy_spores", {name = "idle", loop = true})):add(WaitNode.new("spore_windup", 400)):add(FireProjectileNode.new(
    "fire_projectile",
    {
        prefab = "monster.mycosiph_spores",
        speed = 0,
        offset = Vector.new(-11, -16),
        lifetime = seconds(4),
        collidesWithGround = false,
        rotateToDestination = false
    }
)):add(WaitNode.new(
    "spore_wait",
    seconds(6)
)):add(SetEntryNode.new(
    "set_cooldown",
    {
        entry = "cooldown",
        timerValue = GameTimer.new(seconds(2))
    }
))):add(SequenceNode.new("wander"):add(PlayAnimationNode.new("play_idle", {name = "idle", loop = true})):add(PathRoamNode.new(
    "path_roam",
    {
        movement = MovementType.WalkJump,
        entry = "home",
        distance = FloatRange.new(0, Sizes.SEGMENT * 2)
    }
)):add(MoveToNode.new(
    "move_roam",
    {
        movement = MovementType.WalkJump,
        acceleration = Vector.new(0.1, 0.45),
        speed = Vector.new(0.45, 5),
        liftTime = 100,
        jumpTime = 450,
        timeout = seconds(5),
        acceptableRadius = Sizes.SUBTILE,
        horizontalOnly = true,
        timeoutResult = BehaviorStatus.Success,
        moveSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_MOVE",
        jumpSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_JUMP",
        landSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_LAND"
    }
)):add(PlayAnimationNode.new("play_idle", {name = "idle", loop = true})):add(WaitNode.new(
    "idle_wait",
    seconds(2)
))))})
prefab:addCombat({
    team = CombatTeam.Monster,
    loot = "mycosiph",
    fx = {"action_fx.otto_hit"},
    takeHitSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_TAKEHIT",
    deathSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_DEATH"
})
prefab:addLight({intensity = 65})
return ____exports
