local ____lualib = require("lualib_bundle")
local Map = ____lualib.Map
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 4,["12"] = 6,["13"] = 10,["14"] = 14,["15"] = 16,["16"] = 18,["17"] = 23,["18"] = 23,["19"] = 23,["20"] = 23,["21"] = 23,["22"] = 23,["23"] = 23,["24"] = 23,["25"] = 32,["26"] = 33,["27"] = 33,["28"] = 34,["29"] = 34,["30"] = 34,["31"] = 33,["32"] = 35,["33"] = 35,["34"] = 35,["35"] = 33,["36"] = 36,["37"] = 36,["38"] = 36,["39"] = 33,["40"] = 33,["41"] = 32,["42"] = 40,["43"] = 54,["44"] = 54,["45"] = 41,["46"] = 73,["47"] = 73,["48"] = 73,["49"] = 73,["50"] = 73,["51"] = 72,["52"] = 81,["53"] = 81,["54"] = 81,["55"] = 81,["56"] = 81,["57"] = 81,["58"] = 81,["59"] = 81,["60"] = 81,["61"] = 81,["62"] = 81,["63"] = 81,["64"] = 81,["65"] = 81,["66"] = 81,["67"] = 72,["68"] = 101,["69"] = 101,["70"] = 101,["71"] = 101,["72"] = 101,["73"] = 101,["74"] = 101,["75"] = 101,["76"] = 101,["77"] = 101,["78"] = 101,["79"] = 101,["80"] = 101,["81"] = 41,["82"] = 122,["83"] = 122,["84"] = 122,["85"] = 122,["86"] = 122,["87"] = 122,["88"] = 120,["89"] = 127,["90"] = 127,["91"] = 127,["92"] = 127,["93"] = 127,["94"] = 127,["95"] = 127,["96"] = 127,["97"] = 127,["98"] = 127,["99"] = 127,["100"] = 127,["101"] = 127,["102"] = 127,["103"] = 120,["104"] = 141,["105"] = 141,["106"] = 40,["107"] = 146,["108"] = 146,["109"] = 146,["110"] = 146,["111"] = 146,["112"] = 146,["113"] = 152,["114"] = 153,["115"] = 154,["116"] = 154,["117"] = 154,["118"] = 154,["119"] = 146,["120"] = 146,["121"] = 158,["122"] = 158,["123"] = 158,["124"] = 158});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____Sizes = require("Sizes")
local Sizes = ____Sizes.Sizes
local prefab = Prefab.getCurrent()
prefab:addTransform({origin = Vector.new(24, 48)})
prefab:addLocation({layer = LayerTypes.Monster})
prefab:addRender("sangoli", {layer = 1})
prefab:addIllumination(1)
prefab:addAnimation({start = "idle", loop = true})
prefab:addPhysics({
    offset = Vector.new(-12, -18),
    body = Rect.new(0, 0, 24, 20),
    layer = PhysicsLayers.MONSTER,
    filter = PhysicsLayers.GROUND,
    friction = 1,
    restitution = 0
})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(10, 99, 10)
        },
        {
            "ATK",
            Stat.new(3, 99)
        },
        {
            "DEF",
            Stat.new(1, 99)
        }
    }
)})
prefab:addBehavior({tree = BehaviorTree.new("sangoli"):root(ReactiveSelectorNode.new("root"):add(SequenceNode.new("idle"):add(CanIdleNode.new("can_idle")):add(WaitNode.new(
    "idle_wait",
    seconds(2)
))):add(SequenceNode.new("create_block"):add(HasEntryNode.new("create_block_check", {entry = "createBlock"})):add(CreateBlockNode.new("create_block", {tile = "tile.soil", frequency = 500, amount = 1}))):add(SequenceNode.new("destroy_block"):add(HasEntryNode.new("destroy_block_check", {entry = "destroyBlock"})):add(DestroyBlockNode.new("destroy_block", {frequency = 1000, amount = 1}))):add(SequenceNode.new("pathing"):add(FindTargetNode.new("find_target", {
    team = CombatTeamTarget.Enemy,
    distance = Sizes.SEGMENT,
    distanceWeight = 1,
    stickyWeight = 0.5,
    healthWeight = 0.3
})):add(PathToNode.new("path_to", {entry = "target"})):add(MoveToNode.new(
    "move",
    {
        movement = MovementType.WalkJump,
        acceleration = Vector.new(0.1, 0.45),
        speed = Vector.new(0.8, 5),
        acceptableRadius = Sizes.TILE * 8,
        jumpTime = 350,
        timeout = seconds(4),
        timeoutResult = BehaviorStatus.Failure,
        canCreateBlocks = true,
        canDestroyBlocks = true,
        moveSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_MOVE",
        jumpSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_JUMP",
        landSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_LAND"
    }
)):add(SetAttackingNode.new("attack_on", {value = true})):add(PlaySoundNode.new("play_attack_sound", {sound = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_ATTACK"})):add(PlayAnimationNode.new("play_attack", {name = "attack_enter", blocking = true})):add(PlayAnimationNode.new("attack_loop", {name = "attack_loop", loop = true})):add(ReactiveSequenceNode.new("attack_move"):add(PathToNode.new("path_to", {entry = "target"})):add(MoveToNode.new(
    "move",
    {
        movement = MovementType.Walk,
        animation = "attack_loop",
        acceleration = Vector.new(0.2, 0.45),
        speed = Vector.new(4, 5),
        acceptableRadius = Sizes.SUBTILE,
        timeout = seconds(2.5),
        timeoutResult = BehaviorStatus.Success,
        moveSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_MOVE",
        jumpSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_JUMP",
        landSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_LAND"
    }
))):add(SetAttackingNode.new("attack_off", {value = false})):add(PlayAnimationNode.new("play_attack_exit", {name = "attack_exit", loop = false})):add(QueueAnimationNode.new("queue_idle", {name = "idle", loop = true}))):add(SequenceNode.new("wander"):add(PlayAnimationNode.new("play_idle", {name = "idle", loop = true})):add(PathRoamNode.new(
    "path_roam",
    {
        movement = MovementType.WalkJump,
        entry = "home",
        distance = FloatRange.new(0, Sizes.SEGMENT * 2)
    }
)):add(MoveToNode.new(
    "move_roam",
    {
        movement = MovementType.WalkJump,
        acceleration = Vector.new(0.1, 0.45),
        speed = Vector.new(0.7, 5),
        jumpTime = 350,
        timeout = seconds(5),
        acceptableRadius = Sizes.SUBTILE,
        horizontalOnly = true,
        timeoutResult = BehaviorStatus.Success,
        moveSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_MOVE",
        jumpSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_JUMP",
        landSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_LAND"
    }
)):add(PlayAnimationNode.new("play_idle", {name = "idle", loop = true})):add(WaitNode.new(
    "idle_wait",
    seconds(10)
))))})
prefab:addCombat({
    team = CombatTeam.Monster,
    loot = "sangoli",
    fx = {"action_fx.otto_hit"},
    takeHitSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_TAKEHIT",
    deathSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_DEATH",
    onDefend = function(____, attacker, defender)
        local data = defender.behavior.data
        data:setTimer(
            "attackTimer",
            GameTimer.new(seconds(20))
        )
    end
})
prefab:addLight({
    intensity = 120,
    color = Color.new(255, 177, 87)
})
return ____exports
