local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 2,["9"] = 2,["10"] = 3,["11"] = 3,["12"] = 4,["13"] = 4,["14"] = 6,["15"] = 8,["16"] = 10,["17"] = 14,["18"] = 16,["19"] = 20,["20"] = 20,["21"] = 22,["22"] = 23,["23"] = 23,["24"] = 23,["25"] = 23,["26"] = 23,["27"] = 23,["28"] = 20,["29"] = 20,["30"] = 27,["31"] = 28,["32"] = 28,["33"] = 28,["34"] = 27,["35"] = 33,["36"] = 34,["37"] = 34,["38"] = 35,["41"] = 39,["42"] = 40,["43"] = 41,["44"] = 42,["45"] = 43,["46"] = 44,["47"] = 45,["48"] = 46,["49"] = 47,["50"] = 47,["51"] = 47,["52"] = 48,["53"] = 49,["54"] = 47,["55"] = 47,["56"] = 51,["57"] = 52,["58"] = 53,["59"] = 54,["60"] = 55,["61"] = 55,["62"] = 55,["63"] = 56,["64"] = 57,["65"] = 58,["66"] = 59,["67"] = 59,["68"] = 59,["69"] = 60,["70"] = 59,["71"] = 59,["72"] = 55,["73"] = 55,["75"] = 34,["76"] = 33});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____scheduler = require("systems.scheduler")
local scheduler = ____scheduler.scheduler
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("sehren")
prefab:addAnimation({start = "idle"})
prefab:addPlacement({
    features = PlacementFeatures.Targetable,
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(2, 2),
            "sehren.idle"
        )}
    )}
})
local npc = prefab:addNpc({onStateChange = __TS__New(
    Event,
    function(entity, state, previous)
    end
)})
prefab:addEvent({interact = __TS__New(
    Event,
    function(player, entity)
        if UIManager.getDialogue("sehren") ~= nil then
            return
        end
        local npc = entity.npc
        local dialogue = UIManager.createDialogue("sehren")
        local position = entity.render.center:asPixelVector()
        position.y = position.y + -32
        dialogue:setPosition(position)
        dialogue:open()
        if npc.state == 0 then
            dialogue:showText("Yes, come in. I was expecting...[.500]\nWho the [!][#d46e7f]CAW[/#][/!] are you!?", false)
            scheduler:add(
                seconds(7),
                function()
                    UIManager.removeDialogue("sehren")
                    npc.state = 1
                end
            )
        elseif npc.state == 1 then
            animator.play(entity, "fortune_in")
            animator.queue(entity, "fortune", true)
            dialogue:showText("Now, Let's see what MY future holds...", false)
            scheduler:add(
                seconds(7),
                function()
                    animator.play(entity, "fortune_out")
                    animator.queue(entity, "idle", true)
                    dialogue:showText("Hmmm, it appears I'll have more interesting things to say than this...", false)
                    scheduler:add(
                        seconds(8),
                        function()
                            UIManager.removeDialogue("sehren")
                        end
                    )
                end
            )
        end
    end
)})
return ____exports
