local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 2,["9"] = 2,["10"] = 3,["11"] = 3,["12"] = 4,["13"] = 4,["14"] = 5,["15"] = 5,["16"] = 7,["17"] = 9,["18"] = 11,["19"] = 15,["20"] = 17,["21"] = 19,["22"] = 23,["23"] = 28,["24"] = 30,["25"] = 30,["26"] = 33,["27"] = 33,["28"] = 33,["29"] = 33,["30"] = 33,["31"] = 33,["32"] = 30,["33"] = 28,["34"] = 38,["35"] = 40,["36"] = 40,["37"] = 40,["38"] = 43,["39"] = 44,["40"] = 44,["41"] = 44,["42"] = 44,["43"] = 44,["44"] = 44,["45"] = 40,["46"] = 40,["47"] = 49,["48"] = 49,["49"] = 49,["50"] = 52,["51"] = 52,["52"] = 52,["53"] = 53,["54"] = 54,["55"] = 55,["56"] = 56,["57"] = 57,["58"] = 52,["59"] = 49,["60"] = 60,["61"] = 60,["62"] = 60,["63"] = 61,["64"] = 62,["65"] = 63,["66"] = 60,["67"] = 49,["68"] = 49,["69"] = 67});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____loot = require("systems.loot")
local LootSystem = ____loot.LootSystem
local ____base = require("ui.base")
local showDialogWithInventory = ____base.showDialogWithInventory
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("ancient_chest-1")
prefab:addIllumination(1)
prefab:addAnimation({start = "idle"})
prefab:addItem({icon = "icons_ancient_chest", stack = 10})
prefab:addInventory({inventories = {{
    size = 20,
    collectSize = 20,
    features = bit.bor(
        bit.bor(
            bit.bor(InventoryFeatures.Collect, InventoryFeatures.Dispense),
            InventoryFeatures.Withdraw
        ),
        InventoryFeatures.Deposit
    )
}}})
prefab:addLoot()
prefab:addPlacement({
    drop = Prefab.getID("structure.ancient_chest"),
    features = bit.bor(PlacementFeatures.Default, PlacementFeatures.ScaffoldingSupport),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(1, 1),
            "ancient_chest-1"
        )}
    )}
})
prefab:addEvent({
    interactCursor = CursorType.Container,
    interactText = "OPEN",
    interact = __TS__New(
        Event,
        function(player, entity)
            LootSystem:populateLoot(entity)
            animator.play(entity, "open", false)
            animator.queue(entity, "running")
            audio.start("event:/GENERAL/CHEST_OPEN", entity.transform.position)
            showDialogWithInventory(nil, "Container", entity)
        end
    ),
    withdraw = __TS__New(
        Event,
        function(player, entity)
            animator.play(entity, "close", false)
            animator.queue(entity, "idle")
            audio.start("event:/GENERAL/CHEST_CLOSE", entity.transform.position)
        end
    )
})
prefab:addLight({intensity = 60})
return ____exports
