local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 2,["9"] = 2,["10"] = 3,["11"] = 3,["12"] = 8,["13"] = 10,["14"] = 12,["15"] = 16,["16"] = 18,["17"] = 20,["18"] = 25,["19"] = 29,["20"] = 31,["21"] = 31,["22"] = 31,["23"] = 31,["24"] = 31,["25"] = 29,["26"] = 35,["27"] = 40,["28"] = 40,["29"] = 42,["30"] = 43,["31"] = 43,["32"] = 43,["33"] = 43,["34"] = 43,["35"] = 43,["36"] = 40,["37"] = 40,["38"] = 47,["39"] = 47,["40"] = 47,["41"] = 47,["42"] = 52,["43"] = 53,["44"] = 53,["45"] = 53,["46"] = 54,["47"] = 55,["48"] = 56,["50"] = 58,["52"] = 60,["53"] = 61,["54"] = 53,["55"] = 52,["56"] = 63,["57"] = 63,["58"] = 63,["59"] = 64,["60"] = 65,["61"] = 66,["62"] = 67,["63"] = 67,["64"] = 67,["65"] = 67,["66"] = 69,["67"] = 70,["68"] = 71,["69"] = 72,["70"] = 73,["71"] = 74,["72"] = 74,["74"] = 63,["75"] = 52,["76"] = 52});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("ancient_device_tertiary")
prefab:addIllumination(1)
prefab:addAnimation({start = "idle", loop = true})
prefab:addCollector({reach = 0})
prefab:addInventory({inventories = {{
    name = "input-cermet",
    size = 1,
    collectStack = 500,
    stackOverride = 500,
    filterPrefabs = {Prefab.getID("material.technological_essence")}
}}})
prefab:addFluidSink({inputs = {FluidIO.new(FluidType.Aether, TileDirection.Right, 10000)}})
prefab:addPlacement({
    features = bit.bor(PlacementFeatures.Targetable, PlacementFeatures.Indestructible),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(4, 3),
            "ancient_device_tertiary-1"
        )}
    )}
})
prefab:addLight({
    intensity = 160,
    color = Color.new(158, 228, 255)
})
prefab:addEvent({
    interact = __TS__New(
        Event,
        function(player, entity)
            local ui
            if animator.isCurrentlyPlaying(entity, "interact_idle") then
                ui = UIManager.get("ending")
            else
                ui = UIManager.get("AncientComms")
            end
            ui:setEntity(entity)
            ui:show()
        end
    ),
    moved = __TS__New(
        Event,
        function(realm, entity)
            local collector = entity.collector
            collector:clearTiles()
            local area = entity.placement.axis.area
            collector:addTile(
                TileVector.new(area.x - 1, area.y + area.height - 1),
                TileDirection.Right
            )
            realm.fluid:removeSinkInputs(entity)
            local sink = entity.fluidSink
            local input = sink.inputs[1]
            input.position:set(area.x + area.width, area.y + area.height - 1)
            input.direction = TileDirection.Left
            if realm ~= nil then
                realm.fluid:addSinkInputs(entity)
            end
        end
    )
})
return ____exports
