local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 5,["16"] = 5,["17"] = 6,["18"] = 6,["19"] = 9,["20"] = 11,["21"] = 13,["22"] = 17,["23"] = 22,["24"] = 24,["25"] = 30,["26"] = 32,["27"] = 32,["28"] = 32,["29"] = 32,["30"] = 32,["31"] = 32,["32"] = 32,["33"] = 30,["34"] = 36,["35"] = 40,["36"] = 40,["37"] = 42,["38"] = 42,["39"] = 42,["40"] = 40,["41"] = 43,["42"] = 44,["43"] = 44,["44"] = 45,["45"] = 45,["46"] = 45,["47"] = 45,["48"] = 44,["49"] = 46,["50"] = 46,["51"] = 46,["52"] = 46,["53"] = 44,["54"] = 47,["55"] = 47,["56"] = 47,["57"] = 47,["58"] = 44,["59"] = 48,["60"] = 48,["61"] = 48,["62"] = 48,["63"] = 44,["64"] = 44,["65"] = 40,["66"] = 40,["67"] = 53,["68"] = 55,["69"] = 56,["70"] = 56,["71"] = 56,["72"] = 57,["73"] = 56,["74"] = 55,["75"] = 59,["76"] = 59,["77"] = 59,["78"] = 60,["79"] = 59,["80"] = 55,["81"] = 55,["82"] = 64,["83"] = 69,["84"] = 69,["85"] = 69,["86"] = 72,["87"] = 73,["90"] = 75,["91"] = 76,["92"] = 77,["93"] = 78,["94"] = 79,["95"] = 80,["97"] = 82,["98"] = 83,["99"] = 84,["101"] = 69,["102"] = 69,["103"] = 89,["104"] = 90,["105"] = 90,["106"] = 91,["107"] = 91,["108"] = 91,["109"] = 90,["110"] = 92,["111"] = 92,["112"] = 92,["113"] = 90,["114"] = 93,["115"] = 93,["116"] = 93,["117"] = 90,["118"] = 90,["119"] = 89,["120"] = 97,["121"] = 103});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____world = require("world")
local World = ____world.World
local ____base = require("ui.base")
local showDialogWithInventory = ____base.showDialogWithInventory
local ____utility = require("utility")
local breakItem = ____utility.breakItem
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addItem({icon = "icons_collector", stack = 20})
prefab:addRender("collector_right-1")
prefab:addAnimation({association = "collector_right", start = "idle", loop = true})
prefab:addInventory({inventories = {{
    name = "output",
    size = 10,
    stackOverride = 1,
    features = bit.bor(
        bit.bor(InventoryFeatures.Collect, InventoryFeatures.Dispense),
        InventoryFeatures.Withdraw
    )
}}})
prefab:addGatherer({range = 0})
prefab:addPlacement({
    drop = Prefab.getID("structure.collector"),
    features = bit.bor(
        bit.bor(PlacementFeatures.Default, PlacementFeatures.NoSupportBackwall),
        PlacementFeatures.Pivotable
    ),
    axes = {PlacementAxis.new(
        PlacementAxisType.Backwall,
        {
            PlacementDirection.new(
                FacingDirection.Up,
                TileVector.new(3, 1),
                "collector_up.idle"
            ),
            PlacementDirection.new(
                FacingDirection.Right,
                TileVector.new(1, 3),
                "collector_right.idle"
            ),
            PlacementDirection.new(
                FacingDirection.Down,
                TileVector.new(3, 1),
                "collector_down.idle"
            ),
            PlacementDirection.new(
                FacingDirection.Left,
                TileVector.new(1, 3),
                "collector_left.idle"
            )
        }
    )}
})
local DIRECTION_ASSOCIATION = {"collector_up", "collector_right", "collector_down", "collector_left"}
prefab:addEvent({
    interact = __TS__New(
        Event,
        function(player, entity)
            showDialogWithInventory(nil, "Container", entity)
        end
    ),
    placed = __TS__New(
        Event,
        function(entity)
            animator.setAssociation(entity, DIRECTION_ASSOCIATION[entity.placement.direction + 1])
        end
    )
})
prefab:addDispenser({frequency = 500, isEnabled = true})
prefab:addConsumer({
    idlePower = 4,
    activePower = 20,
    onStateChange = function(entityID, state, flag)
        if flag ~= ConsumerState.Powered then
            return
        end
        local entity = EntityManager.get(entityID)
        local realm = World:get(entity.location.realm)
        if bit.band(state, ConsumerState.Powered) == ConsumerState.Powered then
            animator.tryPlay(entity, "running", true)
            entity.gatherer.range = 128
            realm.dropped:addGatherer(entity)
        else
            animator.tryPlay(entity, "idle", true)
            entity.gatherer.range = 0
            realm.dropped:removeGatherer(entity)
        end
    end
})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(30, 99, 30)
        },
        {
            "DEF",
            Stat.new(1, 99, 1)
        },
        {
            "owner",
            Stat.new(0, 999999)
        }
    }
)})
prefab:addCombat({team = CombatTeam.Structure, destroyOnDeath = false, onDeath = breakItem})
prefab:addOverlay()
return ____exports
