local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 6,["16"] = 6,["17"] = 7,["18"] = 7,["19"] = 10,["20"] = 12,["21"] = 14,["22"] = 14,["23"] = 14,["24"] = 14,["25"] = 14,["26"] = 14,["27"] = 14,["28"] = 14,["29"] = 23,["30"] = 24,["31"] = 25,["32"] = 26,["33"] = 27,["34"] = 28,["35"] = 29,["36"] = 30,["37"] = 30,["38"] = 30,["39"] = 30,["40"] = 30,["42"] = 25,["43"] = 23,["44"] = 35,["45"] = 39,["46"] = 43,["47"] = 48,["48"] = 50,["49"] = 52,["50"] = 57,["51"] = 61,["52"] = 61,["53"] = 63,["54"] = 64,["55"] = 64,["56"] = 64,["57"] = 64,["58"] = 64,["59"] = 64,["60"] = 61,["61"] = 61,["62"] = 68,["63"] = 69,["64"] = 69,["65"] = 69,["66"] = 70,["67"] = 69,["68"] = 68,["69"] = 72,["70"] = 72,["71"] = 72,["72"] = 73,["73"] = 74,["74"] = 75,["75"] = 76,["76"] = 77,["78"] = 72,["79"] = 68,["80"] = 68,["81"] = 82,["82"] = 82,["83"] = 82,["84"] = 82,["85"] = 87,["86"] = 87,["87"] = 87,["88"] = 87,["89"] = 91,["90"] = 92,["93"] = 94,["94"] = 95,["95"] = 96,["96"] = 97,["97"] = 98,["98"] = 99,["100"] = 101,["101"] = 102,["102"] = 103,["103"] = 104,["105"] = 87,["106"] = 87,["107"] = 109,["108"] = 115,["109"] = 121,["110"] = 122,["111"] = 122,["112"] = 123,["113"] = 123,["114"] = 123,["115"] = 122,["116"] = 124,["117"] = 124,["118"] = 124,["119"] = 122,["120"] = 125,["121"] = 125,["122"] = 125,["123"] = 122,["124"] = 126,["125"] = 126,["126"] = 126,["127"] = 122,["128"] = 122,["129"] = 121,["130"] = 130,["131"] = 137,["132"] = 141,["133"] = 141,["134"] = 143,["135"] = 144,["136"] = 145,["138"] = 147,["140"] = 141,["141"] = 141});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____mechanical = require("components.mechanical")
local MechanicalNodeType = ____mechanical.MechanicalNodeType
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____base = require("ui.base")
local showModularDialog = ____base.showModularDialog
local ____utility = require("utility")
local breakItem = ____utility.breakItem
local prefab = Prefab.getCurrent()
prefab:addTransform()
local ANIMATIONS = {
    "idle",
    "running_20",
    "running_40",
    "running_60",
    "running_80",
    "running_100"
}
prefab.onCreate:listen(function(entity)
    local entityID = entity.id
    entity.stats:get("NRG").onChangeCurrent:listen(function(stat, previous, value)
        previous = math.ceil(previous / stat:get() / 0.2)
        value = math.ceil(value / stat:get() / 0.2)
        if previous ~= value then
            local entity = EntityManager.get(entityID)
            animator.play(
                entity,
                ANIMATIONS[math.min(value, 5) + 1],
                true
            )
        end
    end)
end)
prefab:addLocation({layer = LayerTypes.Item})
prefab:addInventory({inventories = {}})
prefab:addItem({icon = "icons_crank_generator", stack = 20})
prefab:addRender("crank_generator-1")
prefab:addIllumination(1)
prefab:addAnimation({start = "idle", loop = true})
prefab:addAmbience({sfx = "event:/FABRICATORS/CRANK_GENERATOR_LOOP"})
prefab:addPlacement({
    drop = Prefab.getID("structure.crank_generator"),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(2, 2),
            "crank_generator.idle"
        )}
    )}
})
prefab:addEvent({
    interact = __TS__New(
        Event,
        function(player, entity)
            showModularDialog(nil, "CrankGenerator", entity)
        end
    ),
    cranked = __TS__New(
        Event,
        function(player, entity)
            local nrg = entity.stats:get("NRG")
            local wasEmpty = nrg:getCurrent() == 0
            nrg:adjustCurrent(nrg:get() * 0.01)
            if wasEmpty then
                entity.consumer:addState(ConsumerState.Powered)
            end
        end
    )
})
prefab:addLight({
    intensity = 150,
    color = Color.new(100, 220, 255)
})
prefab:addConsumer({
    isAutonomous = true,
    idlePower = 20,
    activePower = 20,
    onStateChange = function(entityID, state, flag)
        if flag ~= ConsumerState.Powered then
            return
        end
        local entity = EntityManager.get(entityID)
        local producer = entity.producer
        if bit.band(state, ConsumerState.Powered) == ConsumerState.Powered then
            entity.consumer:addState(ConsumerState.Running)
            producer.generate = producer.throughput
            entity.ambience.event:start()
        else
            entity.consumer:removeState(ConsumerState.Running)
            animator.tryPlay(entity, "idle", true)
            producer.generate = 0
            entity.ambience.event:stop(FMODStopMode.FMOD_STUDIO_STOP_ALLOWFADEOUT)
        end
    end
})
prefab:addDistributor({area = 0, range = 0, animate = false})
prefab:addProducer({generate = 0, throughput = 100, capacity = 0})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(30, 99, 30)
        },
        {
            "DEF",
            Stat.new(1, 99, 1)
        },
        {
            "NRG",
            Stat.new(10000, 10000, 0)
        },
        {
            "owner",
            Stat.new(0, 999999)
        }
    }
)})
prefab:addCombat({team = CombatTeam.Structure, priority = CombatPriority.High, destroyOnDeath = false, onDeath = breakItem})
prefab:addOverlay({noPowerIndicator = atlases.get("autoforge_window_no_crank")})
prefab:addMechanical({
    inputs = {MechanicalNodeType.Basic},
    onReceive = function(____, mechanical, output, input, connection)
        if connection.signal.strength == 1 then
            input.consumer:addState(ConsumerState.On)
        else
            input.consumer:removeState(ConsumerState.On)
        end
    end
})
return ____exports
