local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 5,["16"] = 5,["17"] = 6,["18"] = 6,["19"] = 9,["20"] = 11,["21"] = 13,["22"] = 17,["23"] = 22,["24"] = 24,["25"] = 26,["26"] = 31,["27"] = 35,["28"] = 37,["29"] = 37,["30"] = 37,["31"] = 37,["32"] = 37,["33"] = 37,["34"] = 37,["35"] = 37,["36"] = 37,["37"] = 36,["38"] = 38,["39"] = 38,["40"] = 38,["41"] = 38,["42"] = 38,["43"] = 38,["44"] = 38,["45"] = 38,["46"] = 38,["47"] = 36,["48"] = 39,["49"] = 39,["50"] = 39,["51"] = 39,["52"] = 39,["53"] = 39,["54"] = 39,["55"] = 39,["56"] = 39,["57"] = 36,["58"] = 40,["59"] = 40,["60"] = 40,["61"] = 40,["62"] = 40,["63"] = 40,["64"] = 40,["65"] = 40,["66"] = 36,["67"] = 35,["68"] = 44,["69"] = 48,["70"] = 48,["71"] = 50,["72"] = 50,["73"] = 50,["74"] = 48,["75"] = 51,["76"] = 52,["77"] = 52,["78"] = 53,["79"] = 53,["80"] = 53,["81"] = 52,["82"] = 48,["83"] = 48,["84"] = 58,["85"] = 58,["86"] = 60,["87"] = 60,["88"] = 60,["89"] = 61,["90"] = 60,["91"] = 58,["92"] = 58,["93"] = 65,["94"] = 65,["95"] = 65,["96"] = 65,["97"] = 70,["98"] = 76,["99"] = 81,["100"] = 85,["101"] = 86,["102"] = 86,["103"] = 87,["104"] = 87,["105"] = 87,["106"] = 86,["107"] = 88,["108"] = 88,["109"] = 88,["110"] = 86,["111"] = 89,["112"] = 89,["113"] = 89,["114"] = 86,["115"] = 90,["116"] = 90,["117"] = 90,["118"] = 86,["119"] = 86,["120"] = 85,["121"] = 94,["122"] = 100});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____craft = require("craft")
local CraftSite = ____craft.CraftSite
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local ____utility = require("utility")
local breakItem = ____utility.breakItem
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addItem({icon = "icons_forge", stack = 20})
prefab:addRender("forge-1")
prefab:addIllumination(1)
prefab:addAnimation({start = "idle", loop = true})
prefab:addAmbience({sfx = "event:/GENERAL/FORGE_ACTIVE_LOOP"})
prefab:addInventory({inventories = {
    {
        name = "fuel",
        size = 1,
        filterCategories = {"biofuel"},
        collectStack = 5,
        features = bit.bor(
            bit.bor(InventoryFeatures.Collect, InventoryFeatures.Deposit),
            InventoryFeatures.Withdraw
        )
    },
    {
        name = "input-0",
        size = 1,
        filterCategories = {"smeltable"},
        collectStack = 1,
        features = bit.bor(
            bit.bor(InventoryFeatures.Collect, InventoryFeatures.Deposit),
            InventoryFeatures.Withdraw
        )
    },
    {
        name = "input-1",
        size = 1,
        filterPrefabs = {INVALID_ENTITYID},
        collectStack = 1,
        features = bit.bor(
            bit.bor(InventoryFeatures.Collect, InventoryFeatures.Deposit),
            InventoryFeatures.Withdraw
        )
    },
    {
        name = "output",
        size = 1,
        filterPrefabs = {INVALID_ENTITYID},
        features = bit.bor(
            bit.bor(InventoryFeatures.Dispense, InventoryFeatures.Withdraw),
            InventoryFeatures.RecipeFlush
        )
    }
}})
prefab:addCollector({reach = 2})
prefab:addPlacement({
    drop = Prefab.getID("structure.forge"),
    features = bit.bor(
        bit.bor(PlacementFeatures.Default, PlacementFeatures.Pivotable),
        PlacementFeatures.ScaffoldingSupport
    ),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(2, 2),
            "forge-1"
        )}
    )}
})
prefab:addEvent({
    recipeChange = __TS__New(Event),
    interact = __TS__New(
        Event,
        function(player, entity)
            showModularDialogWithInventory(nil, "CombustFabricator", entity)
        end
    )
})
prefab:addLight({
    intensity = 120,
    color = Color.new(255, 220, 140)
})
prefab:addFabricator({speed = 1, site = CraftSite.Forge, autoSelectRecipe = true})
prefab:addDispenser({frequency = 500, isEnabled = true})
prefab:addOverlay({noPowerIndicator = atlases.get("autoforge_window_no_fuel")})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(30, 99, 30)
        },
        {
            "DEF",
            Stat.new(1, 99, 1)
        },
        {
            "NRG",
            Stat.new(1, 999999999, 0)
        },
        {
            "owner",
            Stat.new(0, 999999)
        }
    }
)})
prefab:addCombat({team = CombatTeam.Structure, destroyOnDeath = false, onDeath = breakItem})
prefab:addConsumer({isAutonomous = true, idlePower = 0, activePower = 5})
return ____exports
