local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 3,["14"] = 4,["15"] = 4,["16"] = 5,["17"] = 5,["18"] = 6,["19"] = 6,["20"] = 7,["21"] = 7,["22"] = 10,["23"] = 12,["24"] = 14,["25"] = 18,["26"] = 23,["27"] = 27,["28"] = 32,["29"] = 34,["30"] = 34,["31"] = 34,["32"] = 34,["33"] = 34,["34"] = 34,["35"] = 33,["36"] = 35,["37"] = 35,["38"] = 35,["39"] = 35,["40"] = 35,["41"] = 35,["42"] = 35,["43"] = 35,["44"] = 35,["45"] = 35,["46"] = 35,["47"] = 35,["48"] = 35,["49"] = 33,["50"] = 36,["51"] = 36,["52"] = 36,["53"] = 36,["54"] = 36,["55"] = 36,["56"] = 36,["57"] = 36,["58"] = 36,["59"] = 36,["60"] = 36,["61"] = 36,["62"] = 36,["63"] = 33,["64"] = 37,["65"] = 37,["66"] = 37,["67"] = 37,["68"] = 37,["69"] = 33,["70"] = 32,["71"] = 41,["72"] = 45,["73"] = 45,["74"] = 45,["75"] = 48,["76"] = 49,["77"] = 49,["78"] = 50,["79"] = 50,["80"] = 50,["81"] = 49,["82"] = 45,["83"] = 45,["84"] = 55,["85"] = 56,["86"] = 56,["87"] = 56,["88"] = 56,["89"] = 56,["90"] = 56,["91"] = 56,["92"] = 58,["93"] = 59,["94"] = 60,["95"] = 61,["96"] = 58,["97"] = 64,["98"] = 65,["99"] = 65,["100"] = 65,["101"] = 66,["102"] = 65,["103"] = 64,["104"] = 68,["105"] = 68,["106"] = 68,["107"] = 69,["108"] = 70,["109"] = 71,["110"] = 72,["111"] = 68,["112"] = 64,["113"] = 74,["114"] = 74,["115"] = 74,["116"] = 75,["117"] = 74,["118"] = 64,["119"] = 64,["120"] = 79,["121"] = 84,["122"] = 86,["123"] = 87,["124"] = 87,["125"] = 88,["126"] = 88,["127"] = 87,["128"] = 86,["129"] = 92,["130"] = 92,["131"] = 92,["132"] = 92,["133"] = 97,["134"] = 97,["135"] = 97,["136"] = 97,["137"] = 102,["138"] = 104,["139"] = 109,["140"] = 110,["141"] = 111,["142"] = 112,["143"] = 113,["144"] = 114,["145"] = 115,["146"] = 115,["147"] = 115,["148"] = 115,["149"] = 115,["150"] = 111,["151"] = 109});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local GameEvents = ____event.GameEvents
local ____Sizes = require("Sizes")
local Sizes = ____Sizes.Sizes
local ____placement = require("utility.placement")
local placementRotate = ____placement.placementRotate
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local ____world = require("world")
local World = ____world.World
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addItem({icon = "icons_irrigated_plant_support", stack = 20})
prefab:addRender("irrigated_plant_support_left_water-1", {layer = 0})
prefab:addAnimation({association = "irrigated_plant_support_left_water", start = "0"})
prefab:addInventory({inventories = {
    {
        name = "fuel",
        size = 1,
        collectStack = 4,
        stackOverride = 20,
        filterCategories = {"fertilizer"}
    },
    {
        name = "seed",
        size = 1,
        collectStack = 1,
        stackOverride = 1,
        filterCategories = {"seed"},
        features = bit.bor(
            bit.bor(
                bit.bor(InventoryFeatures.Collect, InventoryFeatures.Deposit),
                InventoryFeatures.Unsortable
            ),
            InventoryFeatures.Discard
        )
    },
    {
        name = "tool",
        size = 1,
        collectStack = 1,
        stackOverride = 1,
        filterPrefabs = {INVALID_ENTITYID},
        features = bit.bor(
            bit.bor(
                bit.bor(InventoryFeatures.Collect, InventoryFeatures.Deposit),
                InventoryFeatures.Unsortable
            ),
            InventoryFeatures.Discard
        )
    },
    {
        name = "output",
        size = 4,
        filterPrefabs = {INVALID_ENTITYID},
        features = bit.bor(InventoryFeatures.Dispense, InventoryFeatures.Withdraw)
    }
}})
prefab:addCollector({reach = 3})
prefab:addPlacement({
    drop = Prefab.getID("structure.irrigated_plant_support"),
    features = bit.bor(PlacementFeatures.Default, PlacementFeatures.Pivotable),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(3, 5),
            "irrigated_plant_support_left_water-1"
        )}
    )}
})
local DIRECTION_STRINGS = {"left", "left", "right", "right"}
local FLUID_STRINGS = {
    "water",
    "water",
    "lava",
    "miasma",
    "aether"
}
local function updateAssocation(self, entity)
    local fluid = FLUID_STRINGS[entity.fluidSource.outputs[1].type + 1]
    local direction = DIRECTION_STRINGS[entity.placement.direction + 1]
    animator.setAssociation(entity, (("irrigated_plant_support_" .. direction) .. "_") .. fluid)
end
prefab:addEvent({
    interact = __TS__New(
        Event,
        function(player, entity)
            showModularDialogWithInventory(nil, "IrrigatedPlantSupport", entity)
        end
    ),
    rotate = __TS__New(
        Event,
        function(player, entity)
            local realm = World:get(player.location.realm)
            placementRotate(entity.placement, entity, realm)
            GameEvents.playerRotateItem:invoke(player, entity)
            updateAssocation(nil, entity)
        end
    ),
    fluidChange = __TS__New(
        Event,
        function(entity)
            updateAssocation(nil, entity)
        end
    )
})
prefab:addConsumer({idlePower = 10, activePower = 50})
prefab:addOverlay()
prefab:addStats({stats = __TS__New(
    Map,
    {{
        "NRG",
        Stat.new(1, 999999999, 0)
    }}
)})
prefab:addFluidSink({
    inputs = {FluidIO.new(FluidType.None, TileDirection.Right, 100)},
    transferToSource = true
})
prefab:addFluidSource({
    capacity = 100,
    outputs = {FluidIO.new(FluidType.None, TileDirection.Right, 100)}
})
prefab:addFarming({offset = Vector.new(Sizes.TILE + Sizes.SUBTILE, 4 * Sizes.TILE)})
prefab:addDispenser({frequency = 500, isEnabled = true})
prefab.onCreate:listen(function(entity)
    local entityID = entity.id
    entity.fluidSource.onQuantityChanged:listen(function(____, index)
        local entity = EntityManager.get(entityID)
        local source = entity.fluidSource
        local currentLevel = math.ceil(source.quantity / source.capacity * 5)
        animator.tryPlay(
            entity,
            tostring(currentLevel),
            false
        )
    end)
end)
return ____exports
