local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 3,["14"] = 4,["15"] = 4,["16"] = 5,["17"] = 5,["18"] = 6,["19"] = 6,["20"] = 7,["21"] = 7,["22"] = 8,["23"] = 8,["24"] = 11,["25"] = 13,["26"] = 15,["27"] = 19,["28"] = 24,["29"] = 26,["30"] = 28,["31"] = 34,["32"] = 35,["33"] = 35,["34"] = 38,["35"] = 38,["36"] = 38,["37"] = 38,["38"] = 38,["39"] = 38,["40"] = 38,["41"] = 38,["42"] = 35,["43"] = 34,["44"] = 42,["45"] = 48,["46"] = 52,["47"] = 52,["48"] = 54,["49"] = 54,["50"] = 54,["51"] = 52,["52"] = 55,["53"] = 56,["54"] = 56,["55"] = 57,["56"] = 57,["57"] = 57,["58"] = 56,["59"] = 52,["60"] = 52,["61"] = 62,["62"] = 64,["63"] = 65,["64"] = 65,["65"] = 65,["66"] = 66,["67"] = 65,["68"] = 64,["69"] = 68,["70"] = 68,["71"] = 68,["72"] = 69,["73"] = 70,["74"] = 71,["75"] = 72,["76"] = 73,["77"] = 68,["78"] = 64,["79"] = 64,["80"] = 77,["81"] = 82,["82"] = 86,["83"] = 90,["84"] = 91,["85"] = 91,["86"] = 92,["87"] = 92,["88"] = 92,["89"] = 91,["90"] = 93,["91"] = 93,["92"] = 93,["93"] = 91,["94"] = 94,["95"] = 94,["96"] = 94,["97"] = 91,["98"] = 95,["99"] = 95,["100"] = 95,["101"] = 91,["102"] = 91,["103"] = 90,["104"] = 99,["105"] = 105,["106"] = 105,["107"] = 105,["108"] = 105,["109"] = 109,["110"] = 110,["113"] = 113,["114"] = 114,["115"] = 115,["116"] = 116,["117"] = 117,["119"] = 119,["120"] = 120,["122"] = 105,["123"] = 105});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local GameEvents = ____event.GameEvents
local ____craft = require("craft")
local CraftSite = ____craft.CraftSite
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local ____world = require("world")
local World = ____world.World
local ____utility = require("utility")
local breakItem = ____utility.breakItem
local ____placement = require("utility.placement")
local placementRotate = ____placement.placementRotate
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addItem({icon = "icons_lava_forge", stack = 20})
prefab:addRender("lava_forge_left-1")
prefab:addIllumination(1)
prefab:addAnimation({association = "lava_forge_left", start = "idle", loop = true})
prefab:addInventory({inventories = {
    {name = "input-0", size = 1, filterPrefabs = {INVALID_ENTITYID}},
    {name = "input-1", size = 1, filterPrefabs = {INVALID_ENTITYID}},
    {
        name = "output",
        size = 2,
        filterPrefabs = {INVALID_ENTITYID},
        features = bit.bor(
            bit.bor(InventoryFeatures.Dispense, InventoryFeatures.Withdraw),
            InventoryFeatures.RecipeFlush
        )
    }
}})
prefab:addFluidSink({inputs = {FluidIO.new(FluidType.Lava, TileDirection.Right, 200)}})
prefab:addCollector({reach = 2})
prefab:addPlacement({
    drop = Prefab.getID("structure.lava_forge"),
    features = bit.bor(
        bit.bor(PlacementFeatures.Default, PlacementFeatures.Pivotable),
        PlacementFeatures.ScaffoldingSupport
    ),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(3, 3),
            "lava_forge_left-1"
        )}
    )}
})
local DIRECTION_STRINGS = {"left", "left", "right", "right"}
prefab:addEvent({
    interact = __TS__New(
        Event,
        function(player, entity)
            showModularDialogWithInventory(nil, "FluidCombustFabricator", entity)
        end
    ),
    rotate = __TS__New(
        Event,
        function(player, entity)
            local realm = World:get(player.location.realm)
            placementRotate(entity.placement, entity, realm)
            GameEvents.playerRotateItem:invoke(player, entity)
            local direction = DIRECTION_STRINGS[entity.placement.direction + 1]
            animator.setAssociation(entity, "lava_forge_" .. direction)
        end
    )
})
prefab:addFabricator({speed = 1, site = CraftSite.LavaForge})
prefab:addDispenser({frequency = 500})
prefab:addOverlay({noPowerIndicator = atlases.get("autoforge_window_no_fuel")})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(30, 99, 30)
        },
        {
            "DEF",
            Stat.new(1, 99, 1)
        },
        {
            "NRG",
            Stat.new(1, 999999, 0)
        },
        {
            "owner",
            Stat.new(0, 999999)
        }
    }
)})
prefab:addCombat({team = CombatTeam.Structure, destroyOnDeath = false, onDeath = breakItem})
prefab:addConsumer({
    isAutonomous = true,
    idlePower = 0,
    activePower = 25,
    onStateChange = function(entityID, state, flag)
        if flag ~= ConsumerState.Powered then
            return
        end
        local entity = EntityManager.get(entityID)
        local producer = entity.producer
        if bit.band(state, ConsumerState.Powered) == ConsumerState.Powered then
            animator.tryPlay(entity, "running", true)
            producer.generate = producer.throughput
        else
            animator.tryPlay(entity, "idle", true)
            producer.generate = 0
        end
    end
})
return ____exports
