local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 5,["16"] = 5,["17"] = 8,["18"] = 10,["19"] = 12,["20"] = 16,["21"] = 21,["22"] = 23,["23"] = 25,["24"] = 25,["25"] = 25,["26"] = 25,["27"] = 25,["28"] = 25,["29"] = 25,["30"] = 25,["31"] = 25,["32"] = 25,["33"] = 25,["34"] = 25,["35"] = 25,["36"] = 24,["37"] = 26,["38"] = 26,["39"] = 26,["40"] = 26,["41"] = 26,["42"] = 26,["43"] = 26,["44"] = 26,["45"] = 26,["46"] = 26,["47"] = 26,["48"] = 26,["49"] = 26,["50"] = 24,["51"] = 27,["52"] = 27,["53"] = 27,["54"] = 27,["55"] = 27,["56"] = 27,["57"] = 24,["58"] = 28,["59"] = 28,["60"] = 28,["61"] = 28,["62"] = 28,["63"] = 24,["64"] = 23,["65"] = 32,["66"] = 36,["67"] = 36,["68"] = 39,["69"] = 39,["70"] = 39,["71"] = 36,["72"] = 40,["73"] = 41,["74"] = 41,["75"] = 42,["76"] = 42,["77"] = 42,["78"] = 41,["79"] = 36,["80"] = 36,["81"] = 47,["82"] = 48,["83"] = 48,["84"] = 49,["85"] = 48,["86"] = 47,["87"] = 53,["88"] = 58,["89"] = 60,["90"] = 61,["91"] = 61,["92"] = 62,["93"] = 62,["94"] = 61,["95"] = 60,["96"] = 66,["97"] = 68});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____Sizes = require("Sizes")
local Sizes = ____Sizes.Sizes
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addItem({icon = "icons_plant_support", stack = 20})
prefab:addRender("plant_support-1")
prefab:addInventory({inventories = {
    {
        name = "seed",
        size = 1,
        collectStack = 1,
        stackOverride = 1,
        filterPrefabs = {INVALID_ENTITYID},
        features = bit.bor(
            bit.bor(
                bit.bor(InventoryFeatures.Collect, InventoryFeatures.Deposit),
                InventoryFeatures.Unsortable
            ),
            InventoryFeatures.Discard
        )
    },
    {
        name = "tool",
        size = 1,
        collectStack = 1,
        stackOverride = 1,
        filterPrefabs = {INVALID_ENTITYID},
        features = bit.bor(
            bit.bor(
                bit.bor(InventoryFeatures.Collect, InventoryFeatures.Deposit),
                InventoryFeatures.Unsortable
            ),
            InventoryFeatures.Discard
        )
    },
    {
        name = "fuel",
        size = 1,
        collectStack = 4,
        stackOverride = 20,
        filterCategories = {"fertilizer"}
    },
    {
        name = "output",
        size = 4,
        filterPrefabs = {INVALID_ENTITYID},
        features = bit.bor(InventoryFeatures.Dispense, InventoryFeatures.Withdraw)
    }
}})
prefab:addCollector({reach = 3})
prefab:addPlacement({
    drop = Prefab.getID("structure.plant_support"),
    features = bit.bor(
        bit.bor(PlacementFeatures.Default, PlacementFeatures.Pivotable),
        PlacementFeatures.ScaffoldingSupport
    ),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(3, 5),
            "plant_support-1"
        )}
    )}
})
prefab:addEvent({interact = __TS__New(
    Event,
    function(player, entity)
        showModularDialogWithInventory(nil, "PlantSupport", entity)
    end
)})
prefab:addConsumer({idlePower = 6, activePower = 24})
prefab:addOverlay()
prefab:addStats({stats = __TS__New(
    Map,
    {{
        "NRG",
        Stat.new(1, 999999999, 0)
    }}
)})
prefab:addFarming({offset = Vector.new(Sizes.TILE + Sizes.SUBTILE, 4 * Sizes.TILE)})
prefab:addDispenser({frequency = 500, isEnabled = true})
return ____exports
