local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 2,["9"] = 2,["10"] = 3,["11"] = 3,["12"] = 4,["13"] = 4,["14"] = 5,["15"] = 5,["16"] = 6,["17"] = 6,["18"] = 9,["19"] = 11,["20"] = 13,["21"] = 17,["22"] = 22,["23"] = 24,["24"] = 28,["25"] = 28,["26"] = 28,["27"] = 31,["28"] = 32,["29"] = 32,["30"] = 33,["31"] = 33,["32"] = 33,["33"] = 33,["34"] = 32,["35"] = 34,["36"] = 34,["37"] = 34,["38"] = 34,["39"] = 32,["40"] = 35,["41"] = 35,["42"] = 35,["43"] = 35,["44"] = 32,["45"] = 36,["46"] = 36,["47"] = 36,["48"] = 36,["49"] = 32,["50"] = 32,["51"] = 28,["52"] = 28,["53"] = 41,["54"] = 46,["55"] = 51,["56"] = 52,["57"] = 52,["58"] = 53,["59"] = 54,["60"] = 55,["61"] = 56,["62"] = 57,["63"] = 57,["64"] = 57,["65"] = 57,["66"] = 52,["67"] = 51,["68"] = 61,["69"] = 63});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____placement = require("utility.placement")
local placementRotate = ____placement.placementRotate
local ____porter = require("systems.porter")
local PorterSystem = ____porter.PorterSystem
local ____world = require("world")
local World = ____world.World
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addItem({icon = "icons_porter_ii", stack = 100})
prefab:addRender("porter")
prefab:addAnimation({start = "up"})
prefab:addPlacement({
    drop = Prefab.getID("structure.porter_ii"),
    features = bit.bor(PlacementFeatures.Default, PlacementFeatures.NoSupportBackwall),
    axes = {PlacementAxis.new(
        PlacementAxisType.Backwall,
        {
            PlacementDirection.new(
                FacingDirection.Up,
                TileVector.new(1, 1),
                "porter.up"
            ),
            PlacementDirection.new(
                FacingDirection.Right,
                TileVector.new(1, 1),
                "porter.right"
            ),
            PlacementDirection.new(
                FacingDirection.Down,
                TileVector.new(1, 1),
                "porter.down"
            ),
            PlacementDirection.new(
                FacingDirection.Left,
                TileVector.new(1, 1),
                "porter.left"
            )
        }
    )}
})
prefab:addPorter({frequency = 800, reach = 5})
prefab:addConsumer({idlePower = 4, activePower = 16})
prefab:addEvent({rotate = __TS__New(
    Event,
    function(player, entity)
        local realm = World:get(entity.location.realm)
        local placement = entity.placement
        placementRotate(placement, entity, realm)
        PorterSystem:handleRotate(entity)
        realm.transport:rotate(
            placement.axis.area:getPosition(),
            placement.direction
        )
    end
)})
prefab:addOverlay()
prefab:addTransport({type = TransportTileType.Porter, speed = 800})
return ____exports
