local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 2,["9"] = 2,["10"] = 3,["11"] = 3,["12"] = 4,["13"] = 4,["14"] = 5,["15"] = 5,["16"] = 7,["17"] = 9,["18"] = 11,["19"] = 15,["20"] = 17,["21"] = 21,["22"] = 26,["23"] = 28,["24"] = 28,["25"] = 31,["26"] = 31,["27"] = 31,["28"] = 31,["29"] = 31,["30"] = 31,["31"] = 28,["32"] = 26,["33"] = 36,["34"] = 38,["35"] = 42,["36"] = 42,["37"] = 42,["38"] = 45,["39"] = 46,["40"] = 46,["41"] = 46,["42"] = 46,["43"] = 46,["44"] = 46,["45"] = 42,["46"] = 42,["47"] = 50,["48"] = 50,["49"] = 50,["50"] = 53,["51"] = 53,["52"] = 53,["53"] = 54,["54"] = 55,["55"] = 56,["56"] = 57,["57"] = 58,["58"] = 53,["59"] = 50,["60"] = 61,["61"] = 61,["62"] = 61,["63"] = 62,["64"] = 63,["65"] = 64,["66"] = 61,["67"] = 50,["68"] = 50});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____loot = require("systems.loot")
local LootSystem = ____loot.LootSystem
local ____base = require("ui.base")
local showDialogWithInventory = ____base.showDialogWithInventory
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("wood_chest-1")
prefab:addAnimation({start = "idle"})
prefab:addItem({icon = "icons_wood_chest", stack = 10})
prefab:addInventory({inventories = {{
    size = 20,
    collectSize = 20,
    features = bit.bor(
        bit.bor(
            bit.bor(InventoryFeatures.Collect, InventoryFeatures.Dispense),
            InventoryFeatures.Withdraw
        ),
        InventoryFeatures.Deposit
    )
}}})
prefab:addLoot()
prefab:addCollector({reach = 0})
prefab:addPlacement({
    drop = Prefab.getID("structure.wood_chest"),
    features = bit.bor(PlacementFeatures.Default, PlacementFeatures.ScaffoldingSupport),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(1, 1),
            "wood_chest-1"
        )}
    )}
})
prefab:addEvent({
    interactCursor = CursorType.Container,
    interactText = "OPEN",
    interact = __TS__New(
        Event,
        function(player, entity)
            LootSystem:populateLoot(entity)
            animator.play(entity, "open", false)
            animator.queue(entity, "running")
            audio.start("event:/GENERAL/CHEST_OPEN", entity.transform.position)
            showDialogWithInventory(nil, "Container", entity)
        end
    ),
    withdraw = __TS__New(
        Event,
        function(player, entity)
            animator.play(entity, "close", false)
            animator.queue(entity, "idle")
            audio.start("event:/GENERAL/CHEST_CLOSE", entity.transform.position)
        end
    )
})
return ____exports
