local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["8"] = 1,["9"] = 1,["10"] = 2,["11"] = 2,["12"] = 3,["13"] = 3,["14"] = 5,["15"] = 5,["16"] = 5,["18"] = 5,["19"] = 6,["20"] = 8,["21"] = 5,["22"] = 10,["23"] = 11,["24"] = 12,["25"] = 10,["26"] = 15,["27"] = 16,["28"] = 17,["29"] = 18,["30"] = 19,["31"] = 19,["32"] = 19,["33"] = 19,["34"] = 19,["35"] = 20,["36"] = 22,["37"] = 23,["38"] = 15,["39"] = 26,["40"] = 27,["41"] = 26,["42"] = 30,["43"] = 31,["44"] = 30,["45"] = 34,["46"] = 35,["47"] = 36,["49"] = 38,["50"] = 39,["51"] = 39,["52"] = 39,["53"] = 39,["54"] = 40,["55"] = 34,["56"] = 44});
local ____exports = {}
local ____scene = require("scenes.scene")
local Scene = ____scene.Scene
local ____particle_editor = require("ui.particle_editor")
local ParticleEditorUI = ____particle_editor.ParticleEditorUI
local ____core = require("core")
local core = ____core.core
local ParticleEditor = __TS__Class()
ParticleEditor.name = "ParticleEditor"
__TS__ClassExtends(ParticleEditor, Scene)
function ParticleEditor.prototype.____constructor(self, ...)
    Scene.prototype.____constructor(self, ...)
    self.ui = __TS__New(ParticleEditorUI)
    self.preview = INVALID_ENTITYID
end
function ParticleEditor.create(self)
    ParticleManager.initializeEditor()
    return __TS__New(ParticleEditor)
end
function ParticleEditor.prototype.activate(self, data)
    self.ui.dialog:setPosition(50, 50)
    self.ui:show()
    local size = Renderer.getSize()
    self.layer = EntityLayer.new(
        80,
        size:asVector(),
        size.x
    )
    EntityLayerManager.add(self.layer)
    self:resetPreview()
    self.ui.resetPreview = core.cb(self, "resetPreview")
end
function ParticleEditor.prototype.deactivate(self, data)
    self.ui:hide()
end
function ParticleEditor.prototype.handleKeyDown(self, state, mod, key)
    return false
end
function ParticleEditor.prototype.resetPreview(self)
    if self.preview ~= INVALID_ENTITYID then
        EntityManager.destroy(self.preview)
    end
    local size = Renderer.getSize()
    local preview = EntityManager.create(
        "fx.particle_preview",
        Vector.new(size.x / 2, size.y / 2)
    )
    self.preview = preview.id
end
____exports.scene = ParticleEditor
return ____exports
