local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["8"] = 1,["9"] = 1,["10"] = 2,["11"] = 2,["12"] = 4,["13"] = 4,["14"] = 4,["16"] = 4,["17"] = 7,["18"] = 8,["19"] = 10,["20"] = 6,["21"] = 6,["22"] = 6,["23"] = 14,["24"] = 15,["25"] = 15,["26"] = 15,["27"] = 15,["28"] = 15,["29"] = 14,["30"] = 18,["31"] = 19,["32"] = 18,["33"] = 22,["34"] = 23,["35"] = 24,["36"] = 25,["38"] = 27,["39"] = 28,["41"] = 22,["42"] = 32,["43"] = 33,["44"] = 33,["45"] = 33,["46"] = 33,["47"] = 34,["48"] = 35,["49"] = 36,["50"] = 36,["51"] = 36,["52"] = 36,["53"] = 37,["54"] = 37,["55"] = 37,["56"] = 37,["57"] = 38,["58"] = 39,["59"] = 41,["60"] = 41,["61"] = 41,["62"] = 41,["63"] = 42,["64"] = 44,["65"] = 45,["66"] = 47,["67"] = 48,["68"] = 49,["69"] = 51,["70"] = 52,["71"] = 52,["72"] = 52,["73"] = 52,["74"] = 53,["75"] = 54,["76"] = 56,["77"] = 57,["78"] = 32,["79"] = 61});
local ____exports = {}
local ____scene = require("scenes.scene")
local Scene = ____scene.Scene
local ____core = require("core")
local core = ____core.core
local Splash = __TS__Class()
Splash.name = "Splash"
__TS__ClassExtends(Splash, Scene)
function Splash.prototype.____constructor(self)
    Scene.prototype.____constructor(self)
    self.displayTimer = Timer.new(seconds(2))
    self.fadeTimer = Timer.new(seconds(1))
end
function Splash.create(self)
    return __TS__New(Splash)
end
function Splash.prototype.activate(self, data)
    self.layer = Renderer.addLayer(
        100,
        RenderPassTypes.Main,
        core.cb(self, "draw")
    )
end
function Splash.prototype.deactivate(self)
    Renderer.removeLayer(self.layer.pass, self.layer.index)
end
function Splash.prototype.update(self, frameTime)
    self.displayTimer:update(frameTime)
    if self.displayTimer:expired() then
        self.fadeTimer:update(frameTime)
    end
    if self.fadeTimer:expired() then
        SceneManager.load("scenes.menu")
    end
end
function Splash.prototype.draw(self, renderer, layer, viewport)
    local sprite = Sprite.new(
        "blackness",
        Vector.new()
    )
    sprite.material = Renderer.getMaterialHandle("gradient")
    local material = Renderer.getMaterial(sprite.material)
    material:setUniform(
        "topColor",
        Color.new(33, 33, 51)
    )
    material:setUniform(
        "bottomColor",
        Color.new(49, 47, 73)
    )
    sprite.scale:set(viewport.width, viewport.height)
    renderer:draw(sprite)
    local logo = Sprite.new(
        "siege_games_logo",
        Vector.new(viewport.width / 2, viewport.height / 2)
    )
    logo:centerOrigin()
    local scale = viewport.height / 1080
    logo.scale:set(scale * 0.8, scale * 0.8)
    local alpha = (1 - self.fadeTimer:percentage()) * 255
    logo.color = Color.new(255, 255, 255, alpha)
    renderer:draw(logo, 1)
    scale = scale * 0.3
    local fmodlogo = Sprite.new(
        "fmod_logo",
        Vector.new(viewport.width / 2, viewport.height - 192 * scale)
    )
    fmodlogo:centerOrigin()
    fmodlogo.scale:set(scale, scale)
    fmodlogo.color = Color.new(255, 255, 255, alpha)
    renderer:draw(fmodlogo, 1)
end
____exports.scene = Splash
return ____exports
