local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__Class = ____lualib.__TS__Class
local Map = ____lualib.Map
local Set = ____lualib.Set
local __TS__Iterator = ____lualib.__TS__Iterator
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["10"] = 1,["11"] = 1,["12"] = 2,["13"] = 2,["14"] = 2,["15"] = 2,["16"] = 3,["17"] = 3,["18"] = 3,["19"] = 4,["20"] = 4,["21"] = 6,["22"] = 9,["23"] = 10,["24"] = 11,["25"] = 11,["26"] = 11,["27"] = 11,["28"] = 11,["29"] = 11,["30"] = 11,["31"] = 11,["32"] = 11,["33"] = 11,["34"] = 13,["35"] = 13,["37"] = 14,["38"] = 15,["39"] = 17,["40"] = 19,["41"] = 20,["42"] = 21,["44"] = 24,["45"] = 24,["46"] = 25,["48"] = 26,["49"] = 26,["51"] = 27,["52"] = 27,["53"] = 28,["54"] = 27,["57"] = 26,["60"] = 31,["61"] = 31,["62"] = 24,["65"] = 23,["66"] = 35,["67"] = 36,["68"] = 37,["69"] = 38,["70"] = 39,["71"] = 41,["72"] = 43,["73"] = 44,["74"] = 45,["75"] = 45,["76"] = 45,["77"] = 45,["78"] = 46,["81"] = 50,["82"] = 51,["83"] = 52,["86"] = 55,["87"] = 56,["89"] = 35,["90"] = 60,["91"] = 61,["92"] = 62,["93"] = 63,["94"] = 64,["96"] = 60,["97"] = 68,["98"] = 69,["99"] = 70,["100"] = 70,["101"] = 70,["103"] = 70,["105"] = 70,["106"] = 68,["107"] = 73,["108"] = 74,["109"] = 75,["110"] = 76,["112"] = 79,["113"] = 80,["114"] = 81,["115"] = 82,["119"] = 87,["120"] = 88,["121"] = 89,["122"] = 90,["123"] = 91,["124"] = 92,["125"] = 93,["130"] = 99,["131"] = 100,["132"] = 101,["133"] = 102,["136"] = 106,["137"] = 107,["138"] = 108,["140"] = 111,["141"] = 112,["142"] = 113,["143"] = 114,["144"] = 115,["145"] = 116,["146"] = 117,["151"] = 123,["152"] = 73,["153"] = 126,["154"] = 127,["155"] = 128,["158"] = 132,["159"] = 133,["161"] = 126,["162"] = 137,["163"] = 138,["164"] = 139,["167"] = 143,["168"] = 144,["169"] = 144,["170"] = 144,["171"] = 144,["172"] = 144,["174"] = 137,["175"] = 148,["176"] = 149,["177"] = 150,["180"] = 154,["181"] = 155,["182"] = 156,["183"] = 157,["184"] = 158,["185"] = 158,["186"] = 158,["187"] = 158,["188"] = 158,["191"] = 148,["192"] = 167,["193"] = 168,["194"] = 169,["195"] = 170,["196"] = 171,["198"] = 167,["199"] = 175,["200"] = 176,["202"] = 177,["203"] = 177,["204"] = 178,["205"] = 179,["206"] = 180,["207"] = 181,["208"] = 182,["210"] = 177,["213"] = 175,["214"] = 190,["215"] = 191,["216"] = 192,["218"] = 195,["219"] = 197,["220"] = 197});
local ____exports = {}
local ____architect = require("architect")
local architect = ____architect.architect
local ____craft = require("craft")
local CraftRecipe = ____craft.CraftRecipe
local CraftSite = ____craft.CraftSite
local CraftTab = ____craft.CraftTab
local ____event = require("event")
local Event = ____event.Event
local GameEvents = ____event.GameEvents
local ____recipes = require("recipes")
local addRecipes = ____recipes.addRecipes
GameEvents.learnRecipe = __TS__New(Event)
local CRAFT_ROW_SIZE = 10
local CRAFT_ROW_COUNT = 8
local EMPTY_RECIPE = __TS__New(
    CraftRecipe,
    "",
    {},
    {},
    0,
    CraftSite.Player,
    CraftTab.Materials,
    -1
)
local CraftManager = __TS__Class()
CraftManager.name = "CraftManager"
function CraftManager.prototype.____constructor(self)
    self.recipes = __TS__New(Map)
    self.autoRecipes = __TS__New(Map)
    self.playerResults = __TS__New(Map)
    self.results = __TS__New(Map)
    self.tabs = {}
    self.materials = __TS__New(Set)
    do
        local tab = 0
        while tab < CraftTab.Count do
            local recipes = {}
            do
                local row = 0
                while row < CRAFT_ROW_COUNT do
                    do
                        local column = 0
                        while column < CRAFT_ROW_SIZE do
                            recipes[#recipes + 1] = EMPTY_RECIPE
                            column = column + 1
                        end
                    end
                    row = row + 1
                end
            end
            local ____self_tabs_0 = self.tabs
            ____self_tabs_0[#____self_tabs_0 + 1] = recipes
            tab = tab + 1
        end
    end
end
function CraftManager.prototype.add(self, recipe)
    local tabRecipes = self.tabs[recipe.tab + 1]
    local existing = tabRecipes[recipe.index + 1]
    assert(existing.index == -1, (("Attempting to add recipe " .. recipe.name) .. " with same tab index as ") .. existing.name)
    tabRecipes[recipe.index + 1] = recipe
    self.recipes:set(recipe.name, recipe)
    if bit.band(recipe.site, CraftSite.Player) == CraftSite.Player then
        for ____, item in ipairs(recipe.result) do
            assert(
                not self.playerResults:has(item.entityID),
                ((("Attempting to add player craftable recipe \"" .. recipe.name) .. "\" with material=") .. tostring(item)) .. " that is already accounted for."
            )
            self.playerResults:set(item.entityID, recipe.name)
        end
    end
    for ____, item in ipairs(recipe.result) do
        if not self.results:has(item.entityID) then
            self.results:set(item.entityID, recipe.name)
        end
    end
    for ____, item in ipairs(recipe.materials) do
        self.materials:add(item.entityID)
    end
end
function CraftManager.prototype.learn(self, name)
    local recipe = self.recipes:get(name)
    if recipe then
        recipe.known = true
        GameEvents.learnRecipe:invoke(recipe)
    end
end
function CraftManager.prototype.isKnown(self, name)
    local recipe = self.recipes:get(name)
    local ____recipe_1
    if recipe then
        ____recipe_1 = recipe.known
    else
        ____recipe_1 = false
    end
    return ____recipe_1
end
function CraftManager.prototype.canCraft(self, name, entity, inventory)
    local recipe = self.recipes:get(name)
    if not recipe then
        return false
    end
    if #recipe.materials > 0 then
        for ____, material in ipairs(recipe.materials) do
            if not inventory:has(material) then
                return false
            end
        end
    end
    if #recipe.fluids > 0 then
        local sink = entity.fluidSink
        if sink ~= nil then
            for ____, fluid in ipairs(recipe.fluids) do
                local index = sink:get(fluid.type)
                if index ~= -1 and sink.inputs[index + 1].quantity < fluid.quantity then
                    return false
                end
            end
        end
    end
    if #recipe.materials + #recipe.fluids == 0 then
        local input = inventory:get("input-0")
        if input and input.items[1].quantity == 0 then
            return false
        end
    end
    local output = inventory:get("output")
    if output and output.stackOverride > 0 and #recipe.result > 0 and recipe.result[1].quantity > output.stackOverride - output.items[1].quantity then
        return false
    end
    if #recipe.resultFluids > 0 then
        local source = entity.fluidSource
        if source ~= nil then
            for ____, fluid in ipairs(recipe.resultFluids) do
                local index = source:get(fluid.type)
                if index ~= -1 and source.outputs[index + 1].quantity + fluid.quantity > source.outputs[index + 1].capacity then
                    return false
                end
            end
        end
    end
    return true
end
function CraftManager.prototype.startCraft(self, name, inventory)
    local recipe = self.recipes:get(name)
    if not recipe then
        return
    end
    for ____, material in ipairs(recipe.materials) do
        inventory:remove(material, false)
    end
end
function CraftManager.prototype.cancelCraft(self, name, amount, inventory)
    local recipe = self.recipes:get(name)
    if not recipe then
        return
    end
    for ____, material in ipairs(recipe.materials) do
        inventory:add(
            Item.new(material.entityID, material.quantity * amount),
            InventoryFeatures.None,
            false
        )
    end
end
function CraftManager.prototype.finishCraft(self, name, entity)
    local recipe = self.recipes:get(name)
    if not recipe then
        return
    end
    local inventory = entity.inventory
    for ____, item in ipairs(recipe.result) do
        local remaining = inventory:add(item, InventoryFeatures.None, false)
        if remaining > 0 then
            architect:createDropped(
                entity.location.realm,
                entity.transform.position,
                Item.new(item.entityID, remaining)
            )
        end
    end
end
function CraftManager.prototype.serialize(self, stream)
    stream:uint16(self.recipes.size)
    for ____, recipe in __TS__Iterator(self.recipes) do
        stream:string(recipe[1])
        stream:bool(recipe[2].known)
    end
end
function CraftManager.prototype.deserialize(self, stream)
    local count = stream:uint16()
    do
        local i = 0
        while i < count do
            local key = stream:string()
            local known = stream:bool()
            local recipe = self.recipes:get(key)
            if recipe then
                recipe.known = known
            end
            i = i + 1
        end
    end
end
if _G.CraftManager == nil then
    _G.CraftManager = __TS__New(CraftManager)
    addRecipes(nil, _G.CraftManager)
end
local manager = _G.CraftManager
____exports.CraftManager = manager
____exports.CraftManagerType = CraftManager
return ____exports
