local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["8"] = 1,["9"] = 1,["10"] = 2,["11"] = 2,["12"] = 4,["13"] = 4,["14"] = 4,["15"] = 6,["16"] = 7,["17"] = 8,["18"] = 9,["19"] = 6,["20"] = 12,["21"] = 13,["22"] = 15,["23"] = 16,["24"] = 17,["25"] = 18,["26"] = 19,["27"] = 20,["28"] = 21,["32"] = 25,["33"] = 12,["34"] = 5,["35"] = 29});
local ____exports = {}
local ____crafter = require("components.crafter")
local CrafterComponent = ____crafter.CrafterComponent
local ____base = require("systems.base")
local EntitySystem = ____base.EntitySystem
local CrafterSystem = __TS__Class()
CrafterSystem.name = "CrafterSystem"
__TS__ClassExtends(CrafterSystem, EntitySystem)
function CrafterSystem.register(self)
    local system = __TS__New(CrafterSystem)
    SystemManager.registerSystem(CrafterSystem.ID, system, 16)
    SystemManager.associate(CrafterSystem.ID, CrafterComponent.cid)
end
function CrafterSystem.prototype.update(self, frameTime)
    tracy.ZoneBeginN("CrafterSystem::update()")
    for ____, entityID in ipairs(self.entities) do
        local entity = EntityManager.get(entityID)
        local crafter = entity.crafter
        if #crafter.queue > 0 then
            crafter.timer:update(frameTime)
            if crafter.recipeTimer:update(frameTime) then
                crafter:finishCraftEntry(entity)
            end
        end
    end
    tracy.ZoneEnd()
end
CrafterSystem.ID = HashString("CrafterSystem")
____exports.CrafterSystem = CrafterSystem
return ____exports
