local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ArrayIndexOf = ____lualib.__TS__ArrayIndexOf
local __TS__ArraySplice = ____lualib.__TS__ArraySplice
local __TS__Iterator = ____lualib.__TS__Iterator
local __TS__ArraySort = ____lualib.__TS__ArraySort
local __TS__Decorate = ____lualib.__TS__Decorate
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["11"] = 1,["12"] = 1,["13"] = 2,["14"] = 2,["15"] = 3,["16"] = 3,["17"] = 4,["18"] = 4,["19"] = 13,["20"] = 13,["21"] = 27,["22"] = 21,["23"] = 23,["24"] = 24,["25"] = 28,["26"] = 29,["27"] = 30,["28"] = 30,["29"] = 30,["30"] = 30,["31"] = 30,["32"] = 27,["33"] = 33,["34"] = 34,["35"] = 35,["36"] = 35,["37"] = 33,["38"] = 38,["39"] = 39,["40"] = 40,["41"] = 41,["42"] = 41,["43"] = 41,["45"] = 38,["46"] = 44,["47"] = 45,["48"] = 46,["49"] = 47,["51"] = 49,["52"] = 50,["53"] = 51,["56"] = 44,["57"] = 56,["58"] = 57,["59"] = 58,["60"] = 59,["62"] = 56,["63"] = 63,["64"] = 64,["65"] = 63,["66"] = 67,["67"] = 68,["68"] = 70,["69"] = 71,["70"] = 72,["71"] = 73,["72"] = 75,["73"] = 76,["74"] = 79,["75"] = 81,["76"] = 82,["77"] = 83,["78"] = 84,["79"] = 85,["82"] = 88,["83"] = 89,["85"] = 92,["86"] = 92,["87"] = 92,["88"] = 92,["89"] = 93,["91"] = 94,["92"] = 94,["94"] = 95,["95"] = 96,["96"] = 96,["98"] = 98,["99"] = 99,["100"] = 101,["101"] = 102,["105"] = 94,["109"] = 106,["110"] = 108,["111"] = 109,["112"] = 109,["113"] = 109,["114"] = 109,["115"] = 110,["116"] = 111,["117"] = 112,["118"] = 113,["121"] = 116,["122"] = 118,["124"] = 119,["125"] = 119,["127"] = 120,["128"] = 121,["129"] = 122,["130"] = 124,["131"] = 125,["132"] = 126,["133"] = 127,["135"] = 130,["136"] = 131,["137"] = 132,["138"] = 133,["139"] = 134,["140"] = 135,["142"] = 137,["143"] = 138,["144"] = 138,["145"] = 139,["146"] = 140,["147"] = 141,["148"] = 142,["149"] = 143,["151"] = 145,["153"] = 147,["154"] = 148,["155"] = 149,["156"] = 150,["157"] = 150,["158"] = 150,["159"] = 150,["160"] = 151,["161"] = 153,["163"] = 155,["165"] = 157,["166"] = 159,["168"] = 161,["173"] = 119,["176"] = 165,["177"] = 67,["178"] = 168,["179"] = 169,["180"] = 170,["181"] = 171,["182"] = 172,["183"] = 173,["184"] = 174,["186"] = 177,["187"] = 178,["188"] = 179,["190"] = 182,["191"] = 183,["192"] = 184,["193"] = 185,["194"] = 185,["195"] = 187,["196"] = 188,["197"] = 189,["198"] = 191,["199"] = 193,["201"] = 195,["202"] = 168,["203"] = 198,["204"] = 198,["205"] = 15,["206"] = 16,["207"] = 17,["208"] = 18,["209"] = 13,["210"] = 214});
local ____exports = {}
local ____core = require("core")
local core = ____core.core
local ____reload = require("reload")
local reloadable = ____reload.reloadable
local ____Sizes = require("Sizes")
local Sizes = ____Sizes.Sizes
local ____notification = require("systems.notification")
local NotificationSystem = ____notification.NotificationSystem
local DroppedSystem = __TS__Class()
DroppedSystem.name = "DroppedSystem"
function DroppedSystem.prototype.____constructor(self, worldSize, ground)
    self.collectable = {}
    self.collecting = {}
    self.collectors = {}
    self.spatial = SpatialHash.new(worldSize, Sizes.SECTOR)
    self.ground = ground
    Renderer.addLayer(
        200,
        RenderPassTypes.Main,
        core.cb(self, "draw")
    )
end
function DroppedSystem.prototype.addDropped(self, entity)
    log.info((("Add dropped: " .. tostring(entity)) .. " item=") .. tostring(entity.dropped.item))
    local ____self_collectable_0 = self.collectable
    ____self_collectable_0[#____self_collectable_0 + 1] = entity.id
end
function DroppedSystem.prototype.addGatherer(self, entity)
    log.info("Add gatherer: " .. tostring(entity.id))
    local gatherer = entity.gatherer
    if gatherer.range > 0 then
        local ____self_collectors_1 = self.collectors
        ____self_collectors_1[#____self_collectors_1 + 1] = entity.id
    end
end
function DroppedSystem.prototype.removeDropped(self, entity)
    local index = __TS__ArrayIndexOf(self.collecting, entity.id)
    if index ~= -1 then
        __TS__ArraySplice(self.collecting, index, 1)
    else
        index = __TS__ArrayIndexOf(self.collectable, entity.id)
        if index ~= -1 then
            __TS__ArraySplice(self.collectable, index, 1)
        end
    end
end
function DroppedSystem.prototype.removeGatherer(self, entity)
    local index = __TS__ArrayIndexOf(self.collectors, entity.id)
    if index ~= -1 then
        __TS__ArraySplice(self.collectors, index, 1)
    end
end
function DroppedSystem.prototype.updateStart(self, frameTime)
    self.spatial:populateAndClear(self.collectable)
end
function DroppedSystem.prototype.update(self, frameTime)
    local collections = {}
    tracy.ZoneBeginN("Dropped Collectors")
    for ____, collectorId in ipairs(self.collectors) do
        local collectorEntity = EntityManager.get(collectorId)
        local gatherer = collectorEntity.gatherer
        local physics = collectorEntity.physics
        local targetPosition = physics and physics.body:center() or collectorEntity.render.center
        local completed = {}
        for ____, ignored in __TS__Iterator(gatherer.ignored) do
            local entity = EntityManager.get(ignored[1])
            if entity == nil or entity.render.center:getDistance(targetPosition) > DroppedSystem.IGNORE_RANGE then
                completed[#completed + 1] = ignored[1]
                entity.onDestroy:remove(ignored[2])
            end
        end
        for ____, ignored in ipairs(completed) do
            gatherer.ignored:delete(ignored)
        end
        local area = Rect.fromCenter(
            targetPosition,
            Vector.new(gatherer.range * 3, gatherer.range * 3)
        )
        local nearbyDropped = self.spatial:query(area)
        do
            local index = 0
            while index < #nearbyDropped do
                do
                    local entityID = nearbyDropped[index + 1]
                    if gatherer.ignored:has(entityID) then
                        goto __continue20
                    end
                    local entity = EntityManager.get(entityID)
                    local distance = targetPosition:getDistance(entity.render.center)
                    if distance <= gatherer.range and entity.dropped.timer:expired() then
                        collections[#collections + 1] = {distance = distance, entity = entity, collectorEntity = collectorEntity}
                    end
                end
                ::__continue20::
                index = index + 1
            end
        end
    end
    tracy.ZoneEnd()
    tracy.ZoneBeginN("Dropped Collections")
    __TS__ArraySort(
        collections,
        function(____, collection1, collection2) return collection2.distance - collection1.distance end
    )
    for ____, collection in ipairs(collections) do
        local collector = collection.collectorEntity
        if self:collectItem(collector, collector.inventory, collection.entity) then
            collection.entity.physics:setEnabled(false)
        end
    end
    tracy.ZoneEnd()
    tracy.ZoneBeginN("Dropped Collecting")
    do
        local index = #self.collecting - 1
        while index >= 0 do
            do
                local entityID = self.collecting[index + 1]
                local entity = EntityManager.get(entityID)
                local dropped = entity.dropped
                if not EntityManager.has(dropped.gatherer) then
                    EntityManager.destroy(entityID)
                    __TS__ArraySplice(self.collecting, index, 1)
                    goto __continue28
                end
                local destination = dropped.destination
                local center = entity.render.center
                local distance = center:getDistance(destination)
                if distance <= Sizes.SUBTILE then
                    if dropped.item:isEmpty() then
                        EntityManager.destroy(entityID)
                    else
                        dropped.gatherer = INVALID_ENTITYID
                        local ____self_collectable_2 = self.collectable
                        ____self_collectable_2[#____self_collectable_2 + 1] = entityID
                        local physics = entity.physics
                        physics.body:setPosition(destination.x, destination.y)
                        physics:setEnabled(true)
                        physics:setAwake(true)
                        dropped.destination:reset()
                    end
                    __TS__ArraySplice(self.collecting, index, 1)
                else
                    local position = entity.transform.position
                    local speed = DroppedSystem.MOVE_SPEED * (frameTime.milliseconds / DroppedSystem.FRAME_SPEED)
                    local angle = center:getAngle(destination)
                    local movement = Vector.new(
                        math.cos(angle) * speed,
                        math.sin(angle) * speed
                    )
                    if position.x > destination.x and position.x + movement.x < destination.x or position.x < destination.x and position.x + movement.x > destination.x then
                        position.x = destination.x
                    else
                        position.x = position.x + movement.x
                    end
                    if position.y > destination.y and position.y + movement.y < destination.y or position.y < destination.y and position.y + movement.y > destination.y then
                        position.y = destination.y
                    else
                        position.y = position.y + movement.y
                    end
                end
            end
            ::__continue28::
            index = index - 1
        end
    end
    tracy.ZoneEnd()
end
function DroppedSystem.prototype.collectItem(self, collector, inventory, droppedEntity)
    local dropped = droppedEntity.dropped
    local droppedItem = dropped.item
    if dropped.gatherer == INVALID_ENTITYID and inventory:canAdd(droppedItem, InventoryFeatures.Collect) then
        if collector.player ~= nil then
            NotificationSystem:obtainItem(droppedItem)
            audio.start("event:/PLAYER/OTTO_COLLECT_MATERIALS")
        end
        local quantity = inventory:add(droppedItem, InventoryFeatures.Collect, true)
        if quantity ~= droppedItem.quantity then
            dropped.item.quantity = quantity
        end
        dropped.gatherer = collector.id
        local physics = collector.physics
        dropped.destination = physics and physics.body:center() or collector.render.center
        local ____self_collecting_3 = self.collecting
        ____self_collecting_3[#____self_collecting_3 + 1] = droppedEntity.id
        local index = __TS__ArrayIndexOf(self.collectable, droppedEntity.id)
        assert(index ~= -1, "Failed to find belt item in collectables")
        __TS__ArraySplice(self.collectable, index, 1)
        droppedEntity.isSerializable = not dropped.item:isEmpty()
        return true
    end
    return false
end
function DroppedSystem.prototype.draw(self, renderer, layer, viewport)
end
DroppedSystem.MOVE_SPEED = 24
DroppedSystem.FRAME_SPEED = 1000 / 16
DroppedSystem.CELL_SIZE = 512
DroppedSystem.IGNORE_RANGE = 128
DroppedSystem = __TS__Decorate({reloadable}, DroppedSystem)
____exports.DroppedSystem = DroppedSystem
return ____exports
