local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__Class = ____lualib.__TS__Class
local __TS__SetDescriptor = ____lualib.__TS__SetDescriptor
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__ArraySplice = ____lualib.__TS__ArraySplice
local __TS__ArrayIndexOf = ____lualib.__TS__ArrayIndexOf
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["11"] = 1,["12"] = 1,["13"] = 2,["14"] = 2,["15"] = 2,["16"] = 6,["17"] = 7,["18"] = 8,["19"] = 9,["20"] = 11,["21"] = 11,["22"] = 11,["23"] = 11,["24"] = 11,["25"] = 11,["26"] = 11,["27"] = 11,["28"] = 11,["29"] = 11,["30"] = 11,["31"] = 11,["32"] = 11,["33"] = 11,["34"] = 11,["35"] = 11,["36"] = 11,["37"] = 22,["38"] = 22,["40"] = 23,["41"] = 24,["42"] = 25,["43"] = 26,["44"] = 27,["45"] = 28,["46"] = 22,["51"] = 31,["59"] = 35,["67"] = 39,["75"] = 43,["83"] = 47,["91"] = 51,["95"] = 54,["96"] = 54,["97"] = 57,["98"] = 57,["99"] = 57,["100"] = 62,["101"] = 57,["102"] = 58,["103"] = 64,["104"] = 65,["105"] = 62,["110"] = 69,["118"] = 73,["122"] = 77,["123"] = 77,["124"] = 77,["125"] = 81,["126"] = 77,["127"] = 78,["128"] = 83,["129"] = 81,["134"] = 87,["142"] = 91,["150"] = 95,["154"] = 99,["155"] = 99,["156"] = 99,["157"] = 104,["158"] = 99,["159"] = 100,["160"] = 101,["161"] = 106,["162"] = 104,["167"] = 110,["175"] = 114,["183"] = 118,["187"] = 122,["188"] = 122,["189"] = 122,["190"] = 127,["191"] = 122,["192"] = 123,["193"] = 124,["194"] = 129,["195"] = 127,["200"] = 133,["208"] = 137,["216"] = 141,["220"] = 144,["221"] = 145,["222"] = 146,["223"] = 144,["224"] = 150,["225"] = 150,["226"] = 150,["228"] = 150,["229"] = 152,["230"] = 153,["231"] = 150,["236"] = 156,["244"] = 160,["248"] = 151,["249"] = 164,["250"] = 164,["252"] = 165,["253"] = 166,["254"] = 164,["259"] = 173,["260"] = 173,["261"] = 173,["262"] = 173,["266"] = 168,["267"] = 169,["268"] = 168,["269"] = 176,["271"] = 177,["272"] = 177,["273"] = 178,["274"] = 179,["275"] = 180,["276"] = 181,["277"] = 182,["278"] = 183,["279"] = 184,["281"] = 177,["284"] = 176,["285"] = 189,["286"] = 190,["287"] = 191,["288"] = 192,["289"] = 192,["290"] = 193,["291"] = 189,["292"] = 196,["293"] = 197,["294"] = 198,["295"] = 199,["297"] = 201,["298"] = 201,["299"] = 202,["300"] = 196,["301"] = 205,["302"] = 206,["303"] = 207,["304"] = 208,["305"] = 209,["307"] = 205,["308"] = 213,["309"] = 214,["310"] = 215,["311"] = 215,["314"] = 213,["315"] = 219,["316"] = 220,["317"] = 219,["318"] = 223,["319"] = 224,["320"] = 225,["321"] = 226,["322"] = 226,["323"] = 227,["324"] = 228,["328"] = 233,["329"] = 233,["330"] = 233,["331"] = 233,["332"] = 223,["333"] = 236,["334"] = 237,["335"] = 236,["336"] = 240,["337"] = 241,["338"] = 240,["339"] = 244,["340"] = 245,["341"] = 244,["342"] = 251,["343"] = 252,["345"] = 255,["346"] = 257,["347"] = 257,["348"] = 257,["349"] = 257});
local ____exports = {}
local ____core = require("core")
local core = ____core.core
local ____event = require("event")
local Event = ____event.Event
local GameEvents = ____event.GameEvents
GameEvents.notificationAdded = __TS__New(Event)
GameEvents.notificationRemoved = __TS__New(Event)
GameEvents.notificationChanged = __TS__New(Event)
GameEvents.notificationExpiring = __TS__New(Event)
local NotificationType = NotificationType or ({})
NotificationType.None = 0
NotificationType[NotificationType.None] = "None"
NotificationType.General = 1
NotificationType[NotificationType.General] = "General"
NotificationType.Item = 2
NotificationType[NotificationType.Item] = "Item"
NotificationType.Research = 3
NotificationType[NotificationType.Research] = "Research"
NotificationType.Invasion = 4
NotificationType[NotificationType.Invasion] = "Invasion"
NotificationType.Siege = 5
NotificationType[NotificationType.Siege] = "Siege"
NotificationType.Tutorial = 6
NotificationType[NotificationType.Tutorial] = "Tutorial"
NotificationType.Resource = 7
NotificationType[NotificationType.Resource] = "Resource"
local BaseNotification = __TS__Class()
BaseNotification.name = "BaseNotification"
function BaseNotification.prototype.____constructor(self)
    self.durationTime = seconds(5)
    self.fadeTime = 500
    self.type = NotificationType.None
    self.uid = 0
    self.timer = GameTimer.new()
    self.triggeredExpiringEvent = false
end
__TS__SetDescriptor(
    BaseNotification.prototype,
    "isExpiring",
    {get = function(self)
        return self.timer:remaining() <= self.fadeTime
    end},
    true
)
__TS__SetDescriptor(
    BaseNotification.prototype,
    "isExpired",
    {get = function(self)
        return self.timer:expired()
    end},
    true
)
__TS__SetDescriptor(
    BaseNotification.prototype,
    "text",
    {get = function(self)
        return ""
    end},
    true
)
__TS__SetDescriptor(
    BaseNotification.prototype,
    "icon",
    {get = function(self)
        return INVALID_ATLAS_HANDLE
    end},
    true
)
__TS__SetDescriptor(
    BaseNotification.prototype,
    "quantity",
    {get = function(self)
        return 0
    end},
    true
)
__TS__SetDescriptor(
    BaseNotification.prototype,
    "isInteractable",
    {get = function(self)
        return false
    end},
    true
)
function BaseNotification.prototype.interact(self)
end
local GeneralNotification = __TS__Class()
GeneralNotification.name = "GeneralNotification"
__TS__ClassExtends(GeneralNotification, BaseNotification)
function GeneralNotification.prototype.____constructor(self, text, icon)
    BaseNotification.prototype.____constructor(self)
    self.type = NotificationType.General
    self._text = text
    self._icon = icon
end
__TS__SetDescriptor(
    GeneralNotification.prototype,
    "text",
    {get = function(self)
        return self._text
    end},
    true
)
__TS__SetDescriptor(
    GeneralNotification.prototype,
    "icon",
    {get = function(self)
        return self._icon
    end},
    true
)
local ItemNotification = __TS__Class()
ItemNotification.name = "ItemNotification"
__TS__ClassExtends(ItemNotification, BaseNotification)
function ItemNotification.prototype.____constructor(self, item)
    BaseNotification.prototype.____constructor(self)
    self.type = NotificationType.Item
    self.item = item
end
__TS__SetDescriptor(
    ItemNotification.prototype,
    "text",
    {get = function(self)
        return locale.get(self.item.prefab .. "Name")
    end},
    true
)
__TS__SetDescriptor(
    ItemNotification.prototype,
    "icon",
    {get = function(self)
        return self.item.icon
    end},
    true
)
__TS__SetDescriptor(
    ItemNotification.prototype,
    "quantity",
    {get = function(self)
        return self.item.quantity
    end},
    true
)
local ResourceNotification = __TS__Class()
ResourceNotification.name = "ResourceNotification"
__TS__ClassExtends(ResourceNotification, BaseNotification)
function ResourceNotification.prototype.____constructor(self, item)
    BaseNotification.prototype.____constructor(self)
    self.type = NotificationType.Resource
    self.durationTime = seconds(15)
    self.item = item
end
__TS__SetDescriptor(
    ResourceNotification.prototype,
    "text",
    {get = function(self)
        return locale.get(self.item.prefab .. "Name") .. " Node Discovered"
    end},
    true
)
__TS__SetDescriptor(
    ResourceNotification.prototype,
    "icon",
    {get = function(self)
        return self.item.icon
    end},
    true
)
__TS__SetDescriptor(
    ResourceNotification.prototype,
    "quantity",
    {get = function(self)
        return self.item.quantity
    end},
    true
)
local ResearchNotification = __TS__Class()
ResearchNotification.name = "ResearchNotification"
__TS__ClassExtends(ResearchNotification, BaseNotification)
function ResearchNotification.prototype.____constructor(self, technology)
    BaseNotification.prototype.____constructor(self)
    self.type = NotificationType.Research
    self.durationTime = seconds(30)
    self.technology = technology
end
__TS__SetDescriptor(
    ResearchNotification.prototype,
    "text",
    {get = function(self)
        return self.technology.name .. "TechName"
    end},
    true
)
__TS__SetDescriptor(
    ResearchNotification.prototype,
    "icon",
    {get = function(self)
        return self.technology.icon
    end},
    true
)
__TS__SetDescriptor(
    ResearchNotification.prototype,
    "isInteractable",
    {get = function(self)
        return true
    end},
    true
)
function ResearchNotification.prototype.interact(self)
    local dialog = UIManager.get("Research")
    dialog:show()
end
local InvasionNotification = __TS__Class()
InvasionNotification.name = "InvasionNotification"
__TS__ClassExtends(InvasionNotification, BaseNotification)
function InvasionNotification.prototype.____constructor(self, ...)
    BaseNotification.prototype.____constructor(self, ...)
    self.type = NotificationType.Invasion
    self.durationTime = seconds(30)
end
__TS__SetDescriptor(
    InvasionNotification.prototype,
    "text",
    {get = function(self)
        return "Monster Invasion!!"
    end},
    true
)
__TS__SetDescriptor(
    InvasionNotification.prototype,
    "icon",
    {get = function(self)
        return InvasionNotification.ICON
    end},
    true
)
InvasionNotification.ICON = atlases.get("autoforge_window_hud_notif_invasion_icon")
local NotificationSystem = __TS__Class()
NotificationSystem.name = "NotificationSystem"
function NotificationSystem.prototype.____constructor(self)
    self._uid = 0
    self.notifications = {}
end
__TS__SetDescriptor(
    NotificationSystem.prototype,
    "uid",
    {get = function(self)
        local ____self_0, ____uid_1 = self, "_uid"
        local ____self__uid_2 = ____self_0[____uid_1] + 1
        ____self_0[____uid_1] = ____self__uid_2
        return ____self__uid_2
    end},
    true
)
function NotificationSystem.prototype.initialize(self)
    GameEvents.finishResearch:listen(core.cb(self, "handleFinishResearch"))
end
function NotificationSystem.prototype.update(self, frameTime)
    do
        local index = #self.notifications - 1
        while index >= 0 do
            local notification = self.notifications[index + 1]
            if notification.isExpired then
                __TS__ArraySplice(self.notifications, index, 1)
                GameEvents.notificationRemoved:invoke(notification.uid)
            elseif notification.triggeredExpiringEvent and notification.isExpiring then
                notification.triggeredExpiringEvent = true
                GameEvents.notificationExpiring:invoke(notification)
            end
            index = index - 1
        end
    end
end
function NotificationSystem.prototype.add(self, notification)
    notification.uid = self.uid
    notification.timer:reset(notification.durationTime)
    local ____self_notifications_3 = self.notifications
    ____self_notifications_3[#____self_notifications_3 + 1] = notification
    GameEvents.notificationAdded:invoke(notification)
end
function NotificationSystem.prototype.bringToFront(self, notification)
    local index = __TS__ArrayIndexOf(self.notifications, notification)
    if index ~= -1 then
        __TS__ArraySplice(self.notifications, index, 1)
    end
    local ____self_notifications_4 = self.notifications
    ____self_notifications_4[#____self_notifications_4 + 1] = notification
    GameEvents.notificationChanged:invoke(notification)
end
function NotificationSystem.prototype.remove(self, notification)
    local index = __TS__ArrayIndexOf(self.notifications, notification)
    if index ~= -1 then
        __TS__ArraySplice(self.notifications, index, 1)
        GameEvents.notificationRemoved:invoke(notification.uid)
    end
end
function NotificationSystem.prototype.get(self, uid)
    for ____, notification in ipairs(self.notifications) do
        if notification.uid == uid then
            return notification
        end
    end
end
function NotificationSystem.prototype.general(self, text, icon)
    self:add(__TS__New(GeneralNotification, text, icon))
end
function NotificationSystem.prototype.obtainItem(self, item)
    for ____, notification in ipairs(self.notifications) do
        if notification.type == NotificationType.Item and notification.item.entityID == item.entityID then
            local ____notification_item_5, ____quantity_6 = notification.item, "quantity"
            ____notification_item_5[____quantity_6] = ____notification_item_5[____quantity_6] + item.quantity
            self:bringToFront(notification)
            notification.timer:restart()
            return
        end
    end
    self:add(__TS__New(
        ItemNotification,
        item:copy()
    ))
end
function NotificationSystem.prototype.handleDiscoverResource(self, item)
    self:add(__TS__New(ResourceNotification, item))
end
function NotificationSystem.prototype.handleFinishResearch(self, technology)
    self:add(__TS__New(ResearchNotification, technology))
end
function NotificationSystem.prototype.handleInvasion(self)
    self:add(__TS__New(InvasionNotification))
end
if _G.NotificationSystem == nil then
    _G.NotificationSystem = __TS__New(NotificationSystem)
end
local manager = _G.NotificationSystem
____exports.NotificationSystem = manager
____exports.NotificationType = NotificationType
____exports.BaseNotification = BaseNotification
____exports.ResourceNotification = ResourceNotification
return ____exports
