local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 1,["10"] = 2,["11"] = 2,["12"] = 3,["13"] = 3,["14"] = 7,["15"] = 7,["16"] = 7,["17"] = 15,["18"] = 7,["19"] = 12,["20"] = 13,["21"] = 17,["22"] = 18,["23"] = 19,["24"] = 15,["25"] = 22,["26"] = 23,["27"] = 24,["28"] = 25,["29"] = 25,["30"] = 25,["31"] = 25,["32"] = 25,["33"] = 25,["34"] = 25,["35"] = 26,["36"] = 27,["37"] = 28,["38"] = 29,["39"] = 22,["40"] = 32,["41"] = 33,["42"] = 35,["43"] = 36,["44"] = 36,["45"] = 36,["46"] = 36,["47"] = 36,["48"] = 37,["49"] = 38,["50"] = 39,["51"] = 40,["52"] = 40,["53"] = 40,["54"] = 40,["55"] = 41,["56"] = 43,["57"] = 44,["58"] = 45,["59"] = 45,["60"] = 45,["61"] = 45,["62"] = 45,["63"] = 45,["64"] = 46,["65"] = 47,["66"] = 49,["67"] = 50,["68"] = 51,["69"] = 51,["70"] = 51,["71"] = 51,["72"] = 51,["73"] = 51,["74"] = 52,["75"] = 53,["76"] = 55,["77"] = 56,["78"] = 57,["79"] = 57,["80"] = 57,["81"] = 57,["82"] = 57,["83"] = 57,["84"] = 58,["85"] = 59,["86"] = 61,["87"] = 62,["88"] = 63,["89"] = 64,["90"] = 64,["91"] = 64,["92"] = 64,["93"] = 64,["94"] = 64,["95"] = 65,["96"] = 32,["97"] = 68,["98"] = 69,["99"] = 70,["100"] = 71,["101"] = 74,["102"] = 75,["103"] = 78,["104"] = 79,["106"] = 82,["107"] = 83,["109"] = 86,["110"] = 68,["111"] = 89,["112"] = 90,["113"] = 91,["114"] = 92,["116"] = 95,["117"] = 96,["118"] = 97,["120"] = 100,["121"] = 101,["122"] = 102,["124"] = 104,["125"] = 105,["127"] = 108,["128"] = 110,["129"] = 89,["130"] = 113,["131"] = 114,["132"] = 115,["135"] = 118,["136"] = 119,["137"] = 120,["139"] = 122,["140"] = 122,["142"] = 123,["143"] = 124,["144"] = 125,["145"] = 126,["147"] = 129,["148"] = 130,["149"] = 131,["151"] = 133,["155"] = 122,["158"] = 113,["159"] = 138,["160"] = 139,["161"] = 140,["162"] = 141,["163"] = 141,["164"] = 141,["165"] = 141,["166"] = 141,["167"] = 141,["168"] = 138,["169"] = 144,["170"] = 145,["171"] = 146,["172"] = 147,["173"] = 148,["174"] = 144,["175"] = 151,["176"] = 152,["177"] = 153,["178"] = 155,["179"] = 156,["180"] = 157,["182"] = 159,["183"] = 151,["184"] = 162,["185"] = 163,["186"] = 164,["187"] = 165,["188"] = 166,["190"] = 162,["191"] = 170,["192"] = 171,["193"] = 170,["194"] = 175});
local ____exports = {}
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local getOppositeDirection = ____direction.getOppositeDirection
local ____core = require("core")
local core = ____core.core
local ____base = require("ui.base")
local EntityDialogUI = ____base.EntityDialogUI
local FilterUi = __TS__Class()
FilterUi.name = "FilterUi"
__TS__ClassExtends(FilterUi, EntityDialogUI)
function FilterUi.prototype.____constructor(self, player, viewId, title)
    EntityDialogUI.prototype.____constructor(self, player)
    self.arrows = {}
    self.rotateCallbackID = 0
    self.viewId = viewId
    self.title = title
    self:initialize()
end
function FilterUi.prototype.initialize(self)
    self:create("Filter", self.title, self.viewId, DialogPlacement.Right)
    local sections = {}
    local content = Section.new(
        SectionType.Content,
        "content",
        PixelVector.new(150, 150),
        Padding.new(10),
        false
    )
    self.dialog:associate(content)
    sections[#sections + 1] = content
    self.dialog:initialize(sections, DialogFeatures.Closable)
    self:populateContent()
end
function FilterUi.prototype.populateContent(self)
    local content = self.dialog:getElement("content")
    local itemGroup = content:associate(ElementGroup.new("itemslot"))
    local background = itemGroup:add(
        Image.new("simpleBackground"),
        Alignment.Left,
        Padding.new()
    )
    background.onShowTooltip:listen(core.cb(self, "onShowTooltip"))
    background.onActivate:listen(core.cb(self, "onActivateItem"))
    background.onSecondaryActivate:listen(core.cb(self, "onSecondaryActivateItem"))
    self.icon = itemGroup:add(
        Image.new("icon", "large_gold_chest_icon"),
        Alignment.Center
    )
    content:add(itemGroup, Alignment.Center)
    local upArrow = content:associate(ElementGroup.new("up_arrow"))
    upArrow:add(Image.new("arrow_icon"))
    content:add(
        upArrow,
        Alignment.Top,
        itemGroup,
        Padding.new(0, 0, 5, 0)
    )
    upArrow.onActivate:listen(core.bind(self, "handleChangeOutputPriority", FacingDirection.Up))
    self.arrows[FacingDirection.Up + 1] = upArrow
    local rightArrow = content:associate(ElementGroup.new("right_arrow"))
    rightArrow:add(Image.new("arrow_icon"))
    content:add(
        rightArrow,
        Alignment.Right,
        itemGroup,
        Padding.new(0, 0, 0, 5)
    )
    rightArrow.onActivate:listen(core.bind(self, "handleChangeOutputPriority", FacingDirection.Right))
    self.arrows[FacingDirection.Right + 1] = rightArrow
    local downArrow = content:associate(ElementGroup.new("down_arrow"))
    downArrow:add(Image.new("arrow_icon"))
    content:add(
        downArrow,
        Alignment.Bottom,
        itemGroup,
        Padding.new(5, 0, 0, 0)
    )
    downArrow.onActivate:listen(core.bind(self, "handleChangeOutputPriority", FacingDirection.Down))
    self.arrows[FacingDirection.Down + 1] = downArrow
    local leftArrow = content:associate(ElementGroup.new("left_arrow"))
    leftArrow:add(Image.new("arrow_icon"))
    leftArrow.onActivate:listen(core.bind(self, "handleChangeOutputPriority", FacingDirection.Left))
    content:add(
        leftArrow,
        Alignment.Left,
        itemGroup,
        Padding.new(0, 5, 0, 0)
    )
    self.arrows[FacingDirection.Left + 1] = leftArrow
end
function FilterUi.prototype.handleChangeOutputPriority(self, direction, element)
    local entity = EntityManager.get(self.entityID)
    local splitter = entity.splitter
    local placementDirection = entity.placement.direction
    local priority = math.abs(-(direction - placementDirection) % 4 - 1)
    splitter.outputPriority = priority
    if splitter.nextOutput == priority then
        splitter.nextOutput = (priority + 1) % #splitter.outputs
    end
    for ____, arrow in ipairs(self.arrows) do
        arrow:clearClass()
    end
    element:setClass("selected")
end
function FilterUi.prototype.changedEntity(self, entity, previous)
    if previous and self.rotateCallbackID ~= 0 then
        previous.event.rotate:remove(self.rotateCallbackID)
        self.rotateCallbackID = 0
    end
    local event = entity.event
    if event and event.rotate then
        self.rotateCallbackID = event.rotate:listen(core.cb(self, "handleEntityRotate"))
    end
    local item = entity.filter.item
    if item:isEmpty() then
        self.icon:hide()
    else
        self.icon:setAtlas(item:entity().item.icon)
        self.icon:show()
    end
    self:updateArrows(entity)
    self.dialog:resizeToElements(true)
end
function FilterUi.prototype.updateArrows(self, entity)
    local splitter = entity.splitter
    if splitter == nil then
        return
    end
    local direction = entity.placement.direction
    local priority = (direction + splitter.outputPriority - 1) % 4
    local opposite = getOppositeDirection(nil, direction)
    do
        local index = 0
        while index < #self.arrows do
            do
                local arrow = self.arrows[index + 1]
                if index == opposite then
                    arrow:hide()
                    goto __continue16
                end
                arrow:show()
                if index == priority then
                    arrow:setClass("selected")
                else
                    arrow:clearClass()
                end
            end
            ::__continue16::
            index = index + 1
        end
    end
end
function FilterUi.prototype.onActivateItem(self)
    local entity = EntityManager.get(self.entityID)
    local modal = UIManager.get("Modal")
    modal:openItems(
        self,
        core.cb(self, "onSelectedItem"),
        entity.filter.filter,
        false
    )
end
function FilterUi.prototype.onSecondaryActivateItem(self)
    local entity = EntityManager.get(self.entityID)
    entity.filter.item = Item.new()
    entity.splitter.outputPriority = SplitterPriority.None
    self:changedEntity(entity)
end
function FilterUi.prototype.onSelectedItem(self, item)
    local entity = EntityManager.get(self.entityID)
    entity.filter.item = item
    local splitter = entity.splitter
    if splitter and splitter.outputPriority == SplitterPriority.None then
        splitter.outputPriority = SplitterPriority.Left
    end
    self:changedEntity(entity)
end
function FilterUi.prototype.onShowTooltip(self, element)
    local entity = EntityManager.get(self.entityID)
    local item = entity.filter.item
    if not item:isEmpty() then
        UIManager.get("Tooltip"):showItem(element, item)
    end
end
function FilterUi.prototype.handleEntityRotate(self, player, entity)
    self:updateArrows(entity)
end
____exports.FilterUi = FilterUi
return ____exports
