local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 5,["7"] = 5,["8"] = 11,["9"] = 7,["10"] = 8,["11"] = 9,["12"] = 12,["13"] = 11,["14"] = 15,["15"] = 16,["16"] = 17,["17"] = 18,["18"] = 20,["19"] = 21,["20"] = 22,["21"] = 23,["22"] = 24,["23"] = 25,["24"] = 26,["25"] = 27,["26"] = 28,["27"] = 29,["28"] = 30,["29"] = 31,["31"] = 33,["32"] = 36,["33"] = 37,["34"] = 38,["35"] = 40,["36"] = 41,["37"] = 42,["38"] = 43,["40"] = 45,["41"] = 46,["42"] = 47,["43"] = 48,["45"] = 50,["48"] = 53,["49"] = 54,["50"] = 55,["51"] = 56,["53"] = 58,["54"] = 60,["55"] = 61,["56"] = 62,["57"] = 64,["58"] = 65,["60"] = 68,["61"] = 69,["62"] = 70,["63"] = 71,["64"] = 72,["66"] = 74,["67"] = 75,["68"] = 76,["69"] = 77,["70"] = 78,["71"] = 81,["72"] = 82,["75"] = 86,["76"] = 87,["77"] = 88,["78"] = 89,["79"] = 90,["80"] = 91,["83"] = 95,["84"] = 96,["85"] = 97,["87"] = 99,["89"] = 101,["91"] = 104,["92"] = 105,["93"] = 106,["95"] = 109,["96"] = 111,["97"] = 112,["100"] = 15,["101"] = 117,["102"] = 118,["103"] = 119,["104"] = 120,["105"] = 122,["106"] = 123,["107"] = 124,["108"] = 125,["109"] = 126,["110"] = 127,["111"] = 128,["112"] = 129,["113"] = 129,["114"] = 129,["115"] = 129,["116"] = 130,["118"] = 132,["119"] = 133,["120"] = 134,["121"] = 135,["123"] = 138,["124"] = 138,["126"] = 117,["127"] = 141,["128"] = 142,["129"] = 143,["131"] = 146,["132"] = 147,["134"] = 151,["135"] = 141,["136"] = 154,["137"] = 155,["138"] = 154,["139"] = 161,["140"] = 162,["141"] = 163,["142"] = 164,["143"] = 165,["145"] = 161,["146"] = 169,["147"] = 170,["150"] = 174,["153"] = 177,["154"] = 178,["157"] = 182,["158"] = 183,["161"] = 187,["162"] = 188,["163"] = 189,["165"] = 169,["166"] = 194});
local ____exports = {}
local ItemInteractionUI = __TS__Class()
ItemInteractionUI.name = "ItemInteractionUI"
function ItemInteractionUI.prototype.____constructor(self, playerID)
    self.entityID = INVALID_ENTITYID
    self.placement = DialogPlacement.Right
    self.canLockSlots = true
    self.playerID = playerID
end
function ItemInteractionUI.prototype.onActivateItem(self, name, index, element)
    local inventory = EntityManager.get(self.entityID).inventory:get(name)
    local playerEntity = EntityManager.get(self.playerID)
    local player = playerEntity.player
    local modifier = InputManager.getModifier()
    local isAltPressed = bit.band(modifier, KeyModifier.MOD_LALT) == KeyModifier.MOD_LALT or bit.band(modifier, KeyModifier.MOD_RALT) == KeyModifier.MOD_RALT
    if bit.band(modifier, KeyModifier.MOD_LSHIFT) == KeyModifier.MOD_LSHIFT or bit.band(modifier, KeyModifier.MOD_RSHIFT) == KeyModifier.MOD_RSHIFT then
        self:transfer(inventory, index, InventoryTransferScope.Stack, InventoryTransferAmount.Full)
    elseif bit.band(modifier, KeyModifier.MOD_LCTRL) == KeyModifier.MOD_LCTRL or bit.band(modifier, KeyModifier.MOD_RCTRL) == KeyModifier.MOD_RCTRL then
        self:transfer(inventory, index, InventoryTransferScope.Inventory, InventoryTransferAmount.Full)
    elseif self.canLockSlots and isAltPressed and player.grabbed:isEmpty() then
        if inventory:isLocked(index) then
            inventory:unlock(index)
            inventory:sort()
        elseif not inventory.items[index + 1]:isEmpty() then
            inventory:lock(index)
        end
    elseif bit.band(inventory.features, InventoryFeatures.Withdraw) == InventoryFeatures.Withdraw and player.grabbed:isEmpty() or bit.band(inventory.features, InventoryFeatures.Deposit) == InventoryFeatures.Deposit and inventory:check(player.grabbed) then
        local grabbedIndex = player.grabbedIndex
        player.grabbedIndex = nil
        local item = inventory.items[index + 1]
        if item.entityID == player.grabbed.entityID and not player.grabbed:isEmpty() then
            audio.start("event:/UI/UI_INVENTORY_PLACE")
            if index == grabbedIndex and self.playerID == self.entityID then
                player.grabbed = Item.new()
            else
                inventory:stack(index, player.grabbed)
                if player.grabbed:isEmpty() then
                    player.grabbed:clear()
                    player.grabbed = Item.new()
                else
                    player.grabbedIndex = grabbedIndex
                end
            end
        elseif self.playerID == self.entityID and player.grabbed:isEmpty() and not item:isEmpty() then
            audio.start("event:/UI/UI_INVENTORY_GRAB")
            player.grabbed = item
            player.grabbedIndex = index
        else
            audio.start("event:/UI/UI_INVENTORY_PLACE")
            local itemWasEmpty = item:isEmpty()
            local grabbedWasEmpty = player.grabbed:isEmpty()
            inventory:swap(index, player.grabbed)
            if not grabbedWasEmpty and isAltPressed and self.canLockSlots then
                inventory:lock(index)
            end
            if player.grabbed:isEmpty() then
                if grabbedIndex then
                    local playerInventory = playerEntity.inventory:get()
                    playerInventory:changed(grabbedIndex, player.grabbed)
                    playerInventory:unlock(grabbedIndex)
                end
                player.grabbed:clear()
                player.grabbed = Item.new()
            elseif self.playerID == self.entityID then
                player.grabbedIndex = grabbedIndex
            elseif itemWasEmpty and not player.grabbed:isEmpty() then
                player.grabbedIndex = grabbedIndex
                grabbedIndex = nil
            end
        end
        if grabbedIndex ~= player.grabbedIndex then
            if grabbedIndex and not player.wasGrabbedLocked then
                playerEntity.inventory:get():unlock(grabbedIndex)
                inventory:sort()
                if self.entityID ~= self.playerID then
                    playerEntity.inventory:get():sort()
                end
            end
            if player.grabbedIndex then
                player.wasGrabbedLocked = inventory:isLocked(player.grabbedIndex)
                inventory:lock(player.grabbedIndex)
            else
                player.wasGrabbedLocked = false
            end
            player.onGrabbedChange:invoke(player.grabbed, grabbedIndex, player.grabbedIndex)
        end
        if grabbedIndex then
            local playerInventory = playerEntity.inventory:get()
            playerInventory:changed(grabbedIndex, playerInventory.items[grabbedIndex + 1])
        end
        inventory:sort()
        if not item:isEmpty() then
            UIManager.setCursor(CursorType.ItemGrab)
        end
    end
end
function ItemInteractionUI.prototype.onSecondaryActivateItem(self, name, index, element)
    local inventory = EntityManager.get(self.entityID).inventory:get(name)
    local player = EntityManager.get(self.playerID).player
    local item = inventory.items[index + 1]
    local modifier = InputManager.getModifier()
    if bit.band(modifier, KeyModifier.MOD_LSHIFT) == KeyModifier.MOD_LSHIFT or bit.band(modifier, KeyModifier.MOD_RSHIFT) == KeyModifier.MOD_RSHIFT then
        self:transfer(inventory, index, InventoryTransferScope.Stack, InventoryTransferAmount.Half)
    elseif bit.band(modifier, KeyModifier.MOD_LCTRL) == KeyModifier.MOD_LCTRL or bit.band(modifier, KeyModifier.MOD_RCTRL) == KeyModifier.MOD_RCTRL then
        self:transfer(inventory, index, InventoryTransferScope.Inventory, InventoryTransferAmount.Half)
    elseif bit.band(modifier, KeyModifier.MOD_LALT) == KeyModifier.MOD_LALT or bit.band(modifier, KeyModifier.MOD_RALT) == KeyModifier.MOD_RALT then
        if self.canLockSlots and inventory.items[index + 1]:isEmpty() and not player.grabbed:isEmpty() then
            inventory:set(
                index,
                Item.new(player.grabbed.entityID, 0)
            )
            inventory:lock(index)
        end
    elseif player.grabbed:isEmpty() then
        inventory:grabHalfStack(index, player.grabbed)
    elseif self:canDeposit(inventory, item, player) then
        inventory:addOne(index, player.grabbed)
    end
    if player.grabbed.quantity == 0 then
        player.grabbed:clear()
    end
end
function ItemInteractionUI.prototype.canDeposit(self, inventory, item, player)
    if not inventory:isDepositable() then
        return false
    end
    if not inventory:canAdd(player.grabbed, InventoryFeatures.Deposit) then
        return false
    end
    return item:isEmpty() or not item:isEmpty() and item.entityID == player.grabbed.entityID and item.quantity < inventory:getStackSize(item)
end
function ItemInteractionUI.prototype.itemMatches(self, inventory, item, player)
    return item:isEmpty() or not item:isEmpty() and item.entityID == player.grabbed.entityID and item.quantity < inventory:getStackSize(item)
end
function ItemInteractionUI.prototype.onShowTooltip(self, name, index, element)
    local inventory = EntityManager.get(self.entityID).inventory:get(name)
    local item = inventory.items[index + 1]
    if not item:isEmpty() then
        UIManager.get("Tooltip"):showItem(element, item)
    end
end
function ItemInteractionUI.prototype.transfer(self, inventory, index, scope, amount)
    if bit.band(inventory.features, InventoryFeatures.Withdraw) ~= InventoryFeatures.Withdraw then
        return
    end
    if inventory.items[index + 1]:isEmpty() then
        return
    end
    local dialog = UIManager.getOtherDialog(self.placement)
    if dialog == nil or dialog.entityID == nil then
        return
    end
    local entity = EntityManager.get(dialog.entityID)
    if entity == nil then
        return
    end
    local otherInventory = entity.inventory
    if otherInventory ~= nil then
        inventory:transfer(index, otherInventory, scope, amount)
    end
end
____exports.ItemInteractionUI = ItemInteractionUI
return ____exports
