local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 3,["10"] = 3,["11"] = 3,["12"] = 8,["13"] = 3,["14"] = 10,["15"] = 12,["16"] = 13,["17"] = 13,["18"] = 13,["19"] = 13,["20"] = 14,["21"] = 14,["22"] = 14,["23"] = 14,["24"] = 14,["25"] = 15,["26"] = 15,["27"] = 15,["28"] = 15,["29"] = 15,["30"] = 15,["31"] = 15,["32"] = 15,["33"] = 15,["34"] = 8,["35"] = 18,["36"] = 19,["37"] = 20,["38"] = 21,["39"] = 22,["40"] = 23,["41"] = 24,["42"] = 25,["44"] = 27,["45"] = 28,["46"] = 29,["47"] = 18,["48"] = 32,["49"] = 33,["50"] = 32,["51"] = 36,["52"] = 37,["53"] = 36,["54"] = 41});
local ____exports = {}
local ____module = require("ui.modules.module")
local ModuleUI = ____module.ModuleUI
local FluidQuantityModuleUI = __TS__Class()
FluidQuantityModuleUI.name = "FluidQuantityModuleUI"
__TS__ClassExtends(FluidQuantityModuleUI, ModuleUI)
function FluidQuantityModuleUI.prototype.____constructor(self, parent, label, fluidType)
    ModuleUI.prototype.____constructor(self)
    self.fluidType = fluidType
    self.element = parent:associate(ElementGroup.new("progress-module"))
    self.element:add(
        Label.new("name", label),
        Alignment.TopLeft
    )
    self.bar = self.element:addRelative(
        Bar.new("progress", 200, 0),
        Alignment.BottomLeft,
        pad.top(4)
    )
    self.quantity = self.element:addRelative(
        Label.new(
            "quantity",
            "999",
            PixelVector.new(24, 0)
        ),
        Alignment.TopRight,
        pad.bottom(4)
    )
end
function FluidQuantityModuleUI.prototype.updateBar(self, entity)
    local source = entity.fluidSource
    local quantity = source.quantity
    local capacity = source.capacity
    if self.fluidType then
        local output = source.outputs[source:get(self.fluidType) + 1]
        quantity = output.quantity
        capacity = output.capacity
    end
    self.quantity:setText(tostring(quantity))
    local percentage = quantity / capacity
    self.bar:set(percentage)
end
function FluidQuantityModuleUI.prototype.changedEntity(self, entity, previous)
    self:updateBar(entity)
end
function FluidQuantityModuleUI.prototype.update(self, frameTime, player, entity)
    self:updateBar(entity)
end
____exports.FluidQuantityModuleUI = FluidQuantityModuleUI
return ____exports
