local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 5,["14"] = 5,["15"] = 7,["16"] = 9,["17"] = 9,["18"] = 9,["19"] = 16,["20"] = 9,["21"] = 18,["22"] = 18,["23"] = 18,["24"] = 18,["25"] = 18,["26"] = 19,["27"] = 21,["28"] = 22,["29"] = 23,["30"] = 23,["31"] = 23,["32"] = 23,["33"] = 23,["34"] = 24,["35"] = 24,["36"] = 24,["37"] = 24,["38"] = 24,["39"] = 24,["40"] = 24,["41"] = 24,["42"] = 24,["43"] = 25,["44"] = 26,["45"] = 28,["46"] = 29,["47"] = 29,["48"] = 29,["49"] = 29,["50"] = 29,["51"] = 30,["52"] = 30,["53"] = 30,["54"] = 30,["55"] = 30,["56"] = 30,["57"] = 30,["58"] = 30,["59"] = 30,["60"] = 31,["61"] = 32,["62"] = 32,["63"] = 32,["64"] = 32,["65"] = 32,["66"] = 34,["67"] = 35,["68"] = 35,["69"] = 35,["70"] = 35,["71"] = 35,["72"] = 36,["73"] = 36,["74"] = 36,["75"] = 36,["76"] = 36,["77"] = 36,["78"] = 36,["79"] = 36,["80"] = 36,["81"] = 37,["82"] = 38,["83"] = 38,["84"] = 38,["85"] = 38,["86"] = 38,["87"] = 40,["88"] = 42,["89"] = 43,["90"] = 44,["91"] = 44,["92"] = 44,["93"] = 44,["94"] = 44,["95"] = 45,["96"] = 45,["97"] = 45,["98"] = 45,["99"] = 45,["100"] = 45,["101"] = 45,["102"] = 45,["103"] = 45,["104"] = 46,["105"] = 47,["106"] = 49,["107"] = 50,["108"] = 50,["109"] = 50,["110"] = 50,["111"] = 50,["112"] = 51,["113"] = 51,["114"] = 51,["115"] = 51,["116"] = 51,["117"] = 51,["118"] = 51,["119"] = 51,["120"] = 51,["121"] = 52,["122"] = 53,["123"] = 53,["124"] = 53,["125"] = 53,["126"] = 53,["127"] = 55,["128"] = 56,["129"] = 16,["130"] = 59,["131"] = 60,["132"] = 61,["133"] = 59,["134"] = 64,["135"] = 65,["136"] = 64,["137"] = 68,["138"] = 69,["139"] = 70,["140"] = 71,["141"] = 72,["142"] = 73,["143"] = 73,["144"] = 73,["145"] = 73,["146"] = 74,["147"] = 75,["148"] = 76,["149"] = 78,["150"] = 79,["151"] = 80,["153"] = 82,["154"] = 84,["155"] = 85,["156"] = 86,["158"] = 88,["159"] = 90,["160"] = 91,["162"] = 93,["163"] = 94,["164"] = 95,["165"] = 96,["166"] = 97,["168"] = 99,["169"] = 68,["170"] = 102,["171"] = 103,["172"] = 102,["173"] = 107});
local ____exports = {}
local ____core = require("core")
local core = ____core.core
local ____utility = require("utility")
local getPowerString = ____utility.getPowerString
local ____world = require("world")
local World = ____world.World
local ____module = require("ui.modules.module")
local ModuleUI = ____module.ModuleUI
local POWER_PER_MINUTE_MULTIPLIER = 60000 / 250
local PowerModuleUI = __TS__Class()
PowerModuleUI.name = "PowerModuleUI"
__TS__ClassExtends(PowerModuleUI, ModuleUI)
function PowerModuleUI.prototype.____constructor(self, parent)
    ModuleUI.prototype.____constructor(self)
    self.element = parent:associate(Panel.new(
        "power-module",
        PixelVector.new(),
        Padding.new(7)
    ))
    local group = self.element:associate(ElementGroup.new("group"))
    local column = group:associate(ElementGroup.new("column"))
    self.production = column:associate(ElementGroup.new("production-group"))
    self.production:add(
        Image.new("icon", "autoforge_window_power_value"),
        Alignment.TopLeft,
        pad.left(7)
    )
    self.production:addRelative(
        Label.new(
            "stat",
            "",
            PixelVector.new(60, 0)
        ),
        Alignment.Right,
        pad.left(7)
    )
    self.production.onShowTooltip:listen(core.bind(self, "onShowTooltip", "UIPowerProductionHeader", "UIPowerProductionInfo"))
    column:add(self.production, Alignment.TopLeft)
    self.stored = column:associate(ElementGroup.new("stored-group"))
    self.stored:add(
        Image.new("icon", "autoforge_window_energy_value"),
        Alignment.TopLeft,
        pad.left(7)
    )
    self.stored:addRelative(
        Label.new(
            "stat",
            "",
            PixelVector.new(60, 0)
        ),
        Alignment.Right,
        pad.left(7)
    )
    self.stored.onShowTooltip:listen(core.bind(self, "onShowTooltip", "UIPowerStoredHeader", "UIPowerStoredInfo"))
    column:addRelative(
        self.stored,
        Alignment.BottomLeft,
        pad.top(7)
    )
    self.network = column:associate(ElementGroup.new("network-group"))
    self.network:add(
        Image.new("icon", "autoforge_window_power_network"),
        Alignment.TopLeft,
        pad.left(7)
    )
    self.network:addRelative(
        Label.new(
            "stat",
            "",
            PixelVector.new(60, 0)
        ),
        Alignment.Right,
        pad.left(7)
    )
    self.network.onShowTooltip:listen(core.bind(self, "onShowTooltip", "UIPowerNetworkHeader", "UIPowerNetworkInfo"))
    column:addRelative(
        self.network,
        Alignment.BottomLeft,
        pad.top(7)
    )
    group:add(column, Alignment.TopLeft)
    column = group:associate(ElementGroup.new("column"))
    self.demand = column:associate(ElementGroup.new("demand-group"))
    self.demand:add(
        Image.new("icon", "autoforge_window_production_value_2"),
        Alignment.TopLeft,
        pad.left(7)
    )
    self.demand:addRelative(
        Label.new(
            "stat",
            "",
            PixelVector.new(60, 0)
        ),
        Alignment.Right,
        pad.left(7)
    )
    self.demand.onShowTooltip:listen(core.bind(self, "onShowTooltip", "UIPowerDemandHeader", "UIPowerDemandInfo"))
    column:add(self.demand, Alignment.TopLeft)
    self.percentage = column:associate(ElementGroup.new("percentage-group"))
    self.percentage:add(
        Image.new("icon", "autoforge_window_production_value_1"),
        Alignment.TopLeft,
        pad.left(7)
    )
    self.percentage:addRelative(
        Label.new(
            "stat",
            "",
            PixelVector.new(60, 0)
        ),
        Alignment.Right,
        pad.left(7)
    )
    self.percentage.onShowTooltip:listen(core.bind(self, "onShowTooltip", "UIPowerPercentageHeader", "UIPowerPercentageInfo"))
    column:addRelative(
        self.percentage,
        Alignment.BottomLeft,
        pad.top(7)
    )
    group:addRelative(column, Alignment.RightTop)
    self.element:add(group, Alignment.Top)
end
function PowerModuleUI.prototype.changedEntity(self, entity, previous)
    self.stored:setVisible(entity.producer ~= nil and entity.producer.capacity > 0)
    self:updateInfo(entity)
end
function PowerModuleUI.prototype.update(self, frameTime, player, entity)
    self:updateInfo(entity)
end
function PowerModuleUI.prototype.updateInfo(self, entity)
    local power = World:get(entity.location.realm).power
    local network = power.networks:get(entity.distributor.network)
    if network then
        local producer = entity.producer
        local percentage = network.demand == 0 and 100 or math.min(
            math.floor(network.production / network.demand * 100),
            100
        )
        self.network:getElement("stat"):setText(getPowerString(nil, network.production * POWER_PER_MINUTE_MULTIPLIER))
        self.demand:getElement("stat"):setText(getPowerString(nil, network.demand * POWER_PER_MINUTE_MULTIPLIER))
        self.percentage:getElement("stat"):setText(tostring(percentage) .. "%")
        local generating = producer ~= nil and producer.generate > 0
        if generating then
            self.production:getElement("stat"):setText(getPowerString(nil, producer.generate * POWER_PER_MINUTE_MULTIPLIER))
        end
        self.production:setVisible(producer ~= nil)
        local storing = producer ~= nil and producer.capacity > 0
        if storing then
            self.stored:getElement("stat"):setText(getPowerString(nil, producer.stored * POWER_PER_MINUTE_MULTIPLIER))
        end
        self.stored:setVisible(storing)
        self.demand:show()
        self.percentage:show()
    else
        self.network:getElement("stat"):setText("DistributorNotConnected")
        self.production:hide()
        self.demand:hide()
        self.percentage:hide()
        self.stored:hide()
    end
    self.element:resizeToElements(true)
end
function PowerModuleUI.prototype.onShowTooltip(self, header, text, element)
    UIManager.get("Tooltip"):showText(element, header, text)
end
____exports.PowerModuleUI = PowerModuleUI
return ____exports
