local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 2,["12"] = 4,["13"] = 4,["14"] = 7,["15"] = 7,["16"] = 7,["17"] = 13,["18"] = 7,["19"] = 8,["20"] = 9,["21"] = 10,["22"] = 11,["23"] = 15,["24"] = 15,["25"] = 15,["26"] = 15,["27"] = 15,["28"] = 16,["29"] = 16,["30"] = 16,["31"] = 16,["32"] = 18,["33"] = 18,["34"] = 18,["35"] = 18,["36"] = 19,["37"] = 19,["38"] = 19,["39"] = 19,["40"] = 19,["41"] = 21,["42"] = 22,["43"] = 23,["44"] = 23,["45"] = 23,["46"] = 23,["47"] = 23,["48"] = 23,["49"] = 24,["50"] = 25,["51"] = 26,["52"] = 28,["53"] = 29,["54"] = 30,["55"] = 30,["56"] = 30,["57"] = 30,["58"] = 30,["59"] = 30,["60"] = 31,["61"] = 32,["62"] = 33,["63"] = 35,["64"] = 36,["65"] = 37,["66"] = 37,["67"] = 37,["68"] = 37,["69"] = 37,["70"] = 37,["71"] = 38,["72"] = 39,["73"] = 40,["74"] = 42,["75"] = 43,["76"] = 44,["77"] = 44,["78"] = 44,["79"] = 44,["80"] = 44,["81"] = 44,["82"] = 45,["83"] = 46,["84"] = 47,["85"] = 50,["86"] = 51,["87"] = 52,["88"] = 52,["89"] = 52,["90"] = 52,["91"] = 52,["92"] = 52,["93"] = 53,["94"] = 54,["95"] = 55,["96"] = 57,["97"] = 58,["98"] = 59,["99"] = 59,["100"] = 59,["101"] = 59,["102"] = 59,["103"] = 59,["104"] = 60,["105"] = 61,["106"] = 62,["107"] = 64,["108"] = 65,["109"] = 66,["110"] = 66,["111"] = 66,["112"] = 66,["113"] = 66,["114"] = 66,["115"] = 67,["116"] = 68,["117"] = 69,["118"] = 71,["119"] = 72,["120"] = 73,["121"] = 73,["122"] = 73,["123"] = 73,["124"] = 73,["125"] = 73,["126"] = 74,["127"] = 75,["128"] = 76,["129"] = 78,["130"] = 79,["132"] = 13,["133"] = 83,["134"] = 84,["135"] = 86,["136"] = 87,["137"] = 88,["139"] = 91,["140"] = 92,["141"] = 93,["143"] = 96,["144"] = 83,["145"] = 99,["146"] = 100,["147"] = 101,["148"] = 102,["149"] = 105,["150"] = 106,["151"] = 107,["152"] = 108,["155"] = 112,["156"] = 115,["157"] = 116,["159"] = 119,["160"] = 120,["162"] = 123,["163"] = 99,["164"] = 125,["165"] = 126,["166"] = 127,["169"] = 130,["170"] = 131,["171"] = 132,["173"] = 134,["174"] = 134,["176"] = 135,["177"] = 136,["178"] = 138,["179"] = 139,["180"] = 140,["181"] = 141,["183"] = 144,["184"] = 145,["185"] = 146,["186"] = 147,["188"] = 149,["192"] = 134,["195"] = 125,["196"] = 154,["197"] = 155,["198"] = 154,["199"] = 158,["200"] = 159,["201"] = 158,["202"] = 162,["203"] = 163,["204"] = 164,["205"] = 165,["208"] = 168,["209"] = 169,["210"] = 170,["211"] = 162,["212"] = 174});
local ____exports = {}
local ____core = require("core")
local core = ____core.core
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local getOppositeDirection = ____direction.getOppositeDirection
local ____module = require("ui.modules.module")
local ModuleUI = ____module.ModuleUI
local SplitterModuleUI = __TS__Class()
SplitterModuleUI.name = "SplitterModuleUI"
__TS__ClassExtends(SplitterModuleUI, ModuleUI)
function SplitterModuleUI.prototype.____constructor(self, parent)
    ModuleUI.prototype.____constructor(self)
    self.entityID = INVALID_ENTITYID
    self.arrows = {}
    self.inputArrows = {}
    self.rotateCallbackID = 0
    self.element = parent:associate(Panel.new(
        "subcontent",
        PixelVector.new(),
        Padding.new(7)
    ))
    self.element:add(
        Label.new("subheader", "UiSplitterOutputLabel"),
        Alignment.Top
    )
    local splitterGroup = self.element:associate(ElementGroup.new(
        "splitter-group",
        PixelVector.new(16, 16)
    ))
    self.element:addRelative(
        splitterGroup,
        Alignment.Bottom,
        pad.top(24)
    )
    local upArrow = self.element:associate(ElementGroup.new("up_arrow"))
    upArrow:add(Image.new("arrow_icon"))
    self.element:add(
        upArrow,
        Alignment.Top,
        splitterGroup,
        pad.bottom(4)
    )
    upArrow.onActivate:listen(core.bind(self, "handleChangeOutputPriority", FacingDirection.Up))
    upArrow.onShowTooltip:listen(core.bind(self, "onShowTooltipOutput", FacingDirection.Up))
    self.arrows[FacingDirection.Up + 1] = upArrow
    local rightArrow = self.element:associate(ElementGroup.new("right_arrow"))
    rightArrow:add(Image.new("arrow_icon"))
    self.element:add(
        rightArrow,
        Alignment.Right,
        splitterGroup,
        pad.left(4)
    )
    rightArrow.onActivate:listen(core.bind(self, "handleChangeOutputPriority", FacingDirection.Right))
    rightArrow.onShowTooltip:listen(core.bind(self, "onShowTooltipOutput", FacingDirection.Right))
    self.arrows[FacingDirection.Right + 1] = rightArrow
    local downArrow = self.element:associate(ElementGroup.new("down_arrow"))
    downArrow:add(Image.new("arrow_icon"))
    self.element:add(
        downArrow,
        Alignment.Bottom,
        splitterGroup,
        pad.top(4)
    )
    downArrow.onActivate:listen(core.bind(self, "handleChangeOutputPriority", FacingDirection.Down))
    downArrow.onShowTooltip:listen(core.bind(self, "onShowTooltipOutput", FacingDirection.Down))
    self.arrows[FacingDirection.Down + 1] = downArrow
    local leftArrow = self.element:associate(ElementGroup.new("left_arrow"))
    leftArrow:add(Image.new("arrow_icon"))
    self.element:add(
        leftArrow,
        Alignment.Left,
        splitterGroup,
        pad.right(4)
    )
    leftArrow.onActivate:listen(core.bind(self, "handleChangeOutputPriority", FacingDirection.Left))
    leftArrow.onShowTooltip:listen(core.bind(self, "onShowTooltipOutput", FacingDirection.Left))
    self.arrows[FacingDirection.Left + 1] = leftArrow
    local inputUpArrow = self.element:associate(ElementGroup.new("down_arrow"))
    inputUpArrow:add(Image.new("arrow_icon"))
    self.element:add(
        inputUpArrow,
        Alignment.Top,
        splitterGroup,
        pad.bottom(4)
    )
    inputUpArrow:disable()
    inputUpArrow.onShowTooltip:listen(core.cb(self, "onShowTooltipInput"))
    self.inputArrows[FacingDirection.Up + 1] = inputUpArrow
    local inputRightArrow = self.element:associate(ElementGroup.new("left_arrow"))
    inputRightArrow:add(Image.new("arrow_icon"))
    self.element:add(
        inputRightArrow,
        Alignment.Right,
        splitterGroup,
        pad.left(4)
    )
    inputRightArrow:disable()
    inputRightArrow.onShowTooltip:listen(core.cb(self, "onShowTooltipInput"))
    self.inputArrows[FacingDirection.Right + 1] = inputRightArrow
    local inputDownArrow = self.element:associate(ElementGroup.new("up_arrow"))
    inputDownArrow:add(Image.new("arrow_icon"))
    self.element:add(
        inputDownArrow,
        Alignment.Bottom,
        splitterGroup,
        pad.top(4)
    )
    inputDownArrow:disable()
    inputDownArrow.onShowTooltip:listen(core.cb(self, "onShowTooltipInput"))
    self.inputArrows[FacingDirection.Down + 1] = inputDownArrow
    local inputLeftArrow = self.element:associate(ElementGroup.new("right_arrow"))
    inputLeftArrow:add(Image.new("arrow_icon"))
    self.element:add(
        inputLeftArrow,
        Alignment.Left,
        splitterGroup,
        pad.right(4)
    )
    inputLeftArrow:disable()
    inputLeftArrow.onShowTooltip:listen(core.cb(self, "onShowTooltipInput"))
    self.inputArrows[FacingDirection.Left + 1] = inputLeftArrow
    for ____, arrow in ipairs(self.inputArrows) do
        arrow:hide()
    end
end
function SplitterModuleUI.prototype.changedEntity(self, entity, previous)
    self.entityID = entity.id
    if previous and self.rotateCallbackID ~= 0 and previous.event ~= nil and previous.event.rotate ~= nil then
        previous.event.rotate:remove(self.rotateCallbackID)
        self.rotateCallbackID = 0
    end
    local event = entity.event
    if event and event.rotate then
        self.rotateCallbackID = event.rotate:listen(core.cb(self, "handleEntityRotate"))
    end
    self:updateArrows(entity)
end
function SplitterModuleUI.prototype.handleChangeOutputPriority(self, direction, element)
    local entity = EntityManager.get(self.entityID)
    local splitter = entity.splitter
    local placementDirection = entity.placement.direction
    local priority = math.abs(-(direction - placementDirection) % 4 - 1)
    if priority == splitter.outputPriority then
        splitter.outputPriority = SplitterPriority.None
        element:clearClass()
        return
    end
    splitter.outputPriority = priority
    if splitter.nextOutput == priority then
        splitter.nextOutput = (priority + 1) % #splitter.outputs
    end
    for ____, arrow in ipairs(self.arrows) do
        arrow:clearClass()
    end
    element:setClass("selected")
end
function SplitterModuleUI.prototype.updateArrows(self, entity)
    local splitter = entity.splitter
    if splitter == nil then
        return
    end
    local direction = entity.placement.direction
    local priority = (direction + splitter.outputPriority - 1) % 4
    local opposite = getOppositeDirection(nil, direction)
    do
        local index = 0
        while index < #self.arrows do
            do
                local arrow = self.arrows[index + 1]
                local inputArrow = self.inputArrows[index + 1]
                if index == opposite then
                    inputArrow:show()
                    arrow:hide()
                    goto __continue15
                end
                arrow:show()
                inputArrow:hide()
                if index == priority then
                    arrow:setClass("selected")
                else
                    arrow:clearClass()
                end
            end
            ::__continue15::
            index = index + 1
        end
    end
end
function SplitterModuleUI.prototype.handleEntityRotate(self, player, entity)
    self:updateArrows(entity)
end
function SplitterModuleUI.prototype.onShowTooltipInput(self, element)
    UIManager.get("Tooltip"):showSimple(element, "UISplitterInput")
end
function SplitterModuleUI.prototype.onShowTooltipOutput(self, arrowDirection, element)
    local entity = EntityManager.get(self.entityID)
    local splitter = entity.splitter
    if splitter == nil then
        return
    end
    local direction = entity.placement.direction
    local priority = (direction + splitter.outputPriority - 1) % 4
    UIManager.get("Tooltip"):showSimple(element, priority == arrowDirection and "UISplitterClearPriority" or "UISplitterSetPriority")
end
____exports.SplitterModuleUI = SplitterModuleUI
return ____exports
