local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__New = ____lualib.__TS__New
local __TS__SetDescriptor = ____lualib.__TS__SetDescriptor
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["9"] = 1,["10"] = 1,["11"] = 2,["12"] = 2,["13"] = 3,["14"] = 3,["15"] = 4,["16"] = 4,["17"] = 8,["18"] = 8,["19"] = 8,["20"] = 22,["21"] = 8,["22"] = 12,["23"] = 24,["24"] = 22,["29"] = 15,["37"] = 19,["41"] = 27,["42"] = 28,["43"] = 29,["44"] = 30,["45"] = 30,["46"] = 30,["47"] = 30,["48"] = 30,["49"] = 30,["50"] = 30,["51"] = 31,["52"] = 32,["53"] = 33,["54"] = 34,["55"] = 27,["56"] = 37,["57"] = 38,["58"] = 40,["59"] = 41,["60"] = 41,["61"] = 41,["62"] = 41,["63"] = 41,["64"] = 42,["65"] = 42,["66"] = 42,["67"] = 42,["68"] = 43,["69"] = 44,["70"] = 45,["71"] = 45,["72"] = 45,["73"] = 45,["74"] = 46,["75"] = 46,["76"] = 46,["77"] = 46,["78"] = 46,["79"] = 46,["80"] = 46,["81"] = 46,["82"] = 46,["83"] = 47,["84"] = 47,["85"] = 47,["86"] = 47,["87"] = 47,["88"] = 49,["89"] = 37,["90"] = 52,["91"] = 53,["92"] = 55,["93"] = 56,["94"] = 57,["96"] = 59,["97"] = 60,["98"] = 61,["100"] = 52,["101"] = 65,["102"] = 66,["104"] = 66,["105"] = 66,["107"] = 66,["110"] = 8,["111"] = 70,["112"] = 71,["113"] = 72,["115"] = 73,["116"] = 73,["117"] = 74,["118"] = 73,["121"] = 76,["122"] = 65,["123"] = 79,["124"] = 80,["125"] = 81,["126"] = 81,["127"] = 81,["128"] = 81,["129"] = 79,["130"] = 84,["131"] = 85,["132"] = 86,["133"] = 87,["134"] = 88,["135"] = 89,["137"] = 90,["138"] = 90,["139"] = 91,["140"] = 92,["141"] = 93,["142"] = 94,["144"] = 90,["147"] = 97,["149"] = 100,["150"] = 101,["151"] = 102,["153"] = 103,["154"] = 103,["155"] = 104,["156"] = 105,["157"] = 106,["159"] = 103,["162"] = 109,["163"] = 110,["165"] = 113,["166"] = 114,["167"] = 115,["168"] = 84,["169"] = 118,["170"] = 119,["171"] = 118,["172"] = 123});
local ____exports = {}
local ____core = require("core")
local core = ____core.core
local ____item = require("item")
local FluidItem = ____item.FluidItem
local ____world = require("world")
local World = ____world.World
local ____base = require("ui.base")
local EntityDialogUI = ____base.EntityDialogUI
local StorageTankUi = __TS__Class()
StorageTankUi.name = "StorageTankUi"
__TS__ClassExtends(StorageTankUi, EntityDialogUI)
function StorageTankUi.prototype.____constructor(self, player)
    EntityDialogUI.prototype.____constructor(self, player)
    self.item = __TS__New(FluidItem, FluidType.None, 0)
    self:initialize()
end
__TS__SetDescriptor(
    StorageTankUi.prototype,
    "fluidGroup",
    {get = function(self)
        return self._fluidGroup
    end},
    true
)
__TS__SetDescriptor(
    StorageTankUi.prototype,
    "icon",
    {get = function(self)
        return self._icon
    end},
    true
)
function StorageTankUi.prototype.initialize(self)
    self:create("StorageTank", "StorageTank", "StorageTank")
    local sections = {}
    local content = Section.new(
        SectionType.Content,
        "content",
        PixelVector.new(200, 100),
        Padding.new(10),
        false
    )
    self.dialog:associate(content)
    sections[#sections + 1] = content
    self.dialog:initialize(sections, DialogFeatures.Closable)
    self:populateContent()
end
function StorageTankUi.prototype.populateContent(self)
    local content = self.dialog:getElement("content")
    self._fluidGroup = content:associate(ElementGroup.new("fluidGroup"))
    local fluidItem = self.fluidGroup:add(
        ElementGroup.new("itemslot"),
        Alignment.TopLeft,
        Padding.new(5, 0, 0, 0)
    )
    local background = fluidItem:add(
        Image.new("simpleBackground"),
        Alignment.Left
    )
    background.onShowTooltip:listen(core.cb(self, "onShowTooltipFluid"))
    background.onActivate:listen(core.bind(self, "onActivateFluid"))
    self._icon = fluidItem:add(
        Image.new("icon", "large_gold_chest_icon"),
        Alignment.Center
    )
    self.quantity = self.fluidGroup:add(
        Label.new(
            "quantity",
            "999",
            PixelVector.new(24, 0)
        ),
        Alignment.BottomRight,
        Padding.new(0, 2, 2, 0)
    )
    content:add(
        self.fluidGroup,
        Alignment.TopLeft,
        Padding.new(0, 0, 10, 0)
    )
    self.dialog:resizeToElements(true)
end
function StorageTankUi.prototype.changedEntity(self, entity, previous)
    self.dialog:resizeToElements(true)
    local ____type = entity.fluidSource.outputs[1].type
    if ____type == FluidType.None then
        self.icon:hide()
    else
        self.item = __TS__New(FluidItem, ____type, 1)
        self.icon:setAtlas(self.item.icon)
        self.icon:show()
    end
end
function StorageTankUi.prototype.update(self, frameTime)
    local ____temp_2 = self.entityID == INVALID_ENTITYID
    if not ____temp_2 then
        local ____opt_0 = self.view
        ____temp_2 = not (____opt_0 and ____opt_0:isVisible())
    end
    if ____temp_2 then
        return
    end
    EntityDialogUI.prototype.update(self, frameTime)
    local entity = EntityManager.get(self.entityID)
    local quantity = entity.fluidSource.quantity
    local sink = entity.fluidSink
    do
        local i = 0
        while i < #sink.inputs do
            quantity = quantity + sink.inputs[i + 1].quantity
            i = i + 1
        end
    end
    self.quantity:setText(tostring(quantity))
end
function StorageTankUi.prototype.onActivateFluid(self, element)
    local modal = UIManager.get("Modal")
    modal:openFluids(
        self,
        core.cb(self, "onSelectedFluid")
    )
end
function StorageTankUi.prototype.onSelectedFluid(self, result)
    local entity = EntityManager.get(self.entityID)
    local realm = World:get(entity.location.realm)
    local sink = entity.fluidSink
    if sink ~= nil then
        realm.fluid:removeSinkInputs(entity)
        do
            local i = 0
            while i < #sink.inputs do
                local input = sink.inputs[i + 1]
                if input.type ~= FluidType.None then
                    sink:setQuantity(i, 0)
                    input.type = result.type
                end
                i = i + 1
            end
        end
        realm.fluid:addSinkInputs(entity)
    end
    local source = entity.fluidSource
    if source ~= nil then
        realm.fluid:removeSourceOutputs(entity)
        do
            local i = 0
            while i < #source.outputs do
                local output = source.outputs[i + 1]
                if output.type ~= FluidType.None then
                    output.type = result.type
                end
                i = i + 1
            end
        end
        source:setQuantity(0)
        realm.fluid:addSourceOutputs(entity)
    end
    self.item = result
    self.icon:setAtlas(self.item.icon)
    self.icon:show()
end
function StorageTankUi.prototype.onShowTooltipFluid(self, element)
    UIManager.get("Tooltip"):showFluid(element, self.item)
end
____exports.StorageTankUi = StorageTankUi
return ____exports
