local ____lualib = require("lualib_bundle")
local __TS__Iterator = ____lualib.__TS__Iterator
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 4,["9"] = 4,["10"] = 5,["11"] = 5,["12"] = 6,["13"] = 6,["14"] = 9,["15"] = 10,["16"] = 11,["17"] = 12,["18"] = 13,["19"] = 15,["20"] = 16,["21"] = 10,["22"] = 19,["23"] = 19,["24"] = 19,["25"] = 20,["26"] = 20,["27"] = 19,["28"] = 19,["29"] = 23,["30"] = 23,["31"] = 23,["32"] = 24,["33"] = 25,["34"] = 23,["35"] = 23,["36"] = 28,["37"] = 28,["38"] = 28,["39"] = 29,["40"] = 30,["41"] = 31,["42"] = 32,["43"] = 28,["44"] = 28,["45"] = 35,["46"] = 35,["47"] = 35,["48"] = 36,["49"] = 37,["50"] = 38,["51"] = 35,["52"] = 35,["53"] = 41,["54"] = 41,["55"] = 41,["56"] = 42,["57"] = 43,["58"] = 41,["59"] = 41,["60"] = 46,["61"] = 46,["62"] = 46,["63"] = 47,["64"] = 48,["65"] = 46,["66"] = 46,["67"] = 51,["68"] = 51,["69"] = 51,["70"] = 52,["71"] = 52,["72"] = 51,["73"] = 51,["74"] = 55,["75"] = 55,["76"] = 55,["77"] = 56,["78"] = 57,["79"] = 55,["80"] = 55,["81"] = 60,["82"] = 60,["83"] = 60,["84"] = 61,["85"] = 62,["86"] = 60,["87"] = 60,["88"] = 65,["89"] = 65,["90"] = 65,["91"] = 66,["92"] = 67,["93"] = 65,["94"] = 65,["95"] = 70,["96"] = 70,["97"] = 70,["98"] = 71,["99"] = 72,["100"] = 70,["101"] = 70,["102"] = 75,["103"] = 75,["104"] = 75,["105"] = 76,["106"] = 75,["107"] = 75,["108"] = 79,["109"] = 79,["110"] = 79,["111"] = 80,["112"] = 79,["113"] = 79,["114"] = 83,["115"] = 83,["116"] = 83,["117"] = 84,["118"] = 83,["119"] = 83,["120"] = 87,["121"] = 87,["122"] = 87,["123"] = 88,["124"] = 87,["125"] = 87,["126"] = 91,["127"] = 91,["128"] = 91,["129"] = 92,["130"] = 91,["131"] = 91,["132"] = 95,["133"] = 95,["134"] = 95,["135"] = 96,["136"] = 97,["137"] = 95,["138"] = 95,["139"] = 100,["140"] = 100,["141"] = 100,["142"] = 101,["143"] = 102,["145"] = 100,["146"] = 100,["147"] = 9,["148"] = 115});
local ____exports = {}
local ____Sizes = require("Sizes")
local Sizes = ____Sizes.Sizes
local ____upgrades = require("upgrades")
local UpgradeType = ____upgrades.UpgradeType
local ____world = require("world")
local World = ____world.World
local ____loot = require("utility.loot")
local LootOrigin = ____loot.LootOrigin
local function setupUpgrades(self, manager)
    manager:get(UpgradeType.EMPOWER).activate = function(____, entity)
        local hp = entity.stats:get("HP")
        hp:adjust(4)
        hp:setCurrent(hp:get())
        entity.stats:get("HARVEST"):adjust(1)
        entity.stats:get("CRAFT"):adjust(0.25)
    end
    manager:setup(
        {UpgradeType.ROLL},
        function(____, entity)
            local ____entity_input_0, ____maxRolls_1 = entity.input, "maxRolls"
            ____entity_input_0[____maxRolls_1] = ____entity_input_0[____maxRolls_1] + 1
        end
    )
    manager:setup(
        {UpgradeType.SPRINT},
        function(____, entity)
            local stat = entity.stats:get("MOVE")
            stat:adjust(0.1)
        end
    )
    manager:setup(
        {UpgradeType.CARRY, UpgradeType.CARRY_II, UpgradeType.CARRY_III},
        function(____, entity)
            local inventory = entity.inventory:get()
            inventory:resize(inventory.size + 10)
            local dialog = UIManager.get("Inventory")
            dialog:populateDialog()
        end
    )
    manager:setup(
        {UpgradeType.CRYSTALIZE, UpgradeType.CRYSTALIZE_II},
        function(____, entity)
            local hp = entity.stats:get("HP")
            hp:adjust(4)
            hp:setCurrent(hp:get())
        end
    )
    manager:setup(
        {UpgradeType.TERRAFORM, UpgradeType.TERRAFORM_II},
        function(____, entity)
            local stat = entity.stats:get("HARVEST")
            stat:adjust(1)
        end
    )
    manager:setup(
        {UpgradeType.REACH, UpgradeType.REACH_II},
        function(____, entity)
            local stat = entity.stats:get("REACH")
            stat:adjust(Sizes.TILE * 4)
        end
    )
    manager:setup(
        {UpgradeType.EXCAVATE, UpgradeType.EXCAVATE_II},
        function(____, entity)
            local ____entity_player_2, ____maxBuildRadius_3 = entity.player, "maxBuildRadius"
            ____entity_player_2[____maxBuildRadius_3] = ____entity_player_2[____maxBuildRadius_3] + 1
        end
    )
    manager:setup(
        {UpgradeType.STRIKE, UpgradeType.STRIKE_II},
        function(____, entity)
            local stat = entity.stats:get("ATK")
            stat:adjust(2)
        end
    )
    manager:setup(
        {UpgradeType.HARDEN},
        function(____, entity)
            local stat = entity.stats:get("DEF")
            stat:adjust(2)
        end
    )
    manager:setup(
        {UpgradeType.BLAST, UpgradeType.BLAST_II},
        function(____, entity)
            local stat = entity.stats:get("RNG")
            stat:adjust(2)
        end
    )
    manager:setup(
        {UpgradeType.OVERCLOCK, UpgradeType.OVERCLOCK_II},
        function(____, entity)
            local stat = entity.stats:get("CRAFT")
            stat:adjust(0.25)
        end
    )
    manager:setup(
        {UpgradeType.ORGANIZE},
        function(____, entity)
            entity.inventory:get().stackMultiplier = 1.5
        end
    )
    manager:setup(
        {UpgradeType.VERIFY},
        function(____, entity)
            World.lootBonuses:set(LootOrigin.Monster, true)
        end
    )
    manager:setup(
        {UpgradeType.SCAVENGE},
        function(____, entity)
            World.lootBonuses:set(LootOrigin.Spawner, true)
        end
    )
    manager:setup(
        {UpgradeType.FORAGE},
        function(____, entity)
            World.lootBonuses:set(LootOrigin.Plant, true)
        end
    )
    manager:setup(
        {UpgradeType.BRIGHTEN},
        function(____, entity)
            entity.light.intensity = 140
        end
    )
    manager:setup(
        {UpgradeType.REGENERATE},
        function(____, entity)
            local stat = entity.stats:get("HPRegen")
            stat:adjust(1)
        end
    )
    manager:setup(
        {UpgradeType.INSIGHT},
        function(____, entity)
            for ____, realm in __TS__Iterator(World.realms) do
                realm[2].indicator:handleInsight()
            end
        end
    )
end
____exports.setupUpgrades = setupUpgrades
return ____exports
