local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__Class = ____lualib.__TS__Class
local Map = ____lualib.Map
local __TS__SetDescriptor = ____lualib.__TS__SetDescriptor
local __TS__ArrayIndexOf = ____lualib.__TS__ArrayIndexOf
local __TS__ArraySplice = ____lualib.__TS__ArraySplice
local __TS__Iterator = ____lualib.__TS__Iterator
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["12"] = 2,["13"] = 2,["14"] = 2,["15"] = 3,["16"] = 3,["17"] = 7,["18"] = 8,["19"] = 9,["20"] = 10,["21"] = 13,["22"] = 13,["24"] = 14,["25"] = 15,["26"] = 16,["27"] = 17,["28"] = 13,["29"] = 21,["30"] = 21,["31"] = 21,["32"] = 21,["33"] = 21,["34"] = 28,["35"] = 28,["37"] = 29,["38"] = 30,["39"] = 31,["40"] = 32,["41"] = 33,["42"] = 34,["43"] = 35,["44"] = 36,["45"] = 28,["46"] = 38,["47"] = 38,["48"] = 38,["49"] = 38,["50"] = 38,["51"] = 38,["52"] = 38,["53"] = 38,["54"] = 38,["55"] = 38,["56"] = 50,["57"] = 50,["59"] = 51,["60"] = 52,["61"] = 53,["62"] = 54,["63"] = 55,["64"] = 56,["65"] = 50,["70"] = 59,["78"] = 63,["86"] = 67,["90"] = 70,["91"] = 71,["92"] = 70,["93"] = 74,["94"] = 75,["95"] = 76,["96"] = 76,["97"] = 77,["98"] = 74,["99"] = 80,["100"] = 81,["101"] = 82,["102"] = 83,["103"] = 84,["104"] = 85,["106"] = 80,["107"] = 89,["108"] = 90,["111"] = 92,["113"] = 93,["114"] = 94,["115"] = 89,["116"] = 97,["117"] = 99,["118"] = 100,["119"] = 97,["120"] = 103,["121"] = 104,["122"] = 104,["123"] = 104,["124"] = 104,["125"] = 105,["126"] = 106,["127"] = 107,["128"] = 108,["129"] = 103,["130"] = 111,["131"] = 112,["132"] = 111,["133"] = 115,["134"] = 116,["135"] = 115,["136"] = 119,["137"] = 120,["138"] = 121,["140"] = 119,["141"] = 125,["142"] = 126,["143"] = 126,["144"] = 127,["145"] = 128,["147"] = 125,["148"] = 132,["149"] = 133,["150"] = 134,["152"] = 132,["153"] = 138,["154"] = 139,["155"] = 140,["157"] = 138,["158"] = 144,["159"] = 145,["160"] = 145,["161"] = 145,["162"] = 145,["163"] = 146,["164"] = 147,["165"] = 148,["167"] = 148,["170"] = 150,["171"] = 150,["173"] = 151,["175"] = 151,["177"] = 144,["178"] = 154,["179"] = 155,["180"] = 156,["181"] = 157,["183"] = 157,["186"] = 154,["187"] = 161,["188"] = 162,["189"] = 164,["190"] = 165,["191"] = 166,["192"] = 167,["193"] = 168,["194"] = 169,["195"] = 170,["197"] = 173,["198"] = 161,["199"] = 176,["200"] = 177,["201"] = 179,["203"] = 180,["204"] = 180,["205"] = 181,["206"] = 182,["207"] = 183,["208"] = 184,["209"] = 185,["210"] = 186,["211"] = 187,["212"] = 180,["215"] = 190,["216"] = 176,["217"] = 196,["218"] = 197,["220"] = 200,["221"] = 202,["222"] = 202,["223"] = 202});
local ____exports = {}
local ____event = require("event")
local Event = ____event.Event
local GameEvents = ____event.GameEvents
local ____version = require("version")
local GAME_VERSION = ____version.GAME_VERSION
GameEvents.createRealm = __TS__New(Event)
GameEvents.destroyRealm = __TS__New(Event)
GameEvents.playerJoin = __TS__New(Event)
GameEvents.playerLeave = __TS__New(Event)
local WorldInfo = __TS__Class()
WorldInfo.name = "WorldInfo"
function WorldInfo.prototype.____constructor(self)
    self.name = ""
    self.playtime = 0
    self.directory = ""
    self.version = GAME_VERSION
end
WorldInfo.SCHEMA = Schema.new({
    SchemaField.new("name", DataTypes.STRING),
    SchemaField.new("playtime", DataTypes.FLOAT),
    SchemaField.new("version", DataTypes.STRING)
})
local WorldStats = __TS__Class()
WorldStats.name = "WorldStats"
function WorldStats.prototype.____constructor(self)
    self.researchSpeed = 100
    self.miningSpeed = 100
    self.miningEfficiency = 0
    self.wellspringPumping = 100
    self.monsterCaretaking = 100
    self.farmingExpertise = 0
    self.conduitLevel = 0
    self.ancientDeviceLevel = 0
end
WorldStats.SCHEMA = Schema.new({
    SchemaField.new("researchSpeed", DataTypes.INT32),
    SchemaField.new("miningSpeed", DataTypes.INT32),
    SchemaField.new("miningEfficiency", DataTypes.INT32),
    SchemaField.new("wellspringPumping", DataTypes.INT32),
    SchemaField.new("monsterCaretaking", DataTypes.INT32),
    SchemaField.new("farmingExpertise", DataTypes.INT32),
    SchemaField.new("conduitLevel", DataTypes.INT32),
    SchemaField.new("ancientDeviceLevel", DataTypes.INT32)
})
local GameWorld = __TS__Class()
GameWorld.name = "GameWorld"
function GameWorld.prototype.____constructor(self)
    self.info = __TS__New(WorldInfo)
    self.ids = 0
    self.realms = __TS__New(Map)
    self.players = {}
    self.lootBonuses = __TS__New(Map)
    self.stats = __TS__New(WorldStats)
end
__TS__SetDescriptor(
    GameWorld.prototype,
    "name",
    {get = function(self)
        return self.info.name
    end},
    true
)
__TS__SetDescriptor(
    GameWorld.prototype,
    "infoFile",
    {get = function(self)
        return self.info.directory .. "info.dat"
    end},
    true
)
__TS__SetDescriptor(
    GameWorld.prototype,
    "contentFile",
    {get = function(self)
        return self.info.directory .. "world.dat"
    end},
    true
)
function GameWorld.prototype.reset(self)
    self.realms:clear()
end
function GameWorld.prototype.addPlayer(self, entity)
    assert(entity.player ~= nil)
    local ____self_players_0 = self.players
    ____self_players_0[#____self_players_0 + 1] = entity.id
    GameEvents.playerJoin:invoke(entity)
end
function GameWorld.prototype.removePlayer(self, entity)
    assert(entity.player ~= nil)
    local index = __TS__ArrayIndexOf(self.players, entity.id)
    if index ~= -1 then
        __TS__ArraySplice(self.players, index, 1)
        GameEvents.playerLeave:invoke(entity)
    end
end
function GameWorld.prototype.getId(self)
    local id
    repeat
        do
            id = self.ids + 1
        end
    until not self.realms:has(id)
    return id
end
function GameWorld.prototype.addRealm(self, realm)
    self.realms:set(realm.id, realm)
    GameEvents.createRealm:invoke(realm)
end
function GameWorld.prototype.destroyRealm(self, id)
    assert(
        self.realms:has(id),
        "Attempting to destroy nonexistant Realm"
    )
    local realm = self.realms:get(id)
    realm:destroy()
    GameEvents.destroyRealm:invoke(realm)
    self.realms:delete(id)
end
function GameWorld.prototype.get(self, id)
    return self.realms:get(id)
end
function GameWorld.prototype.hasRealm(self, id)
    return self.realms:has(id)
end
function GameWorld.prototype.updateStart(self, frameTime)
    for ____, realm in __TS__Iterator(self.realms) do
        realm[2]:updateStart(frameTime)
    end
end
function GameWorld.prototype.update(self, frameTime)
    local ____self_info_1, ____playtime_2 = self.info, "playtime"
    ____self_info_1[____playtime_2] = ____self_info_1[____playtime_2] + frameTime.seconds
    for ____, realm in __TS__Iterator(self.realms) do
        realm[2]:update(frameTime)
    end
end
function GameWorld.prototype.updateFixed(self, fixedTime)
    for ____, realm in __TS__Iterator(self.realms) do
        realm[2]:updateFixed(fixedTime)
    end
end
function GameWorld.prototype.cleanup(self)
    for ____, realm in __TS__Iterator(self.realms) do
        realm[2]:cleanup()
    end
end
function GameWorld.prototype.move(self, entity, id, layer)
    assert(
        self:hasRealm(id),
        "Attempting to move entity to nonexistant Realm"
    )
    local location = entity.location
    if location.realm ~= 0 and self:hasRealm(location.realm) then
        local ____opt_3 = self.realms:get(location.realm)
        if ____opt_3 ~= nil then
            ____opt_3:remove(entity)
        end
    end
    if layer then
        location.layer = layer
    end
    local ____opt_5 = self.realms:get(id)
    if ____opt_5 ~= nil then
        ____opt_5:add(entity, true)
    end
end
function GameWorld.prototype.remove(self, entity)
    local location = entity.location
    if location.realm ~= 0 and self:hasRealm(location.realm) then
        local ____opt_7 = self.realms:get(location.realm)
        if ____opt_7 ~= nil then
            ____opt_7:remove(entity)
        end
    end
end
function GameWorld.prototype.serialize(self, stream)
    tracy.ZoneBeginN("world serialize")
    stream:uint8(self.realms.size)
    for ____, entry in __TS__Iterator(self.realms) do
        local realm = entry[2]
        stream:string(realm.name)
        stream:uint8(realm.id)
        stream:tileVector(realm.size)
        stream:serialize(realm)
    end
    tracy.ZoneEnd()
end
function GameWorld.prototype.deserialize(self, stream, factory)
    tracy.ZoneBeginN("world deserialize")
    local count = stream:uint8()
    do
        local i = 0
        while i < count do
            local name = stream:string()
            local id = stream:uint8()
            local size = stream:tileVector()
            local realm = factory(nil, name, id, size)
            realm:initialize()
            stream:deserialize(realm)
            self:addRealm(realm)
            i = i + 1
        end
    end
    tracy.ZoneEnd()
end
if _G.World == nil then
    _G.World = __TS__New(GameWorld)
end
local World = _G.World
____exports.World = World
____exports.GameWorld = GameWorld
____exports.WorldInfo = WorldInfo
return ____exports
