$input v_color0, v_texcoord0, v_illum, v_uv

#include <bgfx_shader.sh>

SAMPLER2D(s_texture, 0);
SAMPLER2D(s_main_depth, 1);
uniform vec4 depthThreshold;

void main()
{
    float targetDepth = texture2D(s_main_depth, v_texcoord0).x;
    if (targetDepth >= depthThreshold.x) {
        discard;
    }

    gl_FragColor = texture2D(s_texture, v_texcoord0);
}
