$input v_color0, v_texcoord0, v_illum, v_uv

#include <bgfx_shader.sh>

SAMPLER2D(s_texture, 0);
uniform vec4 data;

float rand(vec2 co){
  return fract(sin(dot(co, vec2(12.9898,78.233))) * 43758.5453);
}

void main()
{
    const vec2 size = vec2(384, 384);
    float x = floor(v_texcoord0.x * size.x) / size.y;
    float y = floor(v_texcoord0.y * size.x) / size.y;
    vec2 centered = vec2(x + data.x, y + data.y) * 2 - 1;
    float radialDistance = length(centered);
    float value = rand(vec2(x, y));
    float offset = fract((sin(data.z) + 1) / 256);
    float amount = 10;

    if (value < (1.0 - radialDistance - (1.0 - data.w) + offset) * amount) {
        discard;
    }
    gl_FragColor = vec4(0, 0, 0, 1.0);
}
