```mermaid
graph LR
    material.iron_ore[[material.iron_ore]]
    material.silver_ore[[material.silver_ore]]
    material.adamantite_ore[[material.adamantite_ore]]
    material.wood[[material.wood]]
    material.iron_ingot(material.iron_ingot)
    material.plank(material.plank)
    material.metal(material.metal)
    material.iron_gear(material.iron_gear)
    material.crank(material.crank)
    material.mana_fiber(material.mana_fiber)
    material.sand[[material.sand]]
    material.glass(material.glass)
    material.resin[[material.resin]]
    material.mineral(material.mineral)
    material.rubber(material.rubber)
    tile.brick(tile.brick)
    material.ceramic(material.ceramic)
    tile.structural_framing(tile.structural_framing)
    material.adamantite_ingot(material.adamantite_ingot)
    material.metal_ii(material.metal_ii)
    material.obsidian(material.obsidian)
    material.tempered_glass(material.tempered_glass)
    material.lens(material.lens)
    material.hyper_catalyst(material.hyper_catalyst)
    material.silver_ingot(material.silver_ingot)
    material.mana(material.mana)
    material.quartz(material.quartz)
    material.magicite(material.magicite)
    material.fiberglass(material.fiberglass)
    material.mana_core(material.mana_core)
    material.bound_composite(material.bound_composite)
    material.gadget(material.gadget)
    material.reinforced_plating(material.reinforced_plating)
    material.fire_catalyst[[material.fire_catalyst]]
    material.water_catalyst[[material.water_catalyst]]
    material.wind_catalyst[[material.wind_catalyst]]
    material.earth_catalyst[[material.earth_catalyst]]
    material.mana_ii(material.mana_ii)
    material.mineral_ii(material.mineral_ii)
    material.biomass_ii(material.biomass_ii)
    material.biomass(material.biomass)
    material.poop[[material.poop]]
    material.metal_plating(material.metal_plating)
    material.mana_bullet(material.mana_bullet)
    material.mana_bullet_ii(material.mana_bullet_ii)
    structure.power_relay(structure.power_relay)
    structure.mana_turret(structure.mana_turret)
    tile.concrete(tile.concrete)
    structure.transport_tube_ii(structure.transport_tube_ii)
    material.mana_substance(material.mana_substance)
    structure.reactor(structure.reactor)
    material.cermet(material.cermet)
    material.solidified_aether(material.solidified_aether)
    material.stone(material.stone)
    material.oil_clot[[material.oil_clot]]
    structure.transport_tube(structure.transport_tube)
    structure.splitter(structure.splitter)
    structure.splitter_ii(structure.splitter_ii)
    structure.transport_tube_iii(structure.transport_tube_iii)
    structure.porter(structure.porter)
    structure.beam_boost(structure.beam_boost)
    material.hyper_lens(material.hyper_lens)
    structure.pipe(structure.pipe)
    structure.forge(structure.forge)
    structure.assembler(structure.assembler)
    structure.assembler_ii(structure.assembler_ii)
    structure.pump(structure.pump)
    structure.plant_support(structure.plant_support)
    structure.power_transmitter(structure.power_transmitter)
    structure.power_relay_ii(structure.power_relay_ii)
    structure.elemental_relay(structure.elemental_relay)
    material.fire_orb(material.fire_orb)
    material.water_orb(material.water_orb)
    material.wind_orb(material.wind_orb)
    material.earth_orb(material.earth_orb)
    fauna.synth_egg[(fauna.synth_egg)]
    material.fertilizer[(material.fertilizer)]
    material.sawblade[(material.sawblade)]
    material.tapper[(material.tapper)]
    material.shears[(material.shears)]
    material.trowel[(material.trowel)]
    material.hyper_bullet[(material.hyper_bullet)]
    material.mechanical_essence[(material.mechanical_essence)]
    material.magical_essence[(material.magical_essence)]
    material.martial_essence[(material.martial_essence)]
    material.structural_essence[(material.structural_essence)]
    material.technological_essence[(material.technological_essence)]
    material.hyper_essence[(material.hyper_essence)]
    material.rapid_bonder[(material.rapid_bonder)]
    material.heavy_bonder[(material.heavy_bonder)]
    material.conductive_bonder[(material.conductive_bonder)]
    tile.scaffolding[(tile.scaffolding)]
    tile.ladder[(tile.ladder)]
    environment.torch[(environment.torch)]
    structure.splitter_iii[(structure.splitter_iii)]
    structure.bypass[(structure.bypass)]
    structure.bypass_ii[(structure.bypass_ii)]
    structure.bypass_iii[(structure.bypass_iii)]
    structure.porter_ii[(structure.porter_ii)]
    structure.beam_dock[(structure.beam_dock)]
    structure.beam_boost_ii[(structure.beam_boost_ii)]
    structure.large_pipe[(structure.large_pipe)]
    structure.storage_tank[(structure.storage_tank)]
    structure.crank_drill[(structure.crank_drill)]
    structure.combustion_drill[(structure.combustion_drill)]
    structure.energy_drill[(structure.energy_drill)]
    structure.lava_forge[(structure.lava_forge)]
    structure.assembler_iii[(structure.assembler_iii)]
    structure.matter_refiner[(structure.matter_refiner)]
    structure.matter_compressor[(structure.matter_compressor)]
    structure.distiller[(structure.distiller)]
    structure.foldery[(structure.foldery)]
    structure.infuser[(structure.infuser)]
    structure.elementalizer[(structure.elementalizer)]
    structure.monster_stable[(structure.monster_stable)]
    structure.irrigated_plant_support[(structure.irrigated_plant_support)]
    structure.wood_chest[(structure.wood_chest)]
    structure.sturdy_chest[(structure.sturdy_chest)]
    structure.crank_generator[(structure.crank_generator)]
    structure.power_chamber[(structure.power_chamber)]
    structure.power_relay_iii[(structure.power_relay_iii)]
    structure.elemental_converter[(structure.elemental_converter)]
    structure.elemental_relay_ii[(structure.elemental_relay_ii)]
    structure.battery[(structure.battery)]
    structure.collector[(structure.collector)]
    structure.fire_turret[(structure.fire_turret)]
    structure.water_turret[(structure.water_turret)]
    structure.wind_turret[(structure.wind_turret)]
    structure.earth_turret[(structure.earth_turret)]
    material.iron_ore --> material.iron_ingot
    material.iron_ore --> material.iron_ingot
    material.iron_ore --> material.stone
    material.silver_ore --> material.silver_ingot
    material.silver_ore --> material.silver_ingot
    material.silver_ore --> material.stone
    material.adamantite_ore --> material.adamantite_ingot
    material.adamantite_ore --> material.stone
    material.wood --> material.plank
    material.iron_ingot --> material.iron_gear
    material.iron_ingot --> material.crank
    material.plank --> material.crank
    material.metal --> material.metal_plating
    material.iron_gear --> material.gadget
    material.crank --> material.gadget
    material.mana_fiber --> material.gadget
    material.sand --> material.glass
    material.sand --> material.glass
    material.sand --> material.stone
    material.glass --> material.fiberglass
    material.resin --> material.fiberglass
    material.sand --> material.quartz
    material.resin --> material.rubber
    material.mineral --> material.rubber
    material.rubber --> tile.concrete
    tile.brick --> tile.concrete
    material.mineral --> material.ceramic
    material.ceramic --> material.cermet
    material.metal --> material.cermet
    material.ceramic --> material.cermet
    material.ceramic --> material.stone
    material.metal --> material.cermet
    material.metal --> material.stone
    tile.structural_framing --> material.reinforced_plating
    material.adamantite_ingot --> material.reinforced_plating
    material.metal_ii --> material.reinforced_plating
    material.glass --> material.tempered_glass
    material.obsidian --> material.tempered_glass
    material.tempered_glass --> material.lens
    material.rubber --> material.lens
    material.lens --> material.hyper_lens
    material.hyper_catalyst --> material.hyper_lens
    material.silver_ingot --> material.mana_fiber
    material.mana --> material.mana_fiber
    material.metal --> material.magicite
    material.mana --> material.magicite
    material.quartz --> material.magicite
    material.magicite --> material.mana_core
    material.mana_fiber --> material.mana_core
    material.fiberglass --> material.mana_core
    material.silver_ingot --> material.bound_composite
    material.mana_core --> material.bound_composite
    material.resin --> material.bound_composite
    material.tempered_glass --> material.bound_composite
    material.bound_composite --> material.mana_substance
    material.gadget --> material.mana_substance
    material.lens --> material.mana_substance
    material.reinforced_plating --> material.mana_substance
    material.fire_catalyst --> material.hyper_catalyst
    material.water_catalyst --> material.hyper_catalyst
    material.wind_catalyst --> material.hyper_catalyst
    material.earth_catalyst --> material.hyper_catalyst
    material.mineral_ii --> material.solidified_aether
    material.bound_composite --> fauna.synth_egg
    material.biomass_ii --> fauna.synth_egg
    material.biomass --> material.fertilizer
    material.poop --> material.fertilizer
    material.mana --> material.fire_orb
    material.mana --> material.water_orb
    material.mana --> material.wind_orb
    material.mana --> material.earth_orb
    material.iron_ingot --> material.sawblade
    material.iron_gear --> material.sawblade
    material.iron_ingot --> material.tapper
    material.gadget --> material.tapper
    material.obsidian --> material.shears
    material.plank --> material.shears
    material.metal_plating --> material.trowel
    material.mana --> material.mana_bullet
    material.iron_ingot --> material.mana_bullet
    material.mana_bullet --> material.mana_bullet_ii
    material.obsidian --> material.mana_bullet_ii
    material.mana_bullet_ii --> material.hyper_bullet
    material.hyper_catalyst --> material.hyper_bullet
    material.metal --> material.metal_ii
    material.mineral --> material.mineral_ii
    material.mana --> material.mana_ii
    material.biomass --> material.biomass_ii
    material.crank --> material.mechanical_essence
    material.iron_gear --> material.mechanical_essence
    material.mana_fiber --> material.magical_essence
    structure.power_relay --> material.magical_essence
    material.silver_ingot --> material.magical_essence
    material.mana_bullet --> material.martial_essence
    material.mana_bullet --> material.martial_essence
    structure.mana_turret --> material.martial_essence
    material.fiberglass --> material.structural_essence
    material.ceramic --> material.structural_essence
    tile.concrete --> material.structural_essence
    material.metal_plating --> material.structural_essence
    structure.transport_tube_ii --> material.technological_essence
    material.bound_composite --> material.technological_essence
    material.adamantite_ingot --> material.technological_essence
    material.mana_substance --> material.hyper_essence
    material.hyper_catalyst --> material.hyper_essence
    structure.reactor --> material.hyper_essence
    material.rubber --> material.rapid_bonder
    material.cermet --> material.heavy_bonder
    material.solidified_aether --> material.conductive_bonder
    material.silver_ingot --> material.conductive_bonder
    material.plank --> tile.scaffolding
    material.plank --> tile.ladder
    material.stone --> tile.brick
    material.cermet --> tile.structural_framing
    material.plank --> environment.torch
    material.oil_clot --> environment.torch
    material.iron_ingot --> structure.transport_tube
    material.iron_gear --> structure.transport_tube
    structure.transport_tube --> structure.transport_tube_ii
    material.cermet --> structure.transport_tube_ii
    material.fiberglass --> structure.transport_tube_ii
    structure.transport_tube_ii --> structure.transport_tube_iii
    material.reinforced_plating --> structure.transport_tube_iii
    material.hyper_catalyst --> structure.transport_tube_iii
    structure.transport_tube --> structure.splitter
    material.mana --> structure.splitter
    structure.splitter --> structure.splitter_ii
    material.mana_core --> structure.splitter_ii
    material.fiberglass --> structure.splitter_ii
    structure.splitter_ii --> structure.splitter_iii
    material.bound_composite --> structure.splitter_iii
    structure.transport_tube --> structure.bypass
    material.iron_gear --> structure.bypass
    structure.transport_tube_ii --> structure.bypass_ii
    material.gadget --> structure.bypass_ii
    structure.transport_tube_iii --> structure.bypass_iii
    structure.transport_tube --> structure.bypass_iii
    material.silver_ingot --> structure.porter
    structure.transport_tube --> structure.porter
    material.quartz --> structure.porter
    structure.porter --> structure.porter_ii
    structure.transport_tube_ii --> structure.porter_ii
    material.mana_core --> structure.porter_ii
    material.cermet --> structure.beam_dock
    material.mana_core --> structure.beam_dock
    material.glass --> structure.beam_boost
    material.mana_core --> structure.beam_boost
    structure.beam_boost --> structure.beam_boost_ii
    material.bound_composite --> structure.beam_boost_ii
    material.hyper_lens --> structure.beam_boost_ii
    material.metal_plating --> structure.pipe
    material.reinforced_plating --> structure.large_pipe
    material.fiberglass --> structure.large_pipe
    structure.pipe --> structure.large_pipe
    structure.pipe --> structure.pump
    material.rubber --> structure.pump
    material.metal_plating --> structure.storage_tank
    structure.pipe --> structure.storage_tank
    material.crank --> structure.crank_drill
    material.plank --> structure.crank_drill
    material.iron_ingot --> structure.combustion_drill
    material.iron_gear --> structure.combustion_drill
    structure.forge --> structure.combustion_drill
    material.magicite --> structure.energy_drill
    material.iron_ingot --> structure.energy_drill
    material.iron_gear --> structure.energy_drill
    material.stone --> structure.forge
    material.ceramic --> structure.lava_forge
    material.obsidian --> structure.lava_forge
    material.iron_ingot --> structure.assembler
    material.iron_gear --> structure.assembler
    material.mana --> structure.assembler
    structure.assembler --> structure.assembler_ii
    material.mana_core --> structure.assembler_ii
    material.cermet --> structure.assembler_ii
    structure.assembler_ii --> structure.assembler_iii
    material.mana_substance --> structure.assembler_iii
    material.reinforced_plating --> structure.assembler_iii
    material.iron_ingot --> structure.matter_refiner
    material.iron_gear --> structure.matter_refiner
    material.mana_fiber --> structure.matter_refiner
    tile.concrete --> structure.matter_compressor
    material.fiberglass --> structure.matter_compressor
    material.gadget --> structure.matter_compressor
    material.silver_ingot --> structure.distiller
    material.iron_gear --> structure.distiller
    material.crank --> structure.foldery
    material.mana_fiber --> structure.foldery
    structure.power_relay --> structure.foldery
    structure.pump --> structure.infuser
    material.magicite --> structure.infuser
    material.obsidian --> structure.infuser
    material.mana_core --> structure.elementalizer
    structure.porter --> structure.elementalizer
    tile.concrete --> structure.elementalizer
    material.plank --> structure.monster_stable
    material.rubber --> structure.monster_stable
    tile.concrete --> structure.monster_stable
    material.plank --> structure.plant_support
    material.magicite --> structure.plant_support
    structure.plant_support --> structure.irrigated_plant_support
    structure.pipe --> structure.irrigated_plant_support
    material.fiberglass --> structure.irrigated_plant_support
    material.plank --> structure.wood_chest
    material.metal_plating --> structure.sturdy_chest
    material.mana_fiber --> structure.sturdy_chest
    material.iron_ingot --> structure.crank_generator
    material.iron_gear --> structure.crank_generator
    material.crank --> structure.crank_generator
    material.metal_plating --> structure.power_chamber
    material.silver_ingot --> structure.power_chamber
    material.magicite --> structure.power_chamber
    material.silver_ingot --> structure.reactor
    material.mana_core --> structure.reactor
    material.cermet --> structure.reactor
    structure.power_transmitter --> structure.reactor
    material.mana --> structure.power_relay
    material.iron_ingot --> structure.power_relay
    structure.power_relay --> structure.power_relay_ii
    material.quartz --> structure.power_relay_ii
    structure.power_relay_ii --> structure.power_relay_iii
    material.lens --> structure.power_relay_iii
    material.gadget --> structure.power_transmitter
    material.silver_ingot --> structure.power_transmitter
    material.reinforced_plating --> structure.elemental_converter
    material.mana_ii --> structure.elemental_converter
    structure.power_relay_ii --> structure.elemental_relay
    material.tempered_glass --> structure.elemental_relay
    structure.elemental_relay --> structure.elemental_relay_ii
    material.hyper_lens --> structure.elemental_relay_ii
    material.magicite --> structure.battery
    material.metal_plating --> structure.battery
    material.iron_ingot --> structure.mana_turret
    material.mana --> structure.mana_turret
    material.glass --> structure.mana_turret
    structure.mana_turret --> structure.fire_turret
    material.fire_orb --> structure.fire_turret
    material.mana_core --> structure.fire_turret
    structure.mana_turret --> structure.water_turret
    material.water_orb --> structure.water_turret
    material.mana_core --> structure.water_turret
    structure.mana_turret --> structure.wind_turret
    material.wind_orb --> structure.wind_turret
    material.mana_core --> structure.wind_turret
    structure.mana_turret --> structure.earth_turret
    material.earth_orb --> structure.earth_turret
    material.mana_core --> structure.earth_turret
```