local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 27,["7"] = 27,["8"] = 43,["9"] = 44,["10"] = 45,["11"] = 46,["12"] = 47,["14"] = 49,["15"] = 50,["17"] = 52,["18"] = 53,["20"] = 55,["21"] = 56,["23"] = 58,["24"] = 59,["26"] = 61,["27"] = 62,["29"] = 64,["30"] = 65,["32"] = 67,["33"] = 68,["35"] = 70,["36"] = 71,["38"] = 73,["39"] = 74,["41"] = 43,["42"] = 78,["43"] = 79,["44"] = 80,["45"] = 78,["46"] = 28,["47"] = 29,["48"] = 84,["49"] = 84});
local ____exports = {}
local EventComponent = __TS__Class()
EventComponent.name = "EventComponent"
function EventComponent.prototype.____constructor(self, event)
    self.interactText = event.interactText or "INTERACT"
    self.interactCursor = event.interactCursor or CursorType.Inspect
    if event.interact then
        self.interact = event.interact
    end
    if event.withdraw then
        self.withdraw = event.withdraw
    end
    if event.moved then
        self.moved = event.moved
    end
    if event.harvest then
        self.harvest = event.harvest
    end
    if event.rotate then
        self.rotate = event.rotate
    end
    if event.cranked then
        self.cranked = event.cranked
    end
    if event.placed then
        self.placed = event.placed
    end
    if event.displaced then
        self.displaced = event.displaced
    end
    if event.fluidChange then
        self.fluidChange = event.fluidChange
    end
    if event.recipeChange then
        self.recipeChange = event.recipeChange
    end
end
function EventComponent.prototype.uninteractable(self)
    self.interact = nil
    self.interactText = nil
end
EventComponent.type = "event"
EventComponent.cid = hash.hash_str32(EventComponent.type)
____exports.EventComponent = EventComponent
____exports.component = EventComponent
return ____exports
