local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 14,["9"] = 14,["10"] = 23,["11"] = 18,["12"] = 19,["13"] = 20,["14"] = 21,["15"] = 23,["16"] = 27,["17"] = 28,["18"] = 27,["19"] = 31,["20"] = 32,["23"] = 35,["24"] = 36,["27"] = 39,["28"] = 40,["32"] = 43,["33"] = 43,["34"] = 44,["35"] = 45,["38"] = 43,["41"] = 31,["42"] = 15,["43"] = 16,["44"] = 51,["45"] = 51});
local ____exports = {}
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local InteractionComponent = __TS__Class()
InteractionComponent.name = "InteractionComponent"
function InteractionComponent.prototype.____constructor(self, interaction)
    self.placementAxis = PlacementAxisType.None
    self.placementItem = Item.new()
    self.itemDirection = FacingDirection.Right
    self.transportDirection = TileDirection.Up
end
function InteractionComponent.prototype.rotateConveyorDirection(self)
    self.transportDirection = (self.transportDirection + 1) % TileDirection.Count
end
function InteractionComponent.prototype.rotateItemDirection(self)
    if self.placementItem:isEmpty() then
        return
    end
    local placement = self.placementItem:entity().placement
    if not placement or self.placementAxis == PlacementAxisType.None then
        return
    end
    local axis = placement:getAxis(self.placementAxis)
    if axis == nil then
        return
    end
    do
        local direction = 0
        while direction < FacingDirection.Count do
            self.itemDirection = (self.itemDirection + 1) % FacingDirection.Count
            if axis:getDirection(self.itemDirection) ~= nil then
                break
            end
            direction = direction + 1
        end
    end
end
InteractionComponent.type = "interaction"
InteractionComponent.cid = hash.hash_str32(InteractionComponent.type)
____exports.InteractionComponent = InteractionComponent
____exports.component = InteractionComponent
return ____exports
