local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local Set = ____lualib.Set
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["8"] = 1,["9"] = 1,["10"] = 30,["11"] = 30,["12"] = 30,["13"] = 30,["14"] = 30,["15"] = 30,["16"] = 30,["17"] = 30,["18"] = 30,["19"] = 30,["20"] = 30,["21"] = 30,["22"] = 30,["23"] = 30,["24"] = 30,["25"] = 30,["26"] = 30,["27"] = 30,["28"] = 30,["29"] = 30,["30"] = 30,["31"] = 43,["32"] = 43,["33"] = 43,["34"] = 43,["35"] = 43,["36"] = 48,["37"] = 48,["38"] = 48,["39"] = 48,["40"] = 48,["41"] = 48,["42"] = 48,["43"] = 62,["44"] = 62,["45"] = 80,["46"] = 66,["47"] = 67,["48"] = 78,["49"] = 81,["50"] = 82,["51"] = 83,["52"] = 84,["54"] = 85,["55"] = 85,["56"] = 86,["57"] = 87,["58"] = 88,["59"] = 88,["60"] = 88,["61"] = 88,["62"] = 88,["63"] = 88,["64"] = 88,["65"] = 88,["66"] = 85,["70"] = 97,["71"] = 98,["72"] = 99,["74"] = 100,["75"] = 100,["76"] = 101,["77"] = 102,["78"] = 103,["79"] = 103,["80"] = 103,["81"] = 103,["82"] = 103,["83"] = 103,["84"] = 103,["85"] = 103,["86"] = 100,["90"] = 112,["91"] = 113,["92"] = 114,["93"] = 115,["94"] = 116,["95"] = 80,["96"] = 119,["97"] = 120,["98"] = 119,["99"] = 123,["100"] = 124,["101"] = 123,["102"] = 127,["103"] = 128,["104"] = 127,["105"] = 131,["106"] = 132,["107"] = 133,["108"] = 134,["109"] = 135,["110"] = 131,["111"] = 138,["112"] = 139,["113"] = 138,["114"] = 146,["115"] = 147,["116"] = 146,["117"] = 63,["118"] = 64,["119"] = 151,["120"] = 151,["121"] = 151,["122"] = 151,["123"] = 151});
local ____exports = {}
local ____event = require("event")
local Event = ____event.Event
local MechanicalStrength = MechanicalStrength or ({})
MechanicalStrength.None = -1
MechanicalStrength[MechanicalStrength.None] = "None"
MechanicalStrength.Zero = 0
MechanicalStrength[MechanicalStrength.Zero] = "Zero"
MechanicalStrength.One = 1
MechanicalStrength[MechanicalStrength.One] = "One"
MechanicalStrength.Two = 2
MechanicalStrength[MechanicalStrength.Two] = "Two"
MechanicalStrength.Three = 3
MechanicalStrength[MechanicalStrength.Three] = "Three"
MechanicalStrength.Four = 4
MechanicalStrength[MechanicalStrength.Four] = "Four"
MechanicalStrength.Five = 5
MechanicalStrength[MechanicalStrength.Five] = "Five"
MechanicalStrength.Six = 6
MechanicalStrength[MechanicalStrength.Six] = "Six"
MechanicalStrength.Seven = 7
MechanicalStrength[MechanicalStrength.Seven] = "Seven"
MechanicalStrength.Max = 7
MechanicalStrength[MechanicalStrength.Max] = "Max"
local MechanicalPutType = MechanicalPutType or ({})
MechanicalPutType.Input = 0
MechanicalPutType[MechanicalPutType.Input] = "Input"
MechanicalPutType.Output = 1
MechanicalPutType[MechanicalPutType.Output] = "Output"
local MechanicalNodeType = MechanicalNodeType or ({})
MechanicalNodeType.Basic = 0
MechanicalNodeType[MechanicalNodeType.Basic] = "Basic"
MechanicalNodeType.Item = 1
MechanicalNodeType[MechanicalNodeType.Item] = "Item"
MechanicalNodeType.Liquid = 2
MechanicalNodeType[MechanicalNodeType.Liquid] = "Liquid"
local MechanicalComponent = __TS__Class()
MechanicalComponent.name = "MechanicalComponent"
function MechanicalComponent.prototype.____constructor(self, mechanical)
    self.signal = {strength = MechanicalStrength.Zero}
    self.signalIndex = -1
    self.onSendSignal = __TS__New(Event)
    self.signal.strength = mechanical.initialStrength or MechanicalStrength.None
    if mechanical.inputs then
        self.inputs = {}
        self.inputNodes = {}
        do
            local i = 0
            while i < #mechanical.inputs do
                local inputType = mechanical.inputs[i + 1]
                self.inputs[i + 1] = inputType
                local ____self_inputNodes_0 = self.inputNodes
                ____self_inputNodes_0[#____self_inputNodes_0 + 1] = {
                    index = i,
                    type = inputType,
                    put = MechanicalPutType.Input,
                    connections = __TS__New(Set),
                    signal = {strength = MechanicalStrength.None}
                }
                i = i + 1
            end
        end
    end
    if mechanical.outputs then
        self.outputs = {}
        self.outputNodes = {}
        do
            local i = 0
            while i < #mechanical.outputs do
                local outputType = mechanical.outputs[i + 1]
                self.outputs[i + 1] = outputType
                local ____self_outputNodes_1 = self.outputNodes
                ____self_outputNodes_1[#____self_outputNodes_1 + 1] = {
                    index = i,
                    type = outputType,
                    put = MechanicalPutType.Output,
                    connections = __TS__New(Set),
                    signal = {strength = MechanicalStrength.None}
                }
                i = i + 1
            end
        end
    end
    self.observeSignal = mechanical.observeSignal or self.outputs ~= nil and self.inputs == nil
    self.onConnect = mechanical.onConnect
    self.onDisconnect = mechanical.onDisconnect
    self.onSignal = mechanical.onSignal
    self.onReceive = mechanical.onReceive
end
function MechanicalComponent.prototype.get(self, put, index)
    return put == MechanicalPutType.Input and self:getInput(index) or self:getOutput(index)
end
function MechanicalComponent.prototype.getInput(self, index)
    return self.inputNodes[index + 1]
end
function MechanicalComponent.prototype.getOutput(self, index)
    return self.outputNodes[index + 1]
end
function MechanicalComponent.prototype.readySignal(self, signal, index)
    self.signal.strength = signal.strength or self.signal.strength
    self.signal.content = signal.content or self.signal.content
    self.signal.provider = signal.provider or self.signal.provider
    self.signalIndex = index or -1
end
function MechanicalComponent.prototype.clearSignal(self)
    self.signal = {strength = MechanicalStrength.None, content = 0, provider = INVALID_ENTITYID}
end
function MechanicalComponent.prototype.isSignalReady(self)
    return self.signal.strength ~= MechanicalStrength.None
end
MechanicalComponent.type = "mechanical"
MechanicalComponent.cid = hash.hash_str32(MechanicalComponent.type)
____exports.MechanicalComponent = MechanicalComponent
____exports.component = MechanicalComponent
____exports.MechanicalStrength = MechanicalStrength
____exports.MechanicalPutType = MechanicalPutType
____exports.MechanicalNodeType = MechanicalNodeType
return ____exports
