local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__New = ____lualib.__TS__New
local __TS__SetDescriptor = ____lualib.__TS__SetDescriptor
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["8"] = 1,["9"] = 1,["10"] = 2,["11"] = 2,["12"] = 4,["13"] = 4,["14"] = 4,["15"] = 4,["16"] = 4,["17"] = 18,["18"] = 18,["19"] = 60,["20"] = 47,["21"] = 48,["22"] = 49,["23"] = 51,["24"] = 52,["25"] = 53,["26"] = 54,["27"] = 56,["28"] = 58,["29"] = 61,["30"] = 62,["31"] = 63,["32"] = 60,["38"] = 30,["40"] = 33,["41"] = 34,["51"] = 39,["53"] = 42,["54"] = 43,["55"] = 44,["60"] = 66,["61"] = 67,["62"] = 68,["63"] = 68,["64"] = 69,["65"] = 70,["68"] = 73,["69"] = 74,["70"] = 75,["71"] = 76,["72"] = 77,["73"] = 78,["74"] = 79,["76"] = 81,["77"] = 82,["79"] = 84,["80"] = 85,["82"] = 88,["83"] = 89,["84"] = 90,["86"] = 66,["87"] = 94,["88"] = 95,["89"] = 96,["91"] = 99,["92"] = 100,["94"] = 102,["96"] = 94,["97"] = 19,["98"] = 20,["99"] = 21,["100"] = 24,["101"] = 24,["102"] = 24,["103"] = 24,["104"] = 107,["105"] = 107,["106"] = 107});
local ____exports = {}
local ____core = require("core")
local core = ____core.core
local ____event = require("event")
local Event = ____event.Event
local PlayerMode = PlayerMode or ({})
PlayerMode.Build = 0
PlayerMode[PlayerMode.Build] = "Build"
PlayerMode.Combat = 1
PlayerMode[PlayerMode.Combat] = "Combat"
local PlayerComponent = __TS__Class()
PlayerComponent.name = "PlayerComponent"
function PlayerComponent.prototype.____constructor(self, Player)
    self.isLocal = true
    self.onModeChange = __TS__New(Event)
    self.grabbed = Item.new()
    self.wasGrabbedLocked = false
    self.onGrabbedChange = __TS__New(Event)
    self.grabbedMeta = {}
    self.buildRadius = 1
    self.lastSafePosition = Vector.new()
    self.fowTimer = GameTimer.new(seconds(3))
    self.mode = PlayerMode.Build
    self.maxBuildRadius = 1
    self.onGrabbedChange:listen(core.cb(self, "handleGrabbedChanged"))
end
__TS__SetDescriptor(
    PlayerComponent.prototype,
    "maxBuildRadius",
    {
        get = function(self)
            return self.data:getUint8(0)
        end,
        set = function(self, value)
            self.data:setUint8(0, value)
        end
    },
    true
)
__TS__SetDescriptor(
    PlayerComponent.prototype,
    "mode",
    {
        get = function(self)
            return self.data:getUint8(1)
        end,
        set = function(self, value)
            self.data:setUint8(1, value)
            self.onModeChange:invoke(value)
        end
    },
    true
)
function PlayerComponent.prototype.consumeGrabbed(self, inventory, quantity)
    if self.grabbed.quantity > 1 then
        local ____self_grabbed_0, ____quantity_1 = self.grabbed, "quantity"
        ____self_grabbed_0[____quantity_1] = ____self_grabbed_0[____quantity_1] - 1
        if self.grabbedIndex then
            inventory:changed(self.grabbedIndex, self.grabbed)
        end
    else
        local previous = self.grabbedIndex
        if previous then
            self.grabbed.quantity = 0
            inventory:changed(previous, self.grabbed)
            if not self.wasGrabbedLocked then
                inventory:unlock(previous)
                self.grabbed:clear()
            end
            self.grabbed = Item.new()
            inventory:sort()
        else
            self.grabbed:clear()
            self.grabbed = Item.new()
        end
        self.wasGrabbedLocked = false
        self.grabbedIndex = nil
        self.onGrabbedChange:invoke(self.grabbed, previous, self.grabbedIndex)
    end
end
function PlayerComponent.prototype.handleGrabbedChanged(self, grabbed, previous, index)
    if grabbed:isEmpty() or grabbed.entityID ~= self.grabbedMeta.entityID then
        self.grabbedMeta = {}
    end
    if grabbed:isEmpty() then
        UIManager.resetCursor()
    else
        UIManager.setCursor(CursorType.ItemHold)
    end
end
PlayerComponent.type = "player"
PlayerComponent.cid = hash.hash_str32(PlayerComponent.type)
PlayerComponent.serialization = 2
PlayerComponent.SCHEMA = Schema.new({
    SchemaField.new("maxBuildRadius", DataTypes.UINT8),
    SchemaField.new("mode", DataTypes.UINT8)
})
____exports.PlayerComponent = PlayerComponent
____exports.component = PlayerComponent
____exports.PlayerMode = PlayerMode
return ____exports
