local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__New = ____lualib.__TS__New
local __TS__SetDescriptor = ____lualib.__TS__SetDescriptor
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["8"] = 1,["9"] = 1,["10"] = 14,["11"] = 16,["12"] = 16,["14"] = 21,["16"] = 24,["17"] = 24,["18"] = 25,["19"] = 25,["20"] = 24,["23"] = 23,["24"] = 17,["25"] = 30,["26"] = 30,["27"] = 47,["28"] = 40,["29"] = 41,["30"] = 43,["31"] = 44,["32"] = 45,["33"] = 48,["35"] = 49,["36"] = 49,["37"] = 50,["38"] = 50,["39"] = 49,["42"] = 47,["47"] = 55,["51"] = 58,["52"] = 59,["53"] = 60,["54"] = 61,["55"] = 62,["56"] = 63,["58"] = 58,["59"] = 67,["60"] = 68,["61"] = 69,["62"] = 70,["63"] = 71,["65"] = 67,["66"] = 75,["67"] = 76,["68"] = 77,["69"] = 79,["71"] = 80,["72"] = 80,["73"] = 81,["74"] = 82,["75"] = 83,["76"] = 84,["78"] = 80,["82"] = 75,["83"] = 31,["84"] = 32,["85"] = 33,["86"] = 34,["87"] = 35,["88"] = 35,["89"] = 35,["90"] = 35,["91"] = 35,["92"] = 35,["93"] = 35,["94"] = 34,["95"] = 34,["96"] = 34,["97"] = 91,["98"] = 91,["99"] = 91});
local ____exports = {}
local ____event = require("event")
local Event = ____event.Event
local QUICKBAR_SIZE = 10
local Quickbar = __TS__Class()
Quickbar.name = "Quickbar"
function Quickbar.prototype.____constructor(self)
    self.items = {}
    do
        local i = 0
        while i < QUICKBAR_SIZE do
            local ____self_items_0 = self.items
            ____self_items_0[#____self_items_0 + 1] = INVALID_ENTITYID
            i = i + 1
        end
    end
end
Quickbar.SCHEMA = Schema.new({SchemaField.new("items", DataTypes.ARRAY, DataTypes.ENTITY)})
local QuickbarComponent = __TS__Class()
QuickbarComponent.name = "QuickbarComponent"
function QuickbarComponent.prototype.____constructor(self, quickbar)
    self.quickbars = {}
    self.activeBar = 0
    self.onActiveChange = __TS__New(Event)
    self.onActiveIndexChange = __TS__New(Event)
    self.onItemChange = __TS__New(Event)
    self.size = quickbar.size
    do
        local i = 0
        while i < self.size do
            local ____self_quickbars_1 = self.quickbars
            ____self_quickbars_1[#____self_quickbars_1 + 1] = __TS__New(Quickbar)
            i = i + 1
        end
    end
end
__TS__SetDescriptor(
    QuickbarComponent.prototype,
    "active",
    {get = function(self)
        return self.quickbars[self.activeBar + 1]
    end},
    true
)
function QuickbarComponent.prototype.setActiveBar(self, index)
    if index ~= self.activeBar then
        self:setActiveItem()
        local previous = self.activeBar
        self.activeBar = index
        self.onActiveChange:invoke(self.active, previous, index)
    end
end
function QuickbarComponent.prototype.setActiveItem(self, index)
    if index ~= self.activeItem then
        local previous = self.activeItem
        self.activeItem = index
        self.onActiveIndexChange:invoke(self.active, previous, index)
    end
end
function QuickbarComponent.prototype.set(self, quickbarIndex, index, entityID)
    self.quickbars[quickbarIndex + 1].items[index + 1] = entityID
    self.onItemChange:invoke(self.quickbars[quickbarIndex + 1], index, entityID)
    if entityID ~= INVALID_ENTITYID then
        do
            local i = 0
            while i < #self.quickbars[quickbarIndex + 1].items do
                local item = self.quickbars[quickbarIndex + 1].items[i + 1]
                if item == entityID and index ~= i then
                    self.quickbars[quickbarIndex + 1].items[i + 1] = INVALID_ENTITYID
                    self.onItemChange:invoke(self.quickbars[quickbarIndex + 1], i, INVALID_ENTITYID)
                end
                i = i + 1
            end
        end
    end
end
QuickbarComponent.type = "quickbar"
QuickbarComponent.cid = hash.hash_str32(QuickbarComponent.type)
QuickbarComponent.serialization = SERIALIZATION_SCRIPT
QuickbarComponent.SCHEMA = Schema.new({
    SchemaField.new(
        "quickbars",
        DataTypes.ARRAY,
        DataTypes.COMPLEX,
        function()
            return __TS__New(Quickbar)
        end
    ),
    SchemaField.new("activeBar", DataTypes.UINT8)
})
____exports.QuickbarComponent = QuickbarComponent
____exports.component = QuickbarComponent
____exports.Quickbar = Quickbar
return ____exports
