local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__InstanceOf = ____lualib.__TS__InstanceOf
local __TS__SetDescriptor = ____lualib.__TS__SetDescriptor
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["8"] = 1,["9"] = 1,["10"] = 3,["11"] = 3,["12"] = 3,["13"] = 3,["14"] = 3,["15"] = 3,["16"] = 3,["17"] = 3,["18"] = 3,["19"] = 10,["20"] = 10,["21"] = 26,["22"] = 12,["23"] = 13,["24"] = 14,["25"] = 15,["26"] = 20,["27"] = 27,["28"] = 28,["29"] = 29,["30"] = 30,["31"] = 30,["33"] = 32,["34"] = 32,["37"] = 35,["38"] = 36,["39"] = 37,["40"] = 37,["42"] = 39,["43"] = 39,["46"] = 42,["47"] = 43,["48"] = 44,["49"] = 45,["50"] = 46,["51"] = 26,["56"] = 23,["64"] = 50,["68"] = 54,["69"] = 54,["70"] = 54});
local ____exports = {}
local ____item = require("item")
local FluidItem = ____item.FluidItem
local CraftTab = CraftTab or ({})
CraftTab.Materials = 0
CraftTab[CraftTab.Materials] = "Materials"
CraftTab.Structures = 1
CraftTab[CraftTab.Structures] = "Structures"
CraftTab.Byproduct = 2
CraftTab[CraftTab.Byproduct] = "Byproduct"
CraftTab.Count = 3
CraftTab[CraftTab.Count] = "Count"
local CraftRecipe = __TS__Class()
CraftRecipe.name = "CraftRecipe"
function CraftRecipe.prototype.____constructor(self, name, materials, result, time, site, tab, index, known)
    self.materials = {}
    self.fluids = {}
    self.result = {}
    self.resultFluids = {}
    self.known = false
    self.name = name
    for ____, item in ipairs(materials) do
        if __TS__InstanceOf(item, FluidItem) then
            local ____self_fluids_0 = self.fluids
            ____self_fluids_0[#____self_fluids_0 + 1] = item
        else
            local ____self_materials_1 = self.materials
            ____self_materials_1[#____self_materials_1 + 1] = item
        end
    end
    for ____, item in ipairs(result) do
        if __TS__InstanceOf(item, FluidItem) then
            local ____self_resultFluids_2 = self.resultFluids
            ____self_resultFluids_2[#____self_resultFluids_2 + 1] = item
        else
            local ____self_result_3 = self.result
            ____self_result_3[#____self_result_3 + 1] = item
        end
    end
    self.time = time
    self.site = site
    self.tab = tab
    self.index = index
    self.known = known or false
end
__TS__SetDescriptor(
    CraftRecipe.prototype,
    "product",
    {get = function(self)
        return #self.result > 0 and self.result[1] or self.resultFluids[1]
    end},
    true
)
__TS__SetDescriptor(
    CraftRecipe.prototype,
    "isValid",
    {get = function(self)
        return self.index ~= -1
    end},
    true
)
____exports.CraftRecipe = CraftRecipe
____exports.CraftSite = CraftSite
____exports.CraftTab = CraftTab
return ____exports
