local ____lualib = require("lualib_bundle")
local Map = ____lualib.Map
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 3,["8"] = 3,["9"] = 5,["10"] = 5,["11"] = 5,["12"] = 5,["13"] = 5,["14"] = 5,["15"] = 5,["16"] = 5,["17"] = 5,["18"] = 16,["19"] = 17,["20"] = 18,["21"] = 19,["22"] = 21,["24"] = 21,["25"] = 21,["26"] = 21,["27"] = 21,["28"] = 21,["29"] = 21,["30"] = 21,["31"] = 21,["32"] = 21,["33"] = 21,["34"] = 21,["35"] = 21,["36"] = 21,["37"] = 21,["38"] = 21,["39"] = 21,["40"] = 21,["41"] = 21,["42"] = 21,["43"] = 21,["44"] = 21,["45"] = 21,["46"] = 21,["47"] = 21,["48"] = 21,["49"] = 21,["50"] = 21,["51"] = 21,["52"] = 21,["53"] = 21,["54"] = 21,["55"] = 21,["56"] = 21,["57"] = 21,["58"] = 21,["59"] = 21,["60"] = 21,["61"] = 21,["62"] = 21,["63"] = 21,["64"] = 21,["65"] = 21,["66"] = 21,["67"] = 21,["68"] = 21,["69"] = 21,["70"] = 21,["71"] = 21,["72"] = 21,["73"] = 21,["74"] = 73,["75"] = 74,["76"] = 77,["77"] = 77,["78"] = 77,["79"] = 77,["80"] = 80,["81"] = 80,["82"] = 80,["83"] = 80,["84"] = 84,["85"] = 85,["86"] = 86,["87"] = 86,["88"] = 86,["89"] = 86,["90"] = 89,["91"] = 90,["92"] = 91,["94"] = 94,["95"] = 97,["96"] = 98,["98"] = 99,["99"] = 99,["101"] = 100,["102"] = 101,["103"] = 102,["105"] = 105,["106"] = 106,["107"] = 107,["111"] = 99,["114"] = 111,["115"] = 111,["116"] = 111,["117"] = 111,["118"] = 111,["119"] = 112,["120"] = 115,["121"] = 116,["122"] = 117,["123"] = 118,["124"] = 119,["126"] = 120,["127"] = 120,["128"] = 121,["129"] = 122,["130"] = 123,["131"] = 124,["133"] = 120,["136"] = 128,["138"] = 130,["139"] = 72,["141"] = 134});
local ____exports = {}
local ____Sizes = require("Sizes")
local Sizes = ____Sizes.Sizes
local BIOME_LOCATIONS = __TS__New(Map, {
    {BiomeType.Start, "MANA"},
    {BiomeType.Fire, "FIRE"},
    {BiomeType.Water, "WATER"},
    {BiomeType.Earth, "EARTH"},
    {BiomeType.Wind, "WIND"},
    {BiomeType.Sky, "SKY"},
    {BiomeType.Underground, "UNDERGROUND"}
})
local VIEWPORT_BASELINE = 1920 * 1080
local FABRICATOR_SCALE = 150
local MIN_THREAT_DISTANCE = Sizes.TILE * 5
local MAX_THREAT_DISTANCE = Sizes.TILE * 30
local fmod = {}
do
    fmod.MATERIAL_GENERIC = "GENERIC"
    fmod.MATERIAL_DIRT = "DIRT"
    fmod.MATERIAL_STONE = "STONE"
    fmod.MATERIAL_ROCK_SMALL = "ROCK_SMALL"
    fmod.MATERIAL_ROCK_LARGE = "ROCK_LARGE"
    fmod.MATERIAL_SAND = "SAND"
    fmod.MATERIAL_GENERIC_HEAVY = "GENERIC_HEAVY"
    fmod.MATERIAL_WOOD = "WOOD"
    fmod.MATERIAL_BRICK = "BRICK"
    fmod.MATERIAL_GRASS = "GRASS"
    fmod.MATERIAL_BIOMASS = "BIOMASS"
    fmod.MATERIAL_SLIME = "SLIME"
    fmod.MATERIAL_ORE = "ORE"
    fmod.MATERIAL_VINES = "VINES"
    fmod.MATERIAL_MUSHROOM_SMALL = "MUSHROOM_SMALL"
    fmod.MATERIAL_MUSHROOM_LARGE = "MUSHROOM_LARGE"
    fmod.MATERIAL_ANCIENT_TECH = "ANCIENT_TECH"
    fmod.MATERIAL_BUILDING_MATERIAL = "BUILDING_MATERIAL"
    fmod.MATERIAL_CRYSTAL = "CRYSTAL"
    fmod.MATERIAL_CLAY = "CLAY"
    fmod.MATERIAL_METAL = "METAL"
    fmod.MATERIAL_GLASS = "GLASS"
    fmod.MATERIAL_RUBBER = "RUBBER"
    fmod.MATERIAL_PLANT = "PLANT"
    fmod.MATERIAL_WOOL = "WOOL"
    fmod.MATERIAL_ANIMAL = "ANIMAL"
    fmod.MATERIAL_LIQUID = "LIQUID"
    fmod.MATERIAL_VAPOR = "VAPOR"
    fmod.TERRAIN_GENERIC = "GENERIC"
    fmod.TERRAIN_DIRT = "DIRT"
    fmod.TERRAIN_STONE = "STONE"
    fmod.TERRAIN_SAND = "SAND"
    fmod.TERRAIN_HARD_GROUND = "HARD_GROUND"
    fmod.TERRAIN_WOOD = "WOOD"
    fmod.TERRAIN_BRICK = "BRICK"
    fmod.TERRAIN_GRASS = "GRASS"
    fmod.TERRAIN_MOSS = "MOSS"
    fmod.TERRAIN_WET_ORGANIC = "WET_ORGANIC"
    fmod.TERRAIN_PLATFORM = "PLATFORM"
    fmod.TERRAIN_ORE = "ORE"
    fmod.TERRAIN_MANA = "MANA"
    fmod.TERRAIN_SANDSTONE = "SANDSTONE"
    fmod.HarvestTile = HarvestTile or ({})
    fmod.HarvestTile.Dirt = 0
    fmod.HarvestTile[fmod.HarvestTile.Dirt] = "Dirt"
    fmod.HarvestTile.Stone = 1
    fmod.HarvestTile[fmod.HarvestTile.Stone] = "Stone"
    fmod.HarvestTile.Organic = 2
    fmod.HarvestTile[fmod.HarvestTile.Organic] = "Organic"
    function fmod.updateGlobalParameters(self, realm, player, camera)
        local position = camera:getPosition()
        audio.updateAttributes(position)
        audio.setParameterByName(
            "TIME_OF_DAY",
            realm.time:getHour()
        )
        audio.setParameterByName(
            "HEALTH",
            math.ceil(player.stats:get("HP"):percentage() * 100)
        )
        local realmHeight = realm.size.y * Sizes.TILE
        local elevation = (realmHeight - position.y) / realmHeight * 200 - 100
        audio.setParameterByName(
            "ELEVATION",
            math.floor(elevation)
        )
        if realm.biome.currentBiome then
            local location = BIOME_LOCATIONS:get(realm.biome.currentBiome.type)
            audio.setParameterByNameWithLabel("LOCATION", location)
        end
        local viewportRatio = VIEWPORT_BASELINE / (camera.viewport.width * camera.viewport.height)
        local fabricatorCount = 0
        local nearbyEntities = realm.spatialHash:queryCulled(camera.viewport)
        do
            local index = 0
            while index < #nearbyEntities do
                do
                    local entityID = nearbyEntities[index + 1]
                    if not EntityManager.has(entityID) then
                        goto __continue5
                    end
                    local entity = EntityManager.get(entityID)
                    if entity.fabricator ~= nil then
                        fabricatorCount = fabricatorCount + 1
                    end
                end
                ::__continue5::
                index = index + 1
            end
        end
        local factoryLevel = clamp(
            math.floor(fabricatorCount * viewportRatio / FABRICATOR_SCALE * 100),
            0,
            100
        )
        audio.setParameterByName("FACTORY", factoryLevel)
        local center = player:getCenter()
        local monsters = realm.monsterLayer.spatialHash:queryCulled(center, MAX_THREAT_DISTANCE)
        local closest = MAX_THREAT_DISTANCE
        local threatLevel = 0
        if #monsters > 0 then
            do
                local i = 0
                while i < #monsters do
                    local monster = EntityManager.get(monsters[i + 1])
                    local distance = monster:getCenter():getDistance(center)
                    if distance < closest then
                        closest = distance
                    end
                    i = i + 1
                end
            end
            threatLevel = clamp((1 - (closest - MIN_THREAT_DISTANCE) / MAX_THREAT_DISTANCE) * 100, 0, 100)
        end
        audio.setParameterByName("THREAT", threatLevel)
    end
end
____exports.fmod = fmod
return ____exports
