local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 2,["9"] = 2,["10"] = 3,["11"] = 3,["12"] = 4,["13"] = 4,["14"] = 6,["15"] = 8,["16"] = 10,["17"] = 14,["18"] = 16,["19"] = 21,["20"] = 26,["21"] = 31,["22"] = 33,["23"] = 33,["24"] = 33,["25"] = 33,["26"] = 33,["27"] = 33,["28"] = 33,["29"] = 32,["30"] = 34,["31"] = 34,["32"] = 34,["33"] = 34,["34"] = 34,["35"] = 34,["36"] = 34,["37"] = 32,["38"] = 35,["39"] = 35,["40"] = 35,["41"] = 35,["42"] = 35,["43"] = 35,["44"] = 35,["45"] = 32,["46"] = 36,["47"] = 36,["48"] = 36,["49"] = 36,["50"] = 36,["51"] = 36,["52"] = 36,["53"] = 32,["54"] = 31,["55"] = 40,["56"] = 40,["57"] = 40,["58"] = 40,["59"] = 45});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____utility = require("utility")
local interactTorch = ____utility.interactTorch
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("candle_dungeon-1")
prefab:addItem({icon = "icons_torch", stack = 99})
prefab:addAnimation({start = "running", loop = true})
prefab:addAmbience({sfx = "event:/GENERAL/TORCH_LOOP", autostart = true})
prefab:addPlacement({axes = {
    PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(1, 1),
            "candle_dungeon.running"
        )}
    ),
    PlacementAxis.new(
        PlacementAxisType.Backwall,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(1, 1),
            "candle_dungeon.back_running"
        )}
    ),
    PlacementAxis.new(
        PlacementAxisType.LeftWall,
        {PlacementDirection.new(
            FacingDirection.Left,
            TileVector.new(1, 1),
            "candle_dungeon.left_running"
        )}
    ),
    PlacementAxis.new(
        PlacementAxisType.RightWall,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(1, 1),
            "candle_dungeon.right_running"
        )}
    )
}})
prefab:addLight({
    intensity = 200,
    color = Color.new(183, 246, 247)
})
prefab:addEvent({interact = __TS__New(Event, interactTorch)})
return ____exports
