local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 5,["16"] = 5,["17"] = 5,["18"] = 7,["19"] = 9,["20"] = 13,["21"] = 17,["22"] = 19,["23"] = 21,["24"] = 26,["25"] = 27,["26"] = 28,["27"] = 30,["28"] = 30,["29"] = 32,["30"] = 32,["31"] = 32,["32"] = 33,["33"] = 34,["36"] = 38,["37"] = 39,["38"] = 41,["39"] = 42,["40"] = 43,["41"] = 44,["42"] = 44,["43"] = 44,["44"] = 44,["45"] = 44,["46"] = 51,["47"] = 51,["48"] = 51,["49"] = 51,["50"] = 51,["53"] = 61,["54"] = 62,["55"] = 63,["56"] = 65,["57"] = 65,["58"] = 65,["59"] = 66,["60"] = 67,["61"] = 67,["62"] = 67,["63"] = 67,["64"] = 67,["65"] = 68,["66"] = 69,["67"] = 70,["68"] = 71,["69"] = 70,["70"] = 73,["71"] = 65,["72"] = 65,["73"] = 32,["74"] = 30,["75"] = 30,["76"] = 78,["77"] = 79,["78"] = 79,["79"] = 80,["80"] = 80,["81"] = 79,["82"] = 78,["83"] = 84,["84"] = 84,["85"] = 86,["86"] = 86,["87"] = 86,["88"] = 84,["89"] = 87,["90"] = 88,["91"] = 88,["92"] = 88,["93"] = 88,["94"] = 88,["95"] = 88,["96"] = 84,["97"] = 84,["98"] = 92,["99"] = 92,["100"] = 92,["101"] = 92,["102"] = 92});
local ____exports = {}
local ____architect = require("architect")
local architect = ____architect.architect
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____tween = require("systems.tween")
local Easing = ____tween.Easing
local Tween = ____tween.Tween
local prefab = Prefab.getCurrent()
prefab:addTransform({origin = Vector.new(16, 24)})
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("ancient_tech_entangled")
prefab:addIllumination(0.5)
prefab:addAnimation({start = "idle", loop = true})
local harvest_hs = HashString("ancient_tech_entangled.harvest")
local hover_hs = HashString("ancient_tech_entangled.hover")
local pop_hs = HashString("ancient_tech_entangled.pop")
prefab:addEvent({
    interactText = "COLLECT",
    harvest = __TS__New(
        Event,
        function(player, entity)
            local hp = entity.stats:get("HP")
            if hp:get() == 0 then
                return
            end
            player.input:harvest(player, 300)
            hp:adjust(-1)
            if hp:get() > 0 then
                audio.start("event:/PLAYER/DIG/DIG", entity.transform.position, "MATERIAL", "ANCIENT_TECH")
                local position = entity.transform.position:copy()
                __TS__New(Tween, entity.id, "transform", "position"):to(
                    {x = position.x + (Random.getBool() and -2 or 2)},
                    50,
                    Easing.Linear
                ):chain(__TS__New(Tween):to({x = position.x}, 50, Easing.Bounce.Out)):start()
                __TS__New(Tween, entity.id, "transform"):to(
                    {angle = Random.getBool() and 3 or -3},
                    50,
                    Easing.Bounce.InOut
                ):chain(__TS__New(Tween):to({angle = 0}, 50, Easing.Bounce.InOut)):start()
                return
            end
            audio.start("event:/PLAYER/CHOP/TREE_FELL", entity.transform.position, "IS_TREE", 1)
            animator.play(entity, harvest_hs)
            animator.queue(entity, hover_hs, true)
            entity.event.interact = __TS__New(
                Event,
                function(player, entity)
                    audio.start("event:/RESOURCE/HARVEST_ENT_ANCIENT_TECH", entity.transform.position)
                    architect:addOrDropItemsPlayer(
                        player,
                        {Item.create("material.ancient_tech")},
                        player.physics.body:center()
                    )
                    animator.play(entity, pop_hs)
                    local entityID = entity.id
                    entity.animation.onFinished:listen(function(____, name)
                        EntityManager.destroy(entityID)
                    end)
                    return false
                end
            )
        end
    )
})
prefab:addStats({stats = __TS__New(
    Map,
    {{
        "HP",
        Stat.new(5, 5)
    }}
)})
prefab:addPlacement({
    supportTags = {"natural"},
    features = bit.bor(
        bit.bor(PlacementFeatures.TileOverlapable, PlacementFeatures.Targetable),
        PlacementFeatures.Indestructible
    ),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(2, 3),
            "ancient_tech_entangled.idle"
        )}
    )}
})
prefab:addLight({
    intensity = 45,
    color = Color.new(178, 230, 221),
    needsExploration = false
})
return ____exports
