local ____lualib = require("lualib_bundle")
local __TS__StringEndsWith = ____lualib.__TS__StringEndsWith
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 5,["16"] = 5,["17"] = 6,["18"] = 6,["19"] = 9,["20"] = 11,["21"] = 13,["22"] = 17,["23"] = 19,["24"] = 21,["25"] = 25,["26"] = 25,["27"] = 27,["28"] = 28,["29"] = 28,["30"] = 28,["31"] = 28,["32"] = 28,["33"] = 28,["34"] = 25,["35"] = 25,["36"] = 32,["37"] = 33,["38"] = 33,["39"] = 33,["40"] = 35,["41"] = 36,["42"] = 37,["43"] = 37,["44"] = 37,["45"] = 37,["46"] = 38,["49"] = 42,["50"] = 43,["51"] = 44,["54"] = 48,["55"] = 49,["56"] = 50,["57"] = 52,["58"] = 53,["59"] = 53,["60"] = 53,["61"] = 54,["62"] = 53,["63"] = 53,["64"] = 56,["65"] = 52,["66"] = 33,["67"] = 32,["68"] = 59,["69"] = 59,["70"] = 59,["71"] = 60,["72"] = 61,["73"] = 62,["74"] = 59,["75"] = 32,["76"] = 32,["77"] = 66,["78"] = 66,["79"] = 66,["80"] = 66});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____scheduler = require("systems.scheduler")
local scheduler = ____scheduler.scheduler
local ____base = require("ui.base")
local showDialog = ____base.showDialog
local ____world = require("world")
local World = ____world.World
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("mainframe", {layer = 2})
prefab:addIllumination(1)
prefab:addAnimation({start = "idle"})
prefab:addPlacement({
    features = bit.bor(PlacementFeatures.Targetable, PlacementFeatures.Indestructible),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(2, 5),
            "mainframe-1"
        )}
    )}
})
prefab:addEvent({
    interact = __TS__New(
        Event,
        function(player, entity)
            local realm = World:get(player.location.realm)
            local apotheos = EntityManager.get(realm.apotheos)
            if __TS__StringEndsWith(
                apotheos.animation:current().name:str(),
                "off"
            ) then
                apotheos.event.interact:invoke(player, apotheos)
                return
            end
            local dialog = UIManager.get("Mainframe")
            if dialog.view:isVisible() then
                dialog:hide()
                return
            end
            audio.start("event:/APOTHEOS/APO_HOLOGRAM_OPEN", entity.transform.position)
            animator.play(entity, "on")
            animator.queue(entity, "running", true)
            entity.animation.onFinished:listen(function(____, name)
                scheduler:add(
                    100,
                    function()
                        showDialog(nil, "Mainframe", entity)
                    end
                )
                return false
            end)
        end
    ),
    withdraw = __TS__New(
        Event,
        function(player, entity)
            audio.start("event:/APOTHEOS/APO_HOLOGRAM_CLOSE", entity.transform.position)
            animator.play(entity, "off")
            animator.queue(entity, "idle", true)
        end
    )
})
prefab:addLight({
    intensity = 120,
    color = Color.new(158, 228, 255)
})
return ____exports
