local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 2,["9"] = 2,["10"] = 3,["11"] = 3,["12"] = 4,["13"] = 4,["14"] = 6,["15"] = 8,["16"] = 10,["17"] = 14,["18"] = 16,["19"] = 18,["20"] = 23,["21"] = 28,["22"] = 33,["23"] = 33,["24"] = 35,["25"] = 36,["26"] = 36,["27"] = 36,["28"] = 36,["29"] = 36,["30"] = 36,["31"] = 36,["32"] = 35,["33"] = 37,["34"] = 37,["35"] = 37,["36"] = 37,["37"] = 37,["38"] = 37,["39"] = 37,["40"] = 37,["41"] = 35,["42"] = 38,["43"] = 38,["44"] = 38,["45"] = 38,["46"] = 38,["47"] = 38,["48"] = 38,["49"] = 38,["50"] = 35,["51"] = 39,["52"] = 39,["53"] = 39,["54"] = 39,["55"] = 39,["56"] = 39,["57"] = 39,["58"] = 39,["59"] = 35,["60"] = 33,["61"] = 33,["62"] = 43,["63"] = 43,["64"] = 43,["65"] = 43,["66"] = 48});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____utility = require("utility")
local interactTorch = ____utility.interactTorch
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("torch-1")
prefab:addIllumination(1)
prefab:addItem({icon = "icons_torch", stack = 99})
prefab:addAnimation({start = "running", loop = true})
prefab:addAmbience({sfx = "event:/GENERAL/TORCH_LOOP", autostart = true})
prefab:addPlacement({
    drop = Prefab.getID("environment.torch"),
    axes = {
        PlacementAxis.new(
            PlacementAxisType.Floor,
            {PlacementDirection.new(
                FacingDirection.Right,
                TileVector.new(1, 1),
                "torch.running"
            )}
        ),
        PlacementAxis.new(
            PlacementAxisType.Backwall,
            {PlacementDirection.new(
                FacingDirection.Right,
                TileVector.new(1, 1),
                "torch.back_running"
            )},
            PixelVector.new(0, -8)
        ),
        PlacementAxis.new(
            PlacementAxisType.LeftWall,
            {PlacementDirection.new(
                FacingDirection.Right,
                TileVector.new(1, 1),
                "torch.left_running"
            )},
            PixelVector.new(0, -8)
        ),
        PlacementAxis.new(
            PlacementAxisType.RightWall,
            {PlacementDirection.new(
                FacingDirection.Right,
                TileVector.new(1, 1),
                "torch.right_running"
            )},
            PixelVector.new(0, -8)
        )
    }
})
prefab:addLight({
    intensity = 200,
    color = Color.new(255, 255, 180)
})
prefab:addEvent({interact = __TS__New(Event, interactTorch)})
return ____exports
