local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 2,["9"] = 2,["10"] = 3,["11"] = 3,["12"] = 4,["13"] = 4,["14"] = 5,["15"] = 5,["16"] = 7,["17"] = 8,["18"] = 10,["19"] = 12,["20"] = 16,["21"] = 20,["22"] = 24,["23"] = 25,["24"] = 26,["25"] = 26,["26"] = 26,["27"] = 26,["28"] = 26,["29"] = 26,["30"] = 26,["31"] = 26,["32"] = 26,["33"] = 26,["34"] = 25,["35"] = 27,["36"] = 27,["37"] = 27,["38"] = 27,["39"] = 27,["40"] = 27,["41"] = 27,["42"] = 27,["43"] = 27,["44"] = 27,["45"] = 25,["46"] = 28,["47"] = 28,["48"] = 28,["49"] = 28,["50"] = 28,["51"] = 28,["52"] = 28,["53"] = 28,["54"] = 28,["55"] = 28,["56"] = 25,["57"] = 29,["58"] = 29,["59"] = 29,["60"] = 29,["61"] = 29,["62"] = 29,["63"] = 29,["64"] = 29,["65"] = 29,["66"] = 29,["67"] = 25,["68"] = 24,["69"] = 24,["70"] = 24,["71"] = 24,["72"] = 24,["73"] = 36,["74"] = 36,["75"] = 36,["76"] = 39,["77"] = 40,["78"] = 40,["79"] = 40,["80"] = 40,["81"] = 40,["82"] = 40,["83"] = 40,["84"] = 39,["85"] = 41,["86"] = 41,["87"] = 41,["88"] = 41,["89"] = 41,["90"] = 41,["91"] = 41,["92"] = 39,["93"] = 36,["94"] = 36});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____Sizes = require("Sizes")
local Sizes = ____Sizes.Sizes
local ____utility = require("utility")
local harvestPlant = ____utility.harvestPlant
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addItem({icon = "underground_garnish_rocks_large_top_1"})
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("underground_garnish_rocks_large_top_1", {layer = 5})
prefab:addEvent({harvest = __TS__New(Event, harvestPlant)})
prefab:addPlant({
    stages = {
        PlantStageAxis.new(
            "underground_garnish_rocks_large_top_1",
            PlacementAxisType.Ceiling,
            0,
            0,
            {{
                type = PlantHarvestTypes.Manual,
                loot = "rocks_large",
                time = seconds(5)
            }}
        ),
        PlantStageAxis.new(
            "underground_garnish_rocks_large_top_2",
            PlacementAxisType.Ceiling,
            0,
            0,
            {{
                type = PlantHarvestTypes.Manual,
                loot = "rocks_large",
                time = seconds(5)
            }}
        ),
        PlantStageAxis.new(
            "underground_garnish_rocks_large_bottom_1",
            PlacementAxisType.Floor,
            0,
            0,
            {{
                type = PlantHarvestTypes.Manual,
                loot = "rocks_large",
                time = seconds(5)
            }}
        ),
        PlantStageAxis.new(
            "underground_garnish_rocks_large_bottom_2",
            PlacementAxisType.Floor,
            0,
            0,
            {{
                type = PlantHarvestTypes.Manual,
                loot = "rocks_large",
                time = seconds(5)
            }}
        )
    },
    area = Vector.new(Sizes.TILE * 1.5, Sizes.TILE),
    variations = 1,
    life = 20
})
prefab:addPlacement({
    supportTags = {"natural"},
    features = bit.bor(PlacementFeatures.TileOverlapable, PlacementFeatures.Targetable),
    axes = {
        PlacementAxis.new(
            PlacementAxisType.Ceiling,
            {PlacementDirection.new(
                FacingDirection.Right,
                TileVector.new(3, 2),
                "underground_garnish_rocks_large_top_1"
            )}
        ),
        PlacementAxis.new(
            PlacementAxisType.Floor,
            {PlacementDirection.new(
                FacingDirection.Right,
                TileVector.new(3, 2),
                "underground_garnish_rocks_large_bottom_1"
            )}
        )
    }
})
return ____exports
