local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 2,["9"] = 2,["10"] = 3,["11"] = 3,["12"] = 6,["13"] = 8,["14"] = 10,["15"] = 14,["16"] = 16,["17"] = 16,["18"] = 18,["19"] = 19,["20"] = 19,["21"] = 19,["22"] = 19,["23"] = 19,["24"] = 19,["25"] = 16,["26"] = 16,["27"] = 23,["28"] = 25,["29"] = 26,["30"] = 27,["31"] = 28,["32"] = 29,["33"] = 30,["34"] = 31,["35"] = 32,["36"] = 33,["37"] = 34,["38"] = 35,["39"] = 36,["40"] = 37,["41"] = 38,["43"] = 40,["45"] = 42,["46"] = 43,["48"] = 25,["49"] = 47});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Monster})
prefab:addRender("scavenger")
prefab:addPlacement({
    features = PlacementFeatures.None,
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(2, 3),
            "scavenger"
        )}
    )}
})
prefab:addNpc({})
local function interact(player, entity)
    local npc = entity.npc
    if npc.state == 0 then
        UIManager.get("Hud").chat:receive("Scavenger: Salutations! Would you happen to have 50 jelly? I need some!")
        npc.state = 1
    elseif npc.state == 1 then
        local inventory = player.inventory:get()
        local slimes = Item.create("material.oil_clot", 100)
        if inventory:has(slimes) then
            inventory:remove(slimes)
            inventory:add(Item.create("fauna.speep_egg", 1))
            inventory:add(Item.create("material.void_matter", 15))
            UIManager.get("Hud").chat:receive("Scavenger: Thank you! Please take this as a token of my appreciation.")
            npc.state = 2
        else
            UIManager.get("Hud").chat:receive("Scavenger: Please! I need 50 jelly.")
        end
    elseif npc.state == 2 then
        UIManager.get("Hud").chat:receive("Scavenger: Thanks again!")
    end
end
prefab:addEvent({interact = __TS__New(Event, interact)})
return ____exports
