local ____lualib = require("lualib_bundle")
local Map = ____lualib.Map
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 5,["16"] = 5,["17"] = 7,["18"] = 8,["19"] = 11,["20"] = 15,["21"] = 19,["22"] = 21,["23"] = 25,["24"] = 25,["25"] = 25,["26"] = 25,["27"] = 25,["28"] = 25,["29"] = 25,["30"] = 33,["31"] = 33,["32"] = 33,["33"] = 36,["34"] = 37,["35"] = 37,["36"] = 37,["37"] = 37,["38"] = 37,["39"] = 37,["40"] = 33,["41"] = 33});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____farming = require("farming")
local FarmingData = ____farming.FarmingData
local ____utility = require("utility")
local harvestPlant = ____utility.harvestPlant
local prefab = Prefab.getCurrent()
prefab:addTransform({origin = Vector.new(56, 160)})
prefab:addLocation({layer = LayerTypes.Back})
prefab:addRender("dead_tree-1", {layer = 5})
prefab:addIllumination(1)
prefab:addEvent({harvest = __TS__New(Event, harvestPlant)})
prefab:addPlant({
    stages = FarmingData:get("Dead Tree"),
    area = Vector.new(24, 24),
    variations = 3,
    life = 15,
    dropPosition = Vector.new(0, -32)
})
prefab:addPlacement({
    supportTags = {"natural"},
    features = bit.bor(PlacementFeatures.TileOverlapable, PlacementFeatures.Targetable),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(1, 1),
            "dead_tree-1"
        )}
    )}
})
return ____exports
