local ____lualib = require("lualib_bundle")
local Map = ____lualib.Map
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 4,["16"] = 4,["17"] = 5,["18"] = 5,["19"] = 7,["20"] = 8,["21"] = 12,["22"] = 16,["23"] = 20,["24"] = 22,["25"] = 26,["26"] = 26,["27"] = 26,["28"] = 26,["29"] = 26,["30"] = 26,["31"] = 26,["32"] = 26,["33"] = 26,["34"] = 36,["35"] = 36,["36"] = 36,["37"] = 36,["38"] = 40,["39"] = 41,["40"] = 41,["41"] = 41,["42"] = 41,["43"] = 41,["44"] = 41,["45"] = 36,["46"] = 36,["47"] = 45,["48"] = 45,["49"] = 45,["50"] = 45});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____farming = require("farming")
local FarmingData = ____farming.FarmingData
local FarmingFluids = ____farming.FarmingFluids
local FarmingRevives = ____farming.FarmingRevives
local ____utility = require("utility")
local harvestPlant = ____utility.harvestPlant
local prefab = Prefab.getCurrent()
prefab:addTransform({origin = Vector.new(24, 64)})
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("globoi-1", {layer = 1})
prefab:addIllumination(0.75)
prefab:addEvent({harvest = __TS__New(Event, harvestPlant)})
prefab:addPlant({
    stages = FarmingData:get("Globoi"),
    fluids = FarmingFluids:get("Globoi"),
    revives = FarmingRevives:get("Globoi"),
    area = Vector.new(24, 24),
    variations = 1,
    life = 12,
    dropPosition = Vector.new(0, -32)
})
prefab:addPlacement({
    created = HashString("flora.globoi"),
    supportTags = {"natural"},
    features = PlacementFeatures.Targetable,
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(1, 1),
            "globoi-1"
        )}
    )}
})
prefab:addLight({
    intensity = 90,
    color = Color.new(96, 222, 164)
})
return ____exports
