local ____lualib = require("lualib_bundle")
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["5"] = 1,["6"] = 1,["7"] = 2,["8"] = 2,["9"] = 3,["10"] = 3,["11"] = 4,["12"] = 4,["13"] = 6,["14"] = 7,["15"] = 9,["16"] = 11,["17"] = 11,["18"] = 11,["19"] = 14,["20"] = 15,["21"] = 11,["22"] = 17,["23"] = 18,["24"] = 19,["25"] = 20,["26"] = 20,["27"] = 20,["28"] = 20,["29"] = 20,["30"] = 20,["31"] = 20,["32"] = 21,["33"] = 11,["34"] = 11,["35"] = 11,["36"] = 26,["37"] = 30});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____fmod = require("fmod")
local fmod = ____fmod.fmod
local ____Sizes = require("Sizes")
local Sizes = ____Sizes.Sizes
local ____utility = require("utility")
local showFxAttached = ____utility.showFxAttached
local prefab = Prefab.getCurrent()
prefab:addTransform()
local fx_heal_hs = HashString("heal_fx.loop")
prefab:addItem({
    icon = "icons_health_canister",
    stack = 100,
    canUse = function(____, entity)
        return not entity.stats:get("HP"):isFull()
    end,
    onUse = function(____, entity)
        entity.stats:get("HP"):adjustCurrent(4)
        local position = entity.transform.position
        showFxAttached(
            nil,
            fx_heal_hs,
            entity,
            position,
            Vector.new(0, Sizes.TILE)
        )
        audio.start("event:/PLAYER/OTTO_HEAL", position)
    end,
    materialSound = fmod.MATERIAL_METAL
})
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("icons_health_canister")
return ____exports
