local ____lualib = require("lualib_bundle")
local Map = ____lualib.Map
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 5,["12"] = 7,["13"] = 11,["14"] = 15,["15"] = 17,["16"] = 19,["17"] = 19,["18"] = 21,["19"] = 22,["20"] = 22,["21"] = 22,["22"] = 22,["23"] = 22,["24"] = 22,["25"] = 19,["26"] = 19,["27"] = 26,["28"] = 27,["29"] = 27,["30"] = 28,["31"] = 28,["32"] = 28,["33"] = 27,["34"] = 29,["35"] = 29,["36"] = 29,["37"] = 27,["38"] = 27,["39"] = 26,["40"] = 33,["41"] = 33,["42"] = 33,["43"] = 33,["44"] = 37,["45"] = 38,["46"] = 33,["47"] = 33,["48"] = 42,["49"] = 42,["50"] = 42,["51"] = 42,["52"] = 42,["53"] = 42});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local prefab = Prefab.getCurrent()
prefab:addTransform({origin = Vector.new(24, 24)})
prefab:addLocation({layer = LayerTypes.Monster})
prefab:addRender("fire_wisp_spawner-1")
prefab:addAnimation({})
prefab:addPlacement({
    features = bit.bor(PlacementFeatures.Overlapable, PlacementFeatures.Indestructible),
    axes = {PlacementAxis.new(
        PlacementAxisType.Backwall,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(2, 2),
            "fire_wisp_spawner-1"
        )}
    )}
})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(12, 99, 12)
        },
        {
            "DEF",
            Stat.new(2, 99, 2)
        }
    }
)})
prefab:addCombat({
    team = CombatTeam.Monster,
    priority = CombatPriority.High,
    loot = "fire_wisp_spawner",
    onDefend = function(____, attacker, defender)
        SpawnerSystem.get():callToArms(attacker, defender)
    end
})
prefab:addSpawner({
    monster = "monster.oil_slime",
    sfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_SPAWN",
    frequency = seconds(20),
    total = 3
})
return ____exports
