local ____lualib = require("lualib_bundle")
local Map = ____lualib.Map
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 4,["12"] = 6,["13"] = 10,["14"] = 14,["15"] = 16,["16"] = 18,["17"] = 23,["18"] = 23,["19"] = 23,["20"] = 23,["21"] = 23,["22"] = 23,["23"] = 23,["24"] = 23,["25"] = 32,["26"] = 33,["27"] = 33,["28"] = 34,["29"] = 34,["30"] = 34,["31"] = 33,["32"] = 35,["33"] = 35,["34"] = 35,["35"] = 33,["36"] = 36,["37"] = 36,["38"] = 36,["39"] = 33,["40"] = 33,["41"] = 32,["42"] = 41,["43"] = 63,["44"] = 63,["45"] = 63,["46"] = 63,["47"] = 63,["48"] = 61,["49"] = 71,["50"] = 71,["51"] = 71,["52"] = 71,["53"] = 71,["54"] = 71,["55"] = 71,["56"] = 71,["57"] = 71,["58"] = 71,["59"] = 71,["60"] = 61,["61"] = 86,["62"] = 86,["63"] = 86,["64"] = 86,["65"] = 86,["66"] = 86,["67"] = 86,["68"] = 86,["69"] = 61,["70"] = 93,["71"] = 93,["72"] = 61,["73"] = 94,["74"] = 94,["75"] = 94,["76"] = 94,["77"] = 94,["78"] = 51,["79"] = 114,["80"] = 114,["81"] = 114,["82"] = 114,["83"] = 114,["84"] = 114,["85"] = 102,["86"] = 122,["87"] = 122,["88"] = 122,["89"] = 122,["90"] = 122,["91"] = 122,["92"] = 122,["93"] = 122,["94"] = 122,["95"] = 41,["96"] = 136,["97"] = 136,["98"] = 136,["99"] = 136,["100"] = 136,["101"] = 136,["102"] = 142,["103"] = 143,["104"] = 144,["105"] = 144,["106"] = 144,["107"] = 144,["108"] = 136,["109"] = 136,["110"] = 148,["111"] = 148,["112"] = 148,["113"] = 148});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____Sizes = require("Sizes")
local Sizes = ____Sizes.Sizes
local prefab = Prefab.getCurrent()
prefab:addTransform({origin = Vector.new(16, 18)})
prefab:addLocation({layer = LayerTypes.Monster})
prefab:addRender("lotus", {layer = 1})
prefab:addIllumination(1)
prefab:addAnimation({start = "idle", loop = true})
prefab:addPhysics({
    offset = Vector.new(-9, -10),
    body = Rect.new(0, 0, 19, 20),
    allowSleep = false,
    layer = PhysicsLayers.MONSTER,
    filter = PhysicsLayers.GROUND,
    gravityScale = 0
})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(8, 99, 8)
        },
        {
            "ATK",
            Stat.new(2, 99)
        },
        {
            "DEF",
            Stat.new(1, 99)
        }
    }
)})
prefab:addBehavior({tree = BehaviorTree.new("lotus"):root(ReactiveSelectorNode.new("root"):add(SequenceNode.new("destroy_block"):add(HasEntryNode.new("destroy_block_check", {entry = "destroyBlock"})):add(DestroyBlockNode.new("destroy_block", {frequency = 1000, amount = 1}))):add(SelectorNode.new("general_pathing"):add(ReactiveSelectorNode.new("aggressive_pathing"):add(SequenceNode.new("destroy_block"):add(HasEntryNode.new("destroy_block_check", {entry = "destroyBlock"})):add(DestroyBlockNode.new("destroy_block", {frequency = 1000, amount = 1}))):add(SequenceNode.new("pathing"):add(HasExpiredNode.new("wait_cooldown", {entry = "cooldown"})):add(FindTargetNode.new("find_target", {
    team = CombatTeamTarget.Enemy,
    distance = Sizes.SEGMENT,
    distanceWeight = 1,
    stickyWeight = 0.5,
    healthWeight = 0.3
})):add(PathToNode.new("path_to", {entry = "target"})):add(MoveToNode.new(
    "move",
    {
        movement = MovementType.Fly,
        acceleration = Vector.new(0.5, 0.5),
        speed = Vector.new(0.8, 0.8),
        acceptableRadius = Sizes.CHUNK * 2,
        timeout = seconds(5),
        timeoutResult = BehaviorStatus.Failure,
        canDestroyBlocks = true,
        moveSfx = "event:/ENEMIES/LOTUS/LOTUS_MOVE"
    }
)):add(FaceEntityNode.new("face_target", {entry = "target"})):add(PlaySoundNode.new("play_charge_sound", {sound = "event:/ENEMIES/LOTUS/LOTUS_CHARGE"})):add(PlayAnimationNode.new("play_charge", {name = "shoot_charge", blocking = true})):add(PlaySoundNode.new("play_attack_sound", {sound = "event:/ENEMIES/LOTUS/LOTUS_ATTACK"})):add(PlayAnimationNode.new("play_fire", {name = "shoot_fire"})):add(FireProjectileNode.new(
    "fire_projectile",
    {
        prefab = "monster.lotus_projectile",
        speed = 3,
        lifetime = seconds(2.5),
        accuracyVariance = 0.2,
        collidesWithGround = false
    }
)):add(WaitNode.new(
    "shoot_wait",
    seconds(1)
)):add(SetEntryNode.new(
    "set_cooldown",
    {
        entry = "cooldown",
        timerValue = GameTimer.new(seconds(2))
    }
)))):add(SequenceNode.new("wander"):add(PlayAnimationNode.new("play_idle", {name = "idle", loop = true})):add(ReactiveSelectorNode.new("validation"):add(ValidateTargetNode.new("validate", {entry = "structure"})):add(FindStructureNode.new("find_structure", {}))):add(SelectorNode.new("pathing"):add(SequenceNode.new("detour"):add(HasEntryNode.new("check_detour", {entry = "detour"})):add(PathToNode.new("path_detour", {entry = "detour"})):add(RemoveEntryNode.new("clear_detour", {entry = "detour"}))):add(PathRoamNode.new(
    "path_roam",
    {
        movement = MovementType.Fly,
        entry = "structure",
        distance = FloatRange.new(0, Sizes.CHUNK * 2)
    }
))):add(SequenceNode.new("move_roam_cooldown"):add(HasExpiredNode.new("wait_cooldown", {entry = "cooldown"})):add(MoveToNode.new(
    "move_roam",
    {
        movement = MovementType.Fly,
        acceleration = Vector.new(0.8, 0.8),
        speed = Vector.new(0.8, 0.8),
        timeout = seconds(3),
        canDestroyBlocks = true,
        moveSfx = "event:/ENEMIES/LOTUS/LOTUS_MOVE"
    }
))))))})
prefab:addCombat({
    team = CombatTeam.Monster,
    loot = "lotus",
    isAttacking = true,
    takeHitSfx = "event:/ENEMIES/LOTUS/LOTUS_TAKEHIT",
    deathSfx = "event:/ENEMIES/LOTUS/LOTUS_DEATH",
    onDefend = function(____, attacker, defender)
        local data = defender.behavior.data
        data:setTimer(
            "attackTimer",
            GameTimer.new(seconds(20))
        )
    end
})
prefab:addLight({
    intensity = 70,
    color = Color.new(255, 211, 230)
})
return ____exports
