local ____lualib = require("lualib_bundle")
local Map = ____lualib.Map
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 4,["12"] = 6,["13"] = 10,["14"] = 14,["15"] = 16,["16"] = 18,["17"] = 23,["18"] = 23,["19"] = 23,["20"] = 23,["21"] = 23,["22"] = 23,["23"] = 23,["24"] = 23,["25"] = 32,["26"] = 33,["27"] = 33,["28"] = 34,["29"] = 34,["30"] = 34,["31"] = 33,["32"] = 35,["33"] = 35,["34"] = 35,["35"] = 33,["36"] = 36,["37"] = 36,["38"] = 36,["39"] = 33,["40"] = 33,["41"] = 32,["42"] = 40,["43"] = 44,["44"] = 44,["45"] = 41,["46"] = 67,["47"] = 67,["48"] = 67,["49"] = 67,["50"] = 67,["51"] = 62,["52"] = 76,["53"] = 76,["54"] = 76,["55"] = 76,["56"] = 76,["57"] = 76,["58"] = 76,["59"] = 76,["60"] = 76,["61"] = 76,["62"] = 76,["63"] = 76,["64"] = 76,["65"] = 76,["66"] = 76,["67"] = 62,["68"] = 96,["69"] = 96,["70"] = 41,["71"] = 102,["72"] = 102,["73"] = 102,["74"] = 102,["75"] = 102,["76"] = 102,["77"] = 100,["78"] = 107,["79"] = 107,["80"] = 107,["81"] = 107,["82"] = 107,["83"] = 107,["84"] = 107,["85"] = 107,["86"] = 107,["87"] = 107,["88"] = 107,["89"] = 107,["90"] = 107,["91"] = 107,["92"] = 100,["93"] = 121,["94"] = 121,["95"] = 40,["96"] = 126,["97"] = 126,["98"] = 126,["99"] = 126,["100"] = 126,["101"] = 126,["102"] = 132,["103"] = 133,["104"] = 134,["105"] = 134,["106"] = 134,["107"] = 134,["108"] = 126,["109"] = 126,["110"] = 138});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____Sizes = require("Sizes")
local Sizes = ____Sizes.Sizes
local prefab = Prefab.getCurrent()
prefab:addTransform({origin = Vector.new(24, 38)})
prefab:addLocation({layer = LayerTypes.Monster})
prefab:addRender("oil_slime", {layer = 1})
prefab:addIllumination(1)
prefab:addAnimation({start = "idle", loop = true})
prefab:addPhysics({
    offset = Vector.new(-10, -18),
    body = Rect.new(0, 0, 20, 20),
    layer = PhysicsLayers.MONSTER,
    filter = PhysicsLayers.GROUND,
    friction = 1,
    restitution = 0
})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(10, 99, 10)
        },
        {
            "ATK",
            Stat.new(3, 99)
        },
        {
            "DEF",
            Stat.new(1, 99)
        }
    }
)})
prefab:addBehavior({tree = BehaviorTree.new("oil_slime"):root(ReactiveSelectorNode.new("root"):add(SequenceNode.new("idle"):add(CanIdleNode.new("can_idle")):add(WaitNode.new(
    "idle_wait",
    seconds(2)
))):add(SequenceNode.new("create_block"):add(HasEntryNode.new("create_block_check", {entry = "createBlock"})):add(CreateBlockNode.new("create_block", {tile = "tile.soil", frequency = 500, amount = 1}))):add(SequenceNode.new("destroy_block"):add(HasEntryNode.new("destroy_block_check", {entry = "destroyBlock"})):add(DestroyBlockNode.new("destroy_block", {frequency = 1000, amount = 1}))):add(SequenceNode.new("night_pathing"):add(SelectorNode.new("aggro_check"):add(InvertNode.new("night_check"):set(IsDaytimeNode.new("daycheck"))):add(InvertNode.new("attack_timer"):set(HasExpiredNode.new("attack_timer", {entry = "attackTimer"})))):add(FindTargetNode.new("find_target", {
    team = CombatTeamTarget.Enemy,
    distance = Sizes.SEGMENT,
    distanceWeight = 1,
    stickyWeight = 0.5,
    healthWeight = 0.3
})):add(ReactiveSequenceNode.new("attack_move"):add(PathToNode.new("path_to", {entry = "target"})):add(MoveToNode.new(
    "move",
    {
        movement = MovementType.WalkJump,
        acceleration = Vector.new(0.1, 0.45),
        speed = Vector.new(1, 5),
        acceptableRadius = Sizes.TILE,
        jumpTime = 450,
        timeout = seconds(4),
        timeoutResult = BehaviorStatus.Failure,
        canCreateBlocks = true,
        canDestroyBlocks = true,
        moveSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_MOVE",
        jumpSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_JUMP",
        landSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_LAND"
    }
))):add(SetAttackingNode.new("attack_on", {value = true})):add(PlaySoundNode.new("play_attack_sound", {sound = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_ATTACK"})):add(PlayAnimationNode.new("play_attack", {name = "attack", blocking = true})):add(SetAttackingNode.new("attack_off", {value = false})):add(PlayAnimationNode.new("play_idle", {name = "idle", loop = true})):add(WaitNode.new(
    "idle_wait",
    seconds(2)
))):add(SequenceNode.new("wander"):add(PlayAnimationNode.new("play_idle", {name = "idle", loop = true})):add(PathRoamNode.new(
    "path_roam",
    {
        movement = MovementType.WalkJump,
        entry = "home",
        distance = FloatRange.new(0, Sizes.SEGMENT * 2)
    }
)):add(MoveToNode.new(
    "move_roam",
    {
        movement = MovementType.WalkJump,
        acceleration = Vector.new(0.1, 0.45),
        speed = Vector.new(0.8, 5),
        jumpTime = 450,
        timeout = seconds(5),
        acceptableRadius = Sizes.SUBTILE,
        horizontalOnly = true,
        timeoutResult = BehaviorStatus.Success,
        moveSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_MOVE",
        jumpSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_JUMP",
        landSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_LAND"
    }
)):add(PlayAnimationNode.new("play_idle", {name = "idle", loop = true})):add(WaitNode.new(
    "idle_wait",
    seconds(10)
))))})
prefab:addCombat({
    team = CombatTeam.Monster,
    loot = "oil_slime",
    fx = {"action_fx.otto_hit"},
    takeHitSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_TAKEHIT",
    deathSfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_DEATH",
    onDefend = function(____, attacker, defender)
        local data = defender.behavior.data
        data:setTimer(
            "attackTimer",
            GameTimer.new(seconds(20))
        )
    end
})
prefab:addLight({intensity = 65})
return ____exports
