local ____lualib = require("lualib_bundle")
local Map = ____lualib.Map
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 5,["12"] = 7,["13"] = 11,["14"] = 15,["15"] = 17,["16"] = 19,["17"] = 19,["18"] = 21,["19"] = 22,["20"] = 22,["21"] = 23,["22"] = 23,["23"] = 23,["24"] = 22,["25"] = 19,["26"] = 19,["27"] = 28,["28"] = 29,["29"] = 29,["30"] = 30,["31"] = 30,["32"] = 30,["33"] = 29,["34"] = 31,["35"] = 31,["36"] = 31,["37"] = 29,["38"] = 29,["39"] = 28,["40"] = 35,["41"] = 35,["42"] = 35,["43"] = 35,["44"] = 39,["45"] = 40,["46"] = 35,["47"] = 35,["48"] = 44,["49"] = 44,["50"] = 44,["51"] = 44,["52"] = 44,["53"] = 44});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local prefab = Prefab.getCurrent()
prefab:addTransform({origin = Vector.new(24, 24)})
prefab:addLocation({layer = LayerTypes.Monster})
prefab:addRender("oil_slime_spawner-1")
prefab:addAnimation({})
prefab:addPlacement({
    features = bit.bor(PlacementFeatures.Overlapable, PlacementFeatures.Indestructible),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(2, 2),
            "oil_slime_spawner-1"
        )}
    )}
})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(16, 99, 16)
        },
        {
            "DEF",
            Stat.new(2, 99, 2)
        }
    }
)})
prefab:addCombat({
    team = CombatTeam.Monster,
    priority = CombatPriority.High,
    loot = "oil_slime_spawner",
    onDefend = function(____, attacker, defender)
        SpawnerSystem.get():callToArms(attacker, defender)
    end
})
prefab:addSpawner({
    monster = "monster.oil_slime",
    sfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_SPAWN",
    frequency = seconds(20),
    total = 3
})
return ____exports
