local ____lualib = require("lualib_bundle")
local Map = ____lualib.Map
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 5,["12"] = 7,["13"] = 11,["14"] = 15,["15"] = 17,["16"] = 19,["17"] = 19,["18"] = 21,["19"] = 22,["20"] = 22,["21"] = 22,["22"] = 22,["23"] = 22,["24"] = 22,["25"] = 22,["26"] = 21,["27"] = 23,["28"] = 23,["29"] = 23,["30"] = 23,["31"] = 23,["32"] = 23,["33"] = 23,["34"] = 21,["35"] = 19,["36"] = 19,["37"] = 27,["38"] = 28,["39"] = 28,["40"] = 29,["41"] = 29,["42"] = 29,["43"] = 28,["44"] = 30,["45"] = 30,["46"] = 30,["47"] = 28,["48"] = 28,["49"] = 27,["50"] = 34,["51"] = 34,["52"] = 34,["53"] = 34,["54"] = 38,["55"] = 39,["56"] = 34,["57"] = 34,["58"] = 43,["59"] = 43,["60"] = 43,["61"] = 43,["62"] = 43,["63"] = 43});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local prefab = Prefab.getCurrent()
prefab:addTransform({origin = Vector.new(24, 24)})
prefab:addLocation({layer = LayerTypes.Monster})
prefab:addRender("voidling_spawner-1")
prefab:addAnimation({})
prefab:addPlacement({
    features = bit.bor(PlacementFeatures.Overlapable, PlacementFeatures.Indestructible),
    axes = {
        PlacementAxis.new(
            PlacementAxisType.Floor,
            {PlacementDirection.new(
                FacingDirection.Right,
                TileVector.new(2, 2),
                "voidling_spawner-1"
            )}
        ),
        PlacementAxis.new(
            PlacementAxisType.Backwall,
            {PlacementDirection.new(
                FacingDirection.Right,
                TileVector.new(2, 2),
                "voidling_spawner-1"
            )}
        )
    }
})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(16, 99, 16)
        },
        {
            "DEF",
            Stat.new(2, 99, 2)
        }
    }
)})
prefab:addCombat({
    team = CombatTeam.Monster,
    priority = CombatPriority.High,
    loot = "voidling_spawner",
    onDefend = function(____, attacker, defender)
        SpawnerSystem.get():callToArms(attacker, defender)
    end
})
prefab:addSpawner({
    monster = "monster.mycosiph",
    sfx = "event:/ENEMIES/OIL_SLIME/OIL_SLIME_SPAWN",
    frequency = seconds(20),
    total = 3
})
return ____exports
