local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 2,["9"] = 2,["10"] = 3,["11"] = 3,["12"] = 5,["13"] = 7,["14"] = 11,["15"] = 15,["16"] = 19,["17"] = 21,["18"] = 24,["19"] = 28,["20"] = 29,["21"] = 30,["22"] = 30,["23"] = 30,["24"] = 30,["25"] = 30,["26"] = 31,["27"] = 32,["28"] = 33,["29"] = 34,["30"] = 33,["31"] = 29,["32"] = 38,["33"] = 42,["34"] = 42,["35"] = 42,["36"] = 42});
local ____exports = {}
local ____architect = require("architect")
local architect = ____architect.architect
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____event = require("event")
local Event = ____event.Event
local prefab = Prefab.getCurrent()
prefab:addTransform({origin = Vector.new(16, 24)})
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("recovery_cube", {layer = 127})
prefab:addIllumination(1)
prefab:addAnimation({})
prefab:addInventory({inventories = {{size = 100, collectSize = 100}}})
local recovery_cube_retrieve_hs = HashString("recovery_cube.retrieve")
local function interact(player, entity)
    architect:addOrDropItemsPlayer(
        player,
        entity.inventory:get().items,
        player.physics.body:center()
    )
    animator.play(entity, recovery_cube_retrieve_hs)
    local entityID = entity.id
    entity.animation.onFinished:listen(function(____, name)
        EntityManager.destroy(entityID)
    end)
end
prefab:addEvent({interact = __TS__New(Event, interact)})
prefab:addLight({
    intensity = 70,
    color = Color.new(200, 255, 255)
})
return ____exports
