local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 2,["9"] = 2,["10"] = 3,["11"] = 3,["12"] = 8,["13"] = 10,["14"] = 12,["15"] = 16,["16"] = 18,["17"] = 20,["18"] = 25,["19"] = 29,["20"] = 31,["21"] = 31,["22"] = 31,["23"] = 31,["24"] = 31,["25"] = 31,["26"] = 30,["27"] = 32,["28"] = 32,["29"] = 32,["30"] = 32,["31"] = 32,["32"] = 32,["33"] = 30,["34"] = 29,["35"] = 36,["36"] = 36,["37"] = 38,["38"] = 39,["39"] = 39,["40"] = 39,["41"] = 39,["42"] = 39,["43"] = 39,["44"] = 36,["45"] = 36,["46"] = 43,["47"] = 43,["48"] = 43,["49"] = 43,["50"] = 48,["51"] = 49,["52"] = 49,["53"] = 49,["54"] = 50,["55"] = 51,["56"] = 52,["58"] = 54,["60"] = 56,["61"] = 57,["62"] = 49,["63"] = 48,["64"] = 59,["65"] = 59,["66"] = 59,["67"] = 60,["68"] = 61,["69"] = 62,["70"] = 63,["71"] = 63,["72"] = 63,["73"] = 63,["74"] = 64,["75"] = 64,["76"] = 64,["77"] = 64,["78"] = 59,["79"] = 48,["80"] = 48});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("ancient_device_secondary")
prefab:addIllumination(1)
prefab:addAnimation({start = "idle", loop = true})
prefab:addCollector({reach = 0})
prefab:addInventory({inventories = {
    {
        name = "input-cermet",
        size = 1,
        collectStack = 500,
        stackOverride = 500,
        filterPrefabs = {Prefab.getID("material.cermet")}
    },
    {
        name = "input-core",
        size = 1,
        collectStack = 500,
        stackOverride = 500,
        filterPrefabs = {Prefab.getID("material.mana_core")}
    }
}})
prefab:addPlacement({
    features = bit.bor(PlacementFeatures.Targetable, PlacementFeatures.Indestructible),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(4, 3),
            "ancient_device_secondary-1"
        )}
    )}
})
prefab:addLight({
    intensity = 160,
    color = Color.new(158, 228, 255)
})
prefab:addEvent({
    interact = __TS__New(
        Event,
        function(player, entity)
            local ui
            if animator.isCurrentlyPlaying(entity, "interact_idle") then
                ui = UIManager.get("ending")
            else
                ui = UIManager.get("AncientComms")
            end
            ui:setEntity(entity)
            ui:show()
        end
    ),
    moved = __TS__New(
        Event,
        function(realm, entity)
            local collector = entity.collector
            collector:clearTiles()
            local area = entity.placement.axis.area
            collector:addTile(
                TileVector.new(area.x - 1, area.y + area.height - 1),
                TileDirection.Right
            )
            collector:addTile(
                TileVector.new(area.x + area.width, area.y + area.height - 1),
                TileDirection.Left
            )
        end
    )
})
return ____exports
