local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 5,["16"] = 5,["17"] = 6,["18"] = 6,["19"] = 9,["20"] = 11,["21"] = 13,["22"] = 17,["23"] = 22,["24"] = 24,["25"] = 26,["26"] = 31,["27"] = 32,["28"] = 32,["29"] = 32,["30"] = 32,["31"] = 37,["32"] = 37,["33"] = 37,["34"] = 37,["35"] = 37,["36"] = 37,["37"] = 37,["38"] = 37,["39"] = 32,["40"] = 31,["41"] = 41,["42"] = 45,["43"] = 49,["44"] = 49,["45"] = 51,["46"] = 51,["47"] = 51,["48"] = 49,["49"] = 52,["50"] = 53,["51"] = 53,["52"] = 54,["53"] = 54,["54"] = 54,["55"] = 53,["56"] = 49,["57"] = 49,["58"] = 59,["59"] = 60,["60"] = 60,["61"] = 61,["62"] = 60,["63"] = 59,["64"] = 65,["65"] = 65,["66"] = 65,["67"] = 65,["68"] = 70,["69"] = 75,["70"] = 79,["71"] = 81,["72"] = 86,["73"] = 87,["74"] = 87,["75"] = 88,["76"] = 88,["77"] = 88,["78"] = 87,["79"] = 89,["80"] = 89,["81"] = 89,["82"] = 87,["83"] = 90,["84"] = 90,["85"] = 90,["86"] = 87,["87"] = 87,["88"] = 86,["89"] = 94});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____craft = require("craft")
local CraftSite = ____craft.CraftSite
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local ____utility = require("utility")
local breakItem = ____utility.breakItem
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addItem({icon = "icons_assembler", stack = 20})
prefab:addRender("assembler")
prefab:addIllumination(1)
prefab:addAnimation({start = "idle", loop = true})
prefab:addInventory({inventories = {
    {name = "input-0", size = 1, filterPrefabs = {INVALID_ENTITYID}},
    {name = "input-1", size = 1, filterPrefabs = {INVALID_ENTITYID}},
    {name = "input-2", size = 1, filterPrefabs = {INVALID_ENTITYID}},
    {name = "input-3", size = 1, filterPrefabs = {INVALID_ENTITYID}},
    {
        name = "output",
        size = 1,
        filterPrefabs = {INVALID_ENTITYID},
        features = bit.bor(
            bit.bor(InventoryFeatures.Dispense, InventoryFeatures.Withdraw),
            InventoryFeatures.RecipeFlush
        )
    }
}})
prefab:addAmbience({sfx = "event:/FABRICATORS/ASSEMBLER_LOOP"})
prefab:addCollector({reach = 2})
prefab:addPlacement({
    drop = Prefab.getID("structure.assembler"),
    features = bit.bor(
        bit.bor(PlacementFeatures.Default, PlacementFeatures.Pivotable),
        PlacementFeatures.ScaffoldingSupport
    ),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(3, 3),
            "assembler-1"
        )}
    )}
})
prefab:addEvent({interact = __TS__New(
    Event,
    function(player, entity)
        showModularDialogWithInventory(nil, "EnergyFabricator", entity)
    end
)})
prefab:addLight({
    intensity = 20,
    color = Color.new(180, 220, 255)
})
prefab:addFabricator({speed = 0.5, site = CraftSite.Assembler})
prefab:addDispenser({frequency = 500})
prefab:addOverlay()
prefab:addConsumer({idlePower = 5, activePower = 25})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(30, 99, 30)
        },
        {
            "DEF",
            Stat.new(1, 99, 1)
        },
        {
            "owner",
            Stat.new(0, 999999)
        }
    }
)})
prefab:addCombat({team = CombatTeam.Structure, destroyOnDeath = false, onDeath = breakItem})
return ____exports
