local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 5,["16"] = 5,["17"] = 6,["18"] = 6,["19"] = 9,["20"] = 11,["21"] = 13,["22"] = 17,["23"] = 22,["24"] = 24,["25"] = 25,["26"] = 25,["27"] = 25,["28"] = 29,["29"] = 29,["30"] = 29,["31"] = 29,["32"] = 29,["33"] = 29,["34"] = 29,["35"] = 29,["36"] = 25,["37"] = 24,["38"] = 33,["39"] = 37,["40"] = 37,["41"] = 39,["42"] = 39,["43"] = 39,["44"] = 37,["45"] = 40,["46"] = 41,["47"] = 41,["48"] = 42,["49"] = 42,["50"] = 42,["51"] = 41,["52"] = 37,["53"] = 37,["54"] = 47,["55"] = 48,["56"] = 48,["57"] = 49,["58"] = 48,["59"] = 47,["60"] = 53,["61"] = 58,["62"] = 62,["63"] = 64,["64"] = 69,["65"] = 70,["66"] = 70,["67"] = 71,["68"] = 71,["69"] = 71,["70"] = 70,["71"] = 72,["72"] = 72,["73"] = 72,["74"] = 70,["75"] = 73,["76"] = 73,["77"] = 73,["78"] = 70,["79"] = 70,["80"] = 69,["81"] = 77});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____craft = require("craft")
local CraftSite = ____craft.CraftSite
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local ____utility = require("utility")
local breakItem = ____utility.breakItem
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addItem({icon = "icons_assembler_iii", stack = 20})
prefab:addRender("assembler_iii")
prefab:addInventory({inventories = {
    {name = "input-0", size = 1, filterPrefabs = {INVALID_ENTITYID}},
    {name = "input-1", size = 1, filterPrefabs = {INVALID_ENTITYID}},
    {name = "input-2", size = 1, filterPrefabs = {INVALID_ENTITYID}},
    {
        name = "output",
        size = 1,
        filterPrefabs = {INVALID_ENTITYID},
        features = bit.bor(
            bit.bor(InventoryFeatures.Dispense, InventoryFeatures.Withdraw),
            InventoryFeatures.RecipeFlush
        )
    }
}})
prefab:addCollector({reach = 3})
prefab:addPlacement({
    drop = Prefab.getID("structure.assembler_iii"),
    features = bit.bor(
        bit.bor(PlacementFeatures.Default, PlacementFeatures.Pivotable),
        PlacementFeatures.ScaffoldingSupport
    ),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(3, 3),
            "assembler_iii"
        )}
    )}
})
prefab:addEvent({interact = __TS__New(
    Event,
    function(player, entity)
        showModularDialogWithInventory(nil, "EnergyFabricator", entity)
    end
)})
prefab:addFabricator({speed = 1, site = CraftSite.Assembler})
prefab:addDispenser({frequency = 500})
prefab:addOverlay()
prefab:addConsumer({idlePower = 22, activePower = 125})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(45, 99, 45)
        },
        {
            "DEF",
            Stat.new(1, 99, 1)
        },
        {
            "owner",
            Stat.new(0, 999999)
        }
    }
)})
prefab:addCombat({team = CombatTeam.Structure, destroyOnDeath = false, onDeath = breakItem})
return ____exports
