local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 5,["16"] = 5,["17"] = 7,["18"] = 10,["19"] = 15,["20"] = 17,["21"] = 21,["22"] = 23,["23"] = 25,["24"] = 25,["25"] = 25,["26"] = 28,["27"] = 29,["28"] = 29,["29"] = 29,["30"] = 29,["31"] = 29,["32"] = 29,["33"] = 25,["34"] = 25,["35"] = 33,["36"] = 38,["37"] = 38,["38"] = 38,["39"] = 38,["40"] = 38,["41"] = 38,["42"] = 38,["43"] = 38,["44"] = 47,["45"] = 47,["46"] = 47,["47"] = 47,["48"] = 47,["49"] = 52,["50"] = 52,["51"] = 52,["52"] = 53,["53"] = 54,["54"] = 55,["55"] = 56,["56"] = 57,["58"] = 52,["59"] = 47,["60"] = 47,["61"] = 63,["62"] = 64,["63"] = 64,["64"] = 65,["65"] = 64,["66"] = 63,["67"] = 69,["68"] = 70,["69"] = 70,["70"] = 71,["71"] = 71,["72"] = 71,["73"] = 70,["74"] = 72,["75"] = 72,["76"] = 72,["77"] = 70,["78"] = 73,["79"] = 73,["80"] = 73,["81"] = 70,["82"] = 74,["83"] = 74,["84"] = 74,["85"] = 70,["86"] = 70,["87"] = 69,["88"] = 78});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____base = require("ui.base")
local showModularDialog = ____base.showModularDialog
local ____utility = require("utility")
local breakItem = ____utility.breakItem
local prefab = Prefab.getCurrent()
prefab:addItem({icon = "icons_battery", stack = 5})
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("battery-1")
prefab:addIllumination(1)
prefab:addPlacement({
    drop = Prefab.getID("structure.battery"),
    features = bit.bor(PlacementFeatures.Default, PlacementFeatures.NoSupportBackwall),
    axes = {PlacementAxis.new(
        PlacementAxisType.Backwall,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(1, 1),
            "battery-1"
        )}
    )}
})
prefab:addDistributor({area = 0, range = 0})
local batteryAtlases = {
    atlases.get("battery-1"),
    atlases.get("battery-2"),
    atlases.get("battery-3"),
    atlases.get("battery-4"),
    atlases.get("battery-5"),
    atlases.get("battery-6")
}
prefab:addProducer({
    generate = 0,
    throughput = 300,
    stored = 0,
    capacity = 54000,
    onStorageChange = __TS__New(
        Event,
        function(entityID, previous, value, max)
            local previousLevel = math.ceil(previous / max * 5)
            local currentLevel = math.ceil(value / max * 5)
            if previousLevel ~= currentLevel then
                local entity = EntityManager.get(entityID)
                entity.render.atlas = batteryAtlases[currentLevel + 1]
            end
        end
    )
})
prefab:addEvent({interact = __TS__New(
    Event,
    function(player, entity)
        showModularDialog(nil, "Power", entity)
    end
)})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(30, 99, 30)
        },
        {
            "DEF",
            Stat.new(1, 99, 1)
        },
        {
            "NRG",
            Stat.new(1, 999999999, 0)
        },
        {
            "owner",
            Stat.new(0, 999999)
        }
    }
)})
prefab:addCombat({team = CombatTeam.Structure, priority = CombatPriority.High, destroyOnDeath = false, onDeath = breakItem})
return ____exports
