local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 6,["16"] = 6,["17"] = 7,["18"] = 7,["19"] = 10,["20"] = 12,["21"] = 14,["22"] = 18,["23"] = 23,["24"] = 25,["25"] = 27,["26"] = 32,["27"] = 36,["28"] = 38,["29"] = 38,["30"] = 38,["31"] = 38,["32"] = 38,["33"] = 38,["34"] = 38,["35"] = 38,["36"] = 38,["37"] = 37,["38"] = 39,["39"] = 39,["40"] = 39,["41"] = 39,["42"] = 39,["43"] = 37,["44"] = 36,["45"] = 43,["46"] = 47,["47"] = 47,["48"] = 47,["49"] = 50,["50"] = 51,["51"] = 51,["52"] = 52,["53"] = 52,["54"] = 52,["55"] = 51,["56"] = 47,["57"] = 47,["58"] = 57,["59"] = 57,["60"] = 57,["61"] = 57,["62"] = 62,["63"] = 67,["64"] = 68,["65"] = 68,["66"] = 69,["67"] = 68,["68"] = 67,["69"] = 73,["70"] = 79,["71"] = 80,["72"] = 80,["73"] = 81,["74"] = 81,["75"] = 81,["76"] = 80,["77"] = 82,["78"] = 82,["79"] = 82,["80"] = 80,["81"] = 83,["82"] = 83,["83"] = 83,["84"] = 80,["85"] = 84,["86"] = 84,["87"] = 84,["88"] = 80,["89"] = 80,["90"] = 79,["91"] = 88,["92"] = 95,["93"] = 99,["94"] = 99,["95"] = 101,["96"] = 102,["97"] = 103,["99"] = 105,["101"] = 99,["102"] = 99});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____mechanical = require("components.mechanical")
local MechanicalNodeType = ____mechanical.MechanicalNodeType
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local ____utility = require("utility")
local breakItem = ____utility.breakItem
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addItem({icon = "icons_combustion_drill", stack = 20})
prefab:addRender("combustion_drill-1")
prefab:addIllumination(1)
prefab:addAnimation({start = "idle", loop = true})
prefab:addAmbience({sfx = "event:/FABRICATORS/DRILL_LOOP"})
prefab:addInventory({inventories = {
    {
        name = "fuel",
        size = 1,
        filterCategories = {"biofuel"},
        collectStack = 5,
        features = bit.bor(
            bit.bor(InventoryFeatures.Collect, InventoryFeatures.Deposit),
            InventoryFeatures.Withdraw
        )
    },
    {
        name = "output",
        size = 1,
        filterPrefabs = {INVALID_ENTITYID},
        features = bit.bor(InventoryFeatures.Dispense, InventoryFeatures.Withdraw)
    }
}})
prefab:addCollector({reach = 2})
prefab:addPlacement({
    drop = Prefab.getID("structure.combustion_drill"),
    features = bit.bor(PlacementFeatures.Default, PlacementFeatures.Pivotable),
    axes = {PlacementAxis.new(
        PlacementAxisType.Backwall,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(2, 2),
            "combustion_drill-1"
        )}
    )}
})
prefab:addDrill({
    speed = seconds(4),
    range = 1
})
prefab:addDispenser({frequency = 500, isEnabled = true})
prefab:addEvent({interact = __TS__New(
    Event,
    function(player, entity)
        showModularDialogWithInventory(nil, "CombustionDrill", entity)
    end
)})
prefab:addConsumer({isAutonomous = true, idlePower = 0, activePower = 4})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(30, 99, 30)
        },
        {
            "DEF",
            Stat.new(1, 99, 1)
        },
        {
            "NRG",
            Stat.new(1, 999999999, 0)
        },
        {
            "owner",
            Stat.new(0, 999999)
        }
    }
)})
prefab:addCombat({team = CombatTeam.Structure, priority = CombatPriority.High, destroyOnDeath = false, onDeath = breakItem})
prefab:addOverlay({noPowerIndicator = atlases.get("autoforge_window_no_fuel")})
prefab:addMechanical({
    inputs = {MechanicalNodeType.Basic},
    onReceive = function(____, mechanical, output, input, connection)
        if connection.signal.strength == 1 then
            input.consumer:addState(ConsumerState.On)
        else
            input.consumer:removeState(ConsumerState.On)
        end
    end
})
return ____exports
