local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__StringSubstring = ____lualib.__TS__StringSubstring
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["8"] = 1,["9"] = 1,["10"] = 2,["11"] = 2,["12"] = 3,["13"] = 3,["14"] = 4,["15"] = 4,["16"] = 5,["17"] = 5,["18"] = 6,["19"] = 6,["20"] = 9,["21"] = 11,["22"] = 13,["23"] = 17,["24"] = 22,["25"] = 24,["26"] = 29,["27"] = 33,["28"] = 34,["29"] = 34,["30"] = 34,["31"] = 34,["32"] = 39,["33"] = 39,["34"] = 39,["35"] = 39,["36"] = 39,["37"] = 39,["38"] = 39,["39"] = 39,["40"] = 34,["41"] = 33,["42"] = 43,["43"] = 47,["44"] = 47,["45"] = 49,["46"] = 49,["47"] = 49,["48"] = 47,["49"] = 50,["50"] = 51,["51"] = 51,["52"] = 52,["53"] = 52,["54"] = 52,["55"] = 51,["56"] = 47,["57"] = 47,["58"] = 57,["59"] = 58,["60"] = 58,["61"] = 59,["62"] = 58,["63"] = 57,["64"] = 63,["65"] = 68,["66"] = 72,["67"] = 74,["68"] = 79,["69"] = 80,["70"] = 80,["71"] = 81,["72"] = 81,["73"] = 81,["74"] = 80,["75"] = 82,["76"] = 82,["77"] = 82,["78"] = 80,["79"] = 83,["80"] = 83,["81"] = 83,["82"] = 80,["83"] = 80,["84"] = 79,["85"] = 87,["86"] = 93,["87"] = 94,["88"] = 95,["89"] = 96,["92"] = 100,["93"] = 101,["94"] = 102,["95"] = 103,["96"] = 104,["97"] = 105,["98"] = 106,["100"] = 109,["102"] = 111,["104"] = 95,["105"] = 93});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____craft = require("craft")
local CraftSite = ____craft.CraftSite
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local ____utility = require("utility")
local breakItem = ____utility.breakItem
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addItem({icon = "icons_distiller", stack = 20})
prefab:addRender("distiller-1")
prefab:addAnimation({start = "idle", loop = true})
prefab:addAmbience({sfx = "event:/FABRICATORS/DISTILLER_LOOP"})
prefab:addInventory({inventories = {
    {name = "input-0", size = 1, filterPrefabs = {INVALID_ENTITYID}},
    {name = "input-1", size = 1, filterPrefabs = {INVALID_ENTITYID}},
    {name = "input-2", size = 1, filterPrefabs = {INVALID_ENTITYID}},
    {name = "input-3", size = 1, filterPrefabs = {INVALID_ENTITYID}},
    {
        name = "output",
        size = 1,
        filterPrefabs = {INVALID_ENTITYID},
        features = bit.bor(
            bit.bor(InventoryFeatures.Dispense, InventoryFeatures.Withdraw),
            InventoryFeatures.RecipeFlush
        )
    }
}})
prefab:addCollector({reach = 3})
prefab:addPlacement({
    drop = Prefab.getID("structure.distiller"),
    features = bit.bor(
        bit.bor(PlacementFeatures.Default, PlacementFeatures.Pivotable),
        PlacementFeatures.ScaffoldingSupport
    ),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(3, 3),
            "distiller-1"
        )}
    )}
})
prefab:addEvent({interact = __TS__New(
    Event,
    function(player, entity)
        showModularDialogWithInventory(nil, "EnergyFabricator", entity)
    end
)})
prefab:addFabricator({speed = 1, site = CraftSite.Distiller})
prefab:addDispenser({frequency = 500})
prefab:addOverlay()
prefab:addConsumer({idlePower = 4, activePower = 12})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(15, 99, 15)
        },
        {
            "DEF",
            Stat.new(1, 99, 1)
        },
        {
            "owner",
            Stat.new(0, 999999)
        }
    }
)})
prefab:addCombat({team = CombatTeam.Structure, destroyOnDeath = false, onDeath = breakItem})
prefab.onCreate:listen(function(entity)
    local entityID = entity.id
    entity.stats:get("HP").onChangeCurrent:listen(function(stat, previous, value)
        if value == 0 then
            return
        end
        local wasDamaged = previous / stat:get() < 0.5
        local isDamaged = value / stat:get() < 0.5
        if wasDamaged ~= isDamaged then
            local entity = EntityManager.get(entityID)
            local current = entity.animation:current().name:str()
            if isDamaged then
                current = current .. "_damaged"
            else
                current = __TS__StringSubstring(current, 0, #current - 8)
            end
            animator.tryPlay(entity, current, true)
        end
    end)
end)
return ____exports
