local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 5,["16"] = 5,["17"] = 8,["18"] = 10,["19"] = 12,["20"] = 16,["21"] = 21,["22"] = 23,["23"] = 25,["24"] = 30,["25"] = 34,["26"] = 36,["27"] = 36,["28"] = 36,["29"] = 36,["30"] = 34,["31"] = 40,["32"] = 40,["33"] = 40,["34"] = 43,["35"] = 44,["36"] = 44,["37"] = 45,["38"] = 45,["39"] = 45,["40"] = 44,["41"] = 40,["42"] = 40,["43"] = 50,["44"] = 50,["45"] = 50,["46"] = 50,["47"] = 55,["48"] = 60,["49"] = 61,["50"] = 61,["51"] = 62,["52"] = 61,["53"] = 60,["54"] = 66,["55"] = 71,["56"] = 73,["57"] = 74,["58"] = 74,["59"] = 75,["60"] = 75,["61"] = 75,["62"] = 74,["63"] = 76,["64"] = 76,["65"] = 76,["66"] = 74,["67"] = 77,["68"] = 77,["69"] = 77,["70"] = 74,["71"] = 74,["72"] = 73,["73"] = 81});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local ____utility = require("utility")
local breakItem = ____utility.breakItem
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addItem({icon = "icons_energy_drill", stack = 20})
prefab:addRender("energy_drill-1")
prefab:addIllumination(1)
prefab:addAnimation({start = "idle", loop = true})
prefab:addAmbience({sfx = "event:/FABRICATORS/DRILL_LOOP"})
prefab:addInventory({inventories = {{
    name = "output",
    size = 1,
    filterPrefabs = {INVALID_ENTITYID},
    features = bit.bor(InventoryFeatures.Dispense, InventoryFeatures.Withdraw)
}}})
prefab:addPlacement({
    drop = Prefab.getID("structure.energy_drill"),
    features = bit.bor(PlacementFeatures.Default, PlacementFeatures.Pivotable),
    axes = {PlacementAxis.new(
        PlacementAxisType.Backwall,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(3, 3),
            "energy_drill.idle"
        )}
    )}
})
prefab:addDrill({
    speed = seconds(2),
    range = 1
})
prefab:addDispenser({frequency = 500, isEnabled = true})
prefab:addEvent({interact = __TS__New(
    Event,
    function(player, entity)
        showModularDialogWithInventory(nil, "EnergyDrill", entity)
    end
)})
prefab:addConsumer({idlePower = 8, activePower = 32})
prefab:addOverlay()
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(45, 99, 45)
        },
        {
            "DEF",
            Stat.new(1, 99, 1)
        },
        {
            "owner",
            Stat.new(0, 999999)
        }
    }
)})
prefab:addCombat({team = CombatTeam.Structure, priority = CombatPriority.High, destroyOnDeath = false, onDeath = breakItem})
return ____exports
