local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 5,["16"] = 5,["17"] = 8,["18"] = 10,["19"] = 12,["20"] = 16,["21"] = 21,["22"] = 23,["23"] = 25,["24"] = 30,["25"] = 34,["26"] = 38,["27"] = 40,["28"] = 40,["29"] = 40,["30"] = 40,["31"] = 40,["32"] = 39,["33"] = 41,["34"] = 41,["35"] = 41,["36"] = 41,["37"] = 41,["38"] = 39,["39"] = 42,["40"] = 42,["41"] = 42,["42"] = 42,["43"] = 42,["44"] = 39,["45"] = 43,["46"] = 43,["47"] = 43,["48"] = 43,["49"] = 43,["50"] = 39,["51"] = 38,["52"] = 47,["53"] = 47,["54"] = 47,["55"] = 50,["56"] = 51,["57"] = 51,["58"] = 52,["59"] = 52,["60"] = 52,["61"] = 51,["62"] = 47,["63"] = 47,["64"] = 57,["65"] = 62,["66"] = 64,["67"] = 69,["68"] = 70,["69"] = 70,["70"] = 71,["71"] = 70,["72"] = 69,["73"] = 75,["74"] = 76,["75"] = 76,["76"] = 77,["77"] = 77,["78"] = 77,["79"] = 76,["80"] = 78,["81"] = 78,["82"] = 78,["83"] = 76,["84"] = 79,["85"] = 79,["86"] = 79,["87"] = 76,["88"] = 76,["89"] = 75,["90"] = 83});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local ____utility = require("utility")
local breakItem = ____utility.breakItem
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addItem({icon = "icons_foldery", stack = 20})
prefab:addRender("foldery-idle")
prefab:addIllumination(1)
prefab:addAnimation({start = "idle", loop = true})
prefab:addAmbience({sfx = "event:/FABRICATORS/FOLDERY_LOOP"})
prefab:addCollector({reach = 3})
prefab:addInventory({inventories = {
    {
        name = "input-mechanical",
        size = 1,
        collectStack = 4,
        filterPrefabs = {Prefab.getID("material.mechanical_essence")}
    },
    {
        name = "input-magical",
        size = 1,
        collectStack = 4,
        filterPrefabs = {Prefab.getID("material.magical_essence")}
    },
    {
        name = "input-martial",
        size = 1,
        collectStack = 4,
        filterPrefabs = {Prefab.getID("material.martial_essence")}
    },
    {
        name = "input-structural",
        size = 1,
        collectStack = 4,
        filterPrefabs = {Prefab.getID("material.structural_essence")}
    }
}})
prefab:addPlacement({
    drop = Prefab.getID("structure.foldery"),
    features = bit.bor(PlacementFeatures.Default, PlacementFeatures.ScaffoldingSupport),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(3, 3),
            "foldery-1"
        )}
    )}
})
prefab:addResearch({type = ResearcherType.Foldery, speed = 1})
prefab:addOverlay()
prefab:addConsumer({idlePower = 4, activePower = 20})
prefab:addEvent({interact = __TS__New(
    Event,
    function(player, entity)
        showModularDialogWithInventory(nil, "Foldery", entity)
    end
)})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(30, 99, 30)
        },
        {
            "DEF",
            Stat.new(1, 99, 1)
        },
        {
            "owner",
            Stat.new(0, 999999)
        }
    }
)})
prefab:addCombat({team = CombatTeam.Structure, destroyOnDeath = false, onDeath = breakItem})
return ____exports
