local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 5,["16"] = 5,["17"] = 6,["18"] = 6,["19"] = 9,["20"] = 11,["21"] = 13,["22"] = 17,["23"] = 22,["24"] = 24,["25"] = 26,["26"] = 31,["27"] = 33,["28"] = 33,["29"] = 33,["30"] = 33,["31"] = 33,["32"] = 31,["33"] = 37,["34"] = 41,["35"] = 41,["36"] = 43,["37"] = 44,["38"] = 44,["39"] = 45,["40"] = 45,["41"] = 45,["42"] = 44,["43"] = 41,["44"] = 41,["45"] = 50,["46"] = 51,["47"] = 51,["48"] = 52,["49"] = 51,["50"] = 50,["51"] = 56,["52"] = 56,["53"] = 56,["54"] = 56,["55"] = 60,["56"] = 61,["57"] = 62,["58"] = 63,["59"] = 64,["61"] = 66,["65"] = 56,["66"] = 56,["67"] = 73,["68"] = 74,["69"] = 74,["70"] = 75,["71"] = 75,["72"] = 75,["73"] = 74,["74"] = 76,["75"] = 76,["76"] = 76,["77"] = 74,["78"] = 77,["79"] = 77,["80"] = 77,["81"] = 74,["82"] = 78,["83"] = 78,["84"] = 78,["85"] = 74,["86"] = 79,["87"] = 79,["88"] = 79,["89"] = 74,["90"] = 74,["91"] = 73,["92"] = 83,["93"] = 88,["94"] = 88,["95"] = 88,["96"] = 88,["97"] = 88,["98"] = 85,["99"] = 92,["100"] = 92,["101"] = 92,["102"] = 92,["103"] = 92,["104"] = 84,["105"] = 109,["106"] = 109,["107"] = 109,["108"] = 109,["109"] = 109,["110"] = 109,["111"] = 109,["112"] = 109,["113"] = 109,["114"] = 101,["115"] = 121,["116"] = 121,["117"] = 121,["118"] = 121,["119"] = 121,["120"] = 83,["121"] = 129,["122"] = 129,["123"] = 129,["124"] = 129,["125"] = 129,["126"] = 129,["127"] = 129,["128"] = 129,["129"] = 138,["130"] = 138,["131"] = 138,["132"] = 138});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____Sizes = require("Sizes")
local Sizes = ____Sizes.Sizes
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local ____utility = require("utility")
local breakItem = ____utility.breakItem
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addItem({icon = "icons_mana_turret", stack = 20})
prefab:addRender("mana_turret-1")
prefab:addIllumination(0.75)
prefab:addAnimation({start = "idle", loop = true})
prefab:addInventory({inventories = {{
    name = "fuel",
    size = 1,
    filterCategories = {"ammo"},
    collectStack = 5,
    stackOverride = 10
}}})
prefab:addCollector({reach = 1})
prefab:addPlacement({
    drop = Prefab.getID("structure.mana_turret"),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(2, 2),
            "mana_turret-1"
        )}
    )}
})
prefab:addEvent({interact = __TS__New(
    Event,
    function(player, entity)
        showModularDialogWithInventory(nil, "ManaTurret", entity)
    end
)})
prefab:addConsumer({
    isAutonomous = true,
    idlePower = 0,
    activePower = 0,
    onStateChange = function(entityID, state, flag)
        if flag == ConsumerState.Powered then
            local entity = EntityManager.get(entityID)
            if bit.band(state, ConsumerState.Powered) == ConsumerState.Powered then
                animator.tryPlay(entity, "running", true)
            else
                animator.tryPlay(entity, "idle", true)
            end
            return
        end
    end
})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(40, 99, 40)
        },
        {
            "ATK",
            Stat.new(5, 99)
        },
        {
            "DEF",
            Stat.new(1, 99, 1)
        },
        {
            "NRG",
            Stat.new(1, 999999999, 0)
        },
        {
            "owner",
            Stat.new(0, 999999)
        }
    }
)})
prefab:addBehavior({tree = BehaviorTree.new("mana_turret"):root(ReactiveSelectorNode.new("root"):add(SequenceNode.new("targeting"):add(IsPoweredNode.new("check_power")):add(HasExpiredNode.new("target_cooldown", {entry = "target_cooldown"})):add(SetEntryNode.new(
    "set_cooldown",
    {
        entry = "target_cooldown",
        timerValue = GameTimer.new(seconds(2))
    }
)):add(FindTargetNode.new("find_target", {
    team = CombatTeamTarget.Friendly,
    distance = Sizes.SEGMENT * 1.5,
    distanceWeight = 0.5,
    stickyWeight = 1,
    healthWeight = 0.8
}))):add(SequenceNode.new("attacking"):add(IsPoweredNode.new("check_power")):add(ValidateTargetNode.new("range_check", {maxRange = Sizes.SEGMENT})):add(HasExpiredNode.new("attack_cooldown", {entry = "attack_cooldown"})):add(PlayAnimationNode.new("play_shoot", {name = "shoot", blocking = true})):add(PlaySoundNode.new("play_attack_sound", {sound = "event:/ENEMIES/LOTUS/LOTUS_ATTACK"})):add(FireProjectileNode.new(
    "fire_projectile",
    {
        prefab = "material.mana_bullet_projectile",
        speed = 4,
        lifetime = seconds(5),
        offset = Vector.new(0, -Sizes.SUBTILE),
        accuracyVariance = 0.1,
        collidesWithGround = false
    }
)):add(StatChangeStateNode.new("reduce_nrg", {name = "NRG", amount = -1})):add(SetEntryNode.new(
    "set_cooldown",
    {
        entry = "attack_cooldown",
        timerValue = GameTimer.new(seconds(3))
    }
))))})
prefab:addCombat({
    team = CombatTeam.Structure,
    priority = CombatPriority.Maximum,
    destroyOnDeath = false,
    onDeath = breakItem,
    takeHitSfx = "event:/ENEMIES/LOTUS/LOTUS_TAKEHIT",
    deathSfx = "event:/ENEMIES/LOTUS/LOTUS_DEATH"
})
prefab:addLight({
    intensity = 80,
    color = Color.new(151, 218, 229)
})
return ____exports
