local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 5,["16"] = 5,["17"] = 6,["18"] = 6,["19"] = 9,["20"] = 11,["21"] = 13,["22"] = 17,["23"] = 22,["24"] = 24,["25"] = 26,["26"] = 27,["27"] = 29,["28"] = 29,["29"] = 29,["30"] = 29,["31"] = 29,["32"] = 29,["33"] = 29,["34"] = 29,["35"] = 27,["36"] = 26,["37"] = 33,["38"] = 37,["39"] = 37,["40"] = 39,["41"] = 39,["42"] = 39,["43"] = 37,["44"] = 40,["45"] = 41,["46"] = 41,["47"] = 42,["48"] = 42,["49"] = 42,["50"] = 41,["51"] = 37,["52"] = 37,["53"] = 47,["54"] = 48,["55"] = 48,["56"] = 49,["57"] = 48,["58"] = 47,["59"] = 53,["60"] = 58,["61"] = 62,["62"] = 67,["63"] = 68,["64"] = 68,["65"] = 69,["66"] = 69,["67"] = 69,["68"] = 68,["69"] = 70,["70"] = 70,["71"] = 70,["72"] = 68,["73"] = 71,["74"] = 71,["75"] = 71,["76"] = 68,["77"] = 68,["78"] = 67,["79"] = 75,["80"] = 81});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____craft = require("craft")
local CraftSite = ____craft.CraftSite
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local ____utility = require("utility")
local breakItem = ____utility.breakItem
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addItem({icon = "icons_matter_compressor", stack = 20})
prefab:addRender("matter_compressor-1")
prefab:addAnimation({start = "idle"})
prefab:addInventory({inventories = {
    {name = "input-0", size = 1, filterPrefabs = {INVALID_ENTITYID}},
    {
        name = "output",
        size = 1,
        filterPrefabs = {INVALID_ENTITYID},
        features = bit.bor(
            bit.bor(InventoryFeatures.Dispense, InventoryFeatures.Withdraw),
            InventoryFeatures.RecipeFlush
        )
    }
}})
prefab:addCollector({reach = 2})
prefab:addPlacement({
    drop = Prefab.getID("structure.matter_compressor"),
    features = bit.bor(
        bit.bor(PlacementFeatures.Default, PlacementFeatures.Pivotable),
        PlacementFeatures.ScaffoldingSupport
    ),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(3, 3),
            "matter_compressor-1"
        )}
    )}
})
prefab:addEvent({interact = __TS__New(
    Event,
    function(player, entity)
        showModularDialogWithInventory(nil, "EnergyFabricator", entity)
    end
)})
prefab:addFabricator({speed = 1, site = CraftSite.Compressor})
prefab:addDispenser({frequency = 500})
prefab:addConsumer({idlePower = 9, activePower = 36})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(30, 99, 30)
        },
        {
            "DEF",
            Stat.new(1, 99, 1)
        },
        {
            "owner",
            Stat.new(0, 999999)
        }
    }
)})
prefab:addCombat({team = CombatTeam.Structure, destroyOnDeath = false, onDeath = breakItem})
prefab:addOverlay()
return ____exports
