local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 5,["16"] = 5,["17"] = 6,["18"] = 6,["19"] = 9,["20"] = 11,["21"] = 13,["22"] = 17,["23"] = 22,["24"] = 24,["25"] = 29,["26"] = 33,["27"] = 35,["28"] = 35,["29"] = 35,["30"] = 35,["31"] = 35,["32"] = 35,["33"] = 34,["34"] = 36,["35"] = 36,["36"] = 36,["37"] = 36,["38"] = 36,["39"] = 36,["40"] = 36,["41"] = 36,["42"] = 34,["43"] = 33,["44"] = 40,["45"] = 44,["46"] = 44,["47"] = 46,["48"] = 46,["49"] = 46,["50"] = 44,["51"] = 47,["52"] = 48,["53"] = 48,["54"] = 49,["55"] = 49,["56"] = 49,["57"] = 48,["58"] = 44,["59"] = 44,["60"] = 54,["61"] = 55,["62"] = 55,["63"] = 56,["64"] = 55,["65"] = 54,["66"] = 60,["67"] = 65,["68"] = 69,["69"] = 74,["70"] = 75,["71"] = 75,["72"] = 76,["73"] = 76,["74"] = 76,["75"] = 75,["76"] = 77,["77"] = 77,["78"] = 77,["79"] = 75,["80"] = 78,["81"] = 78,["82"] = 78,["83"] = 75,["84"] = 75,["85"] = 74,["86"] = 82,["87"] = 88});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____craft = require("craft")
local CraftSite = ____craft.CraftSite
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local ____utility = require("utility")
local breakItem = ____utility.breakItem
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addItem({icon = "icons_matter_refiner", stack = 20})
prefab:addRender("matter_refiner")
prefab:addAnimation({start = "idle", loop = true})
prefab:addAmbience({sfx = "event:/FABRICATORS/MATTER_REFINER_LOOP"})
prefab:addInventory({inventories = {
    {
        name = "input-0",
        size = 1,
        collectStack = 10,
        stackOverride = 50,
        filterCategories = {""}
    },
    {
        name = "output",
        size = 1,
        filterPrefabs = {INVALID_ENTITYID},
        features = bit.bor(
            bit.bor(InventoryFeatures.Dispense, InventoryFeatures.Withdraw),
            InventoryFeatures.RecipeFlush
        )
    }
}})
prefab:addCollector({reach = 2})
prefab:addPlacement({
    drop = Prefab.getID("structure.matter_refiner"),
    features = bit.bor(
        bit.bor(PlacementFeatures.Default, PlacementFeatures.Pivotable),
        PlacementFeatures.ScaffoldingSupport
    ),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(3, 3),
            "matter_refiner-1"
        )}
    )}
})
prefab:addEvent({interact = __TS__New(
    Event,
    function(player, entity)
        showModularDialogWithInventory(nil, "EnergyFabricator", entity)
    end
)})
prefab:addFabricator({speed = 1, site = CraftSite.Refiner})
prefab:addDispenser({frequency = 500})
prefab:addConsumer({idlePower = 7, activePower = 28})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(30, 99, 30)
        },
        {
            "DEF",
            Stat.new(1, 99, 1)
        },
        {
            "owner",
            Stat.new(0, 999999)
        }
    }
)})
prefab:addCombat({team = CombatTeam.Structure, destroyOnDeath = false, onDeath = breakItem})
prefab:addOverlay()
return ____exports
