local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 7,["16"] = 9,["17"] = 11,["18"] = 15,["19"] = 20,["20"] = 24,["21"] = 26,["22"] = 26,["23"] = 26,["24"] = 26,["25"] = 26,["26"] = 26,["27"] = 32,["28"] = 32,["29"] = 32,["30"] = 26,["31"] = 25,["32"] = 34,["33"] = 34,["34"] = 34,["35"] = 34,["36"] = 34,["37"] = 34,["38"] = 25,["39"] = 35,["40"] = 35,["41"] = 35,["42"] = 35,["43"] = 35,["44"] = 25,["45"] = 24,["46"] = 39,["47"] = 43,["48"] = 43,["49"] = 43,["50"] = 46,["51"] = 47,["52"] = 47,["53"] = 48,["54"] = 48,["55"] = 48,["56"] = 47,["57"] = 43,["58"] = 43,["59"] = 53,["60"] = 54,["61"] = 54,["62"] = 55,["63"] = 54,["64"] = 53,["65"] = 59,["66"] = 64,["67"] = 65,["68"] = 65,["69"] = 66,["70"] = 66,["71"] = 65,["72"] = 64,["73"] = 70,["74"] = 72,["75"] = 77});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addItem({icon = "icons_monster_stable", stack = 20})
prefab:addRender("monster_stable", {layer = 8})
prefab:addInventory({inventories = {
    {
        name = "egg",
        size = 1,
        collectStack = 1,
        stackOverride = 1,
        filterPrefabs = {INVALID_ENTITYID},
        features = bit.bor(
            bit.bor(InventoryFeatures.Collect, InventoryFeatures.Deposit),
            InventoryFeatures.Discard
        )
    },
    {
        name = "food",
        size = 1,
        filterPrefabs = {INVALID_ENTITYID},
        collectStack = 4,
        stackOverride = 20
    },
    {
        name = "output",
        size = 2,
        filterPrefabs = {INVALID_ENTITYID},
        features = bit.bor(InventoryFeatures.Dispense, InventoryFeatures.Withdraw)
    }
}})
prefab:addCollector({reach = 2})
prefab:addPlacement({
    drop = Prefab.getID("structure.monster_stable"),
    features = bit.bor(PlacementFeatures.Default, PlacementFeatures.Pivotable),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(3, 3),
            "monster_stable"
        )}
    )}
})
prefab:addEvent({interact = __TS__New(
    Event,
    function(player, entity)
        showModularDialogWithInventory(nil, "MonsterStable", entity)
    end
)})
prefab:addConsumer({idlePower = 6, activePower = 24})
prefab:addStats({stats = __TS__New(
    Map,
    {{
        "NRG",
        Stat.new(1, 999999999, 0)
    }}
)})
prefab:addHusbandry()
prefab:addDispenser({isEnabled = true, frequency = 500})
prefab:addOverlay()
return ____exports
