local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 2,["9"] = 2,["10"] = 3,["11"] = 3,["12"] = 4,["13"] = 4,["14"] = 5,["15"] = 5,["16"] = 7,["17"] = 9,["18"] = 11,["19"] = 15,["20"] = 17,["21"] = 17,["22"] = 19,["23"] = 19,["24"] = 19,["25"] = 19,["26"] = 19,["27"] = 17,["28"] = 17,["29"] = 27,["30"] = 32,["31"] = 37,["32"] = 37,["33"] = 37,["34"] = 40,["35"] = 41,["36"] = 41,["37"] = 41,["38"] = 41,["39"] = 41,["40"] = 41,["41"] = 37,["42"] = 43,["43"] = 44,["44"] = 37,["45"] = 37,["46"] = 48,["47"] = 49,["48"] = 49,["49"] = 49,["50"] = 50,["51"] = 51,["52"] = 52,["53"] = 53,["55"] = 55,["56"] = 55,["57"] = 56,["58"] = 57,["59"] = 58,["61"] = 55,["64"] = 62,["65"] = 63,["66"] = 49,["67"] = 48,["68"] = 65,["69"] = 65,["70"] = 65,["71"] = 66,["72"] = 65,["73"] = 48,["74"] = 48,["75"] = 70,["76"] = 71,["77"] = 72,["78"] = 73,["79"] = 70});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local ____world = require("world")
local World = ____world.World
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("pump-1", {layer = 100})
prefab:addFluidSource({
    capacity = 800,
    outputs = {
        FluidIO.new(FluidType.Water, TileDirection.Up, 0),
        FluidIO.new(FluidType.Water, TileDirection.Right, 0),
        FluidIO.new(FluidType.Water, TileDirection.Up, 0),
        FluidIO.new(FluidType.Water, TileDirection.Right, 0)
    }
})
prefab:addConsumer({idlePower = 2, activePower = 8})
prefab:addItem({icon = "icons_pump", stack = 10})
prefab:addPlacement({
    drop = Prefab.getID("structure.pump"),
    features = bit.bor(PlacementFeatures.Default, PlacementFeatures.Pivotable),
    axes = {PlacementAxis.new(
        PlacementAxisType.Backwall,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(2, 2),
            "pump-1"
        )}
    )},
    overlayFilter = function(____, entity)
        return entity.wellspring ~= nil
    end
})
prefab:addEvent({
    placed = __TS__New(
        Event,
        function(entity)
            local supportEntity = EntityManager.get(entity.placement.axis.supportEntity)
            local wellspring = supportEntity.wellspring
            wellspring.extractor = entity.id
            local source = entity.fluidSource
            do
                local i = 0
                while i < #source.outputs do
                    local output = source.outputs[i + 1]
                    if output.type ~= FluidType.None then
                        source.outputs[i + 1].type = wellspring.type
                    end
                    i = i + 1
                end
            end
            local realm = World:get(supportEntity.location.realm)
            realm.indicator:discoverResourceAttached(realm, supportEntity)
        end
    ),
    interact = __TS__New(
        Event,
        function(player, entity)
            showModularDialogWithInventory(nil, "FluidSource", entity)
        end
    )
})
prefab.onDestroy:listen(function(entity)
    local supportEntity = EntityManager.get(entity.placement.axis.supportEntity)
    local wellspring = supportEntity.wellspring
    wellspring.extractor = INVALID_ENTITYID
end)
return ____exports
