local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 2,["9"] = 2,["10"] = 3,["11"] = 3,["12"] = 4,["13"] = 4,["14"] = 5,["15"] = 5,["16"] = 6,["17"] = 6,["18"] = 7,["19"] = 7,["20"] = 9,["21"] = 11,["22"] = 13,["23"] = 18,["24"] = 22,["25"] = 24,["26"] = 24,["27"] = 24,["28"] = 27,["29"] = 28,["30"] = 28,["31"] = 29,["32"] = 29,["33"] = 29,["34"] = 29,["35"] = 28,["36"] = 30,["37"] = 30,["38"] = 30,["39"] = 30,["40"] = 28,["41"] = 31,["42"] = 31,["43"] = 31,["44"] = 31,["45"] = 28,["46"] = 32,["47"] = 32,["48"] = 32,["49"] = 32,["50"] = 28,["51"] = 28,["52"] = 24,["53"] = 24,["54"] = 37,["55"] = 38,["56"] = 40,["57"] = 41,["58"] = 41,["59"] = 41,["60"] = 42,["61"] = 43,["62"] = 44,["63"] = 45,["64"] = 46,["65"] = 46,["66"] = 46,["67"] = 46,["68"] = 41,["69"] = 40,["70"] = 48,["71"] = 48,["72"] = 48,["73"] = 49,["74"] = 48,["75"] = 40,["76"] = 40,["77"] = 53,["78"] = 53,["79"] = 53,["80"] = 53,["81"] = 53});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____placement = require("utility.placement")
local placementRotate = ____placement.placementRotate
local ____splitter = require("systems.splitter")
local SplitterSystem = ____splitter.SplitterSystem
local ____world = require("world")
local World = ____world.World
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addItem({icon = "icons_splitter_ii", stack = 50})
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("splitter_ii_up", {layer = 255})
prefab:addPlacement({
    drop = Prefab.getID("structure.splitter_ii"),
    features = bit.bor(PlacementFeatures.Default, PlacementFeatures.NoSupportBackwall),
    axes = {PlacementAxis.new(
        PlacementAxisType.Backwall,
        {
            PlacementDirection.new(
                FacingDirection.Up,
                TileVector.new(1, 1),
                "splitter_ii_up"
            ),
            PlacementDirection.new(
                FacingDirection.Right,
                TileVector.new(1, 1),
                "splitter_ii_right"
            ),
            PlacementDirection.new(
                FacingDirection.Down,
                TileVector.new(1, 1),
                "splitter_ii_down"
            ),
            PlacementDirection.new(
                FacingDirection.Left,
                TileVector.new(1, 1),
                "splitter_ii_left"
            )
        }
    )}
})
prefab:addSplitter()
prefab:addFilter()
prefab:addEvent({
    rotate = __TS__New(
        Event,
        function(player, entity)
            local realm = World:get(entity.location.realm)
            local placement = entity.placement
            placementRotate(placement, entity, realm)
            SplitterSystem:handleRotate(entity)
            realm.transport:rotate(
                placement.axis.area:getPosition(),
                placement.direction
            )
        end
    ),
    interact = __TS__New(
        Event,
        function(player, entity)
            showModularDialogWithInventory(nil, "Splitter", entity)
        end
    )
})
prefab:addTransport({
    type = TransportTileType.Splitter,
    speed = 200,
    mapColor = Color.new(234, 202, 12)
})
return ____exports
