local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 2,["9"] = 2,["10"] = 3,["11"] = 3,["12"] = 4,["13"] = 4,["14"] = 6,["15"] = 8,["16"] = 10,["17"] = 14,["18"] = 20,["19"] = 25,["20"] = 26,["21"] = 26,["22"] = 29,["23"] = 29,["24"] = 29,["25"] = 29,["26"] = 29,["27"] = 29,["28"] = 26,["29"] = 25,["30"] = 33,["31"] = 37,["32"] = 37,["33"] = 39,["34"] = 40,["35"] = 40,["36"] = 40,["37"] = 40,["38"] = 40,["39"] = 40,["40"] = 37,["41"] = 37,["42"] = 44,["43"] = 44,["44"] = 44,["45"] = 47,["46"] = 47,["47"] = 47,["48"] = 48,["49"] = 49,["50"] = 50,["51"] = 47,["52"] = 44,["53"] = 53,["54"] = 53,["55"] = 53,["56"] = 54,["57"] = 55,["58"] = 53,["59"] = 44,["60"] = 44});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____base = require("ui.base")
local showDialogWithInventory = ____base.showDialogWithInventory
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("sturdy_chest-1")
prefab:addItem({icon = "icons_sturdy_chest", stack = 10})
prefab:addInventory({inventories = {{
    size = 20,
    collectSize = 20,
    features = bit.bor(
        bit.bor(
            bit.bor(InventoryFeatures.Collect, InventoryFeatures.Dispense),
            InventoryFeatures.Withdraw
        ),
        InventoryFeatures.Deposit
    )
}}})
prefab:addCollector({reach = 1})
prefab:addPlacement({
    drop = Prefab.getID("structure.sturdy_chest"),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(2, 2),
            "sturdy_chest-1"
        )}
    )}
})
prefab:addEvent({
    interactCursor = CursorType.Container,
    interactText = "OPEN",
    interact = __TS__New(
        Event,
        function(player, entity)
            animator.play(entity, "open", false)
            animator.queue(entity, "running")
            showDialogWithInventory(nil, "Container", entity)
        end
    ),
    withdraw = __TS__New(
        Event,
        function(player, entity)
            animator.play(entity, "close", false)
            animator.queue(entity, "idle")
        end
    )
})
return ____exports
