local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 2,["9"] = 2,["10"] = 3,["11"] = 3,["12"] = 4,["13"] = 4,["14"] = 5,["15"] = 5,["16"] = 7,["17"] = 9,["18"] = 11,["19"] = 15,["20"] = 17,["21"] = 21,["22"] = 26,["23"] = 27,["24"] = 27,["25"] = 30,["26"] = 30,["27"] = 30,["28"] = 30,["29"] = 30,["30"] = 30,["31"] = 27,["32"] = 26,["33"] = 34,["34"] = 38,["35"] = 38,["36"] = 38,["37"] = 41,["38"] = 42,["39"] = 42,["40"] = 42,["41"] = 42,["42"] = 42,["43"] = 42,["44"] = 38,["45"] = 38,["46"] = 46,["47"] = 46,["48"] = 46,["49"] = 49,["50"] = 49,["51"] = 49,["52"] = 50,["53"] = 51,["54"] = 52,["55"] = 53,["56"] = 49,["57"] = 46,["58"] = 56,["59"] = 56,["60"] = 56,["61"] = 57,["62"] = 58,["63"] = 59,["64"] = 56,["65"] = 46,["66"] = 46,["67"] = 63,["68"] = 64,["69"] = 65,["70"] = 66,["71"] = 67,["72"] = 67,["73"] = 67,["74"] = 68,["75"] = 68,["76"] = 68,["77"] = 68,["78"] = 67,["79"] = 67,["81"] = 65,["82"] = 63});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____scheduler = require("systems.scheduler")
local scheduler = ____scheduler.scheduler
local ____base = require("ui.base")
local showDialogWithInventory = ____base.showDialogWithInventory
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("void_chest-1")
prefab:addAnimation({start = "idle"})
prefab:addItem({icon = "icons_void_chest", stack = 10})
prefab:addInventory({inventories = {{
    size = 5,
    collectSize = 5,
    features = bit.bor(
        bit.bor(
            bit.bor(InventoryFeatures.Collect, InventoryFeatures.Dispense),
            InventoryFeatures.Withdraw
        ),
        InventoryFeatures.Deposit
    )
}}})
prefab:addCollector({reach = 0})
prefab:addPlacement({
    drop = Prefab.getID("structure.void_chest"),
    features = bit.bor(PlacementFeatures.Default, PlacementFeatures.ScaffoldingSupport),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(1, 1),
            "void_chest-1"
        )}
    )}
})
prefab:addEvent({
    interactCursor = CursorType.Container,
    interactText = "OPEN",
    interact = __TS__New(
        Event,
        function(player, entity)
            animator.play(entity, "open", false)
            animator.queue(entity, "running")
            audio.start("event:/GENERAL/CHEST_OPEN", entity.transform.position)
            showDialogWithInventory(nil, "Container", entity)
        end
    ),
    withdraw = __TS__New(
        Event,
        function(player, entity)
            animator.play(entity, "close", false)
            animator.queue(entity, "idle")
            audio.start("event:/GENERAL/CHEST_CLOSE", entity.transform.position)
        end
    )
})
prefab.onCreate:listen(function(entity)
    local entityID = entity.id
    entity.inventory.onChange:listen(function(name, index, item)
        if item.quantity > 0 then
            scheduler:add(
                0,
                function()
                    EntityManager.get(entityID).inventory:get():set(
                        index,
                        Item.new()
                    )
                end
            )
        end
    end)
end)
return ____exports
