local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["8"] = 1,["9"] = 1,["10"] = 2,["11"] = 2,["12"] = 3,["13"] = 3,["14"] = 4,["15"] = 4,["16"] = 5,["17"] = 5,["18"] = 6,["19"] = 6,["20"] = 7,["21"] = 7,["22"] = 8,["23"] = 8,["24"] = 10,["25"] = 10,["26"] = 10,["28"] = 10,["29"] = 11,["30"] = 19,["31"] = 17,["32"] = 13,["33"] = 13,["34"] = 13,["35"] = 22,["36"] = 23,["37"] = 25,["38"] = 26,["39"] = 27,["40"] = 28,["41"] = 29,["43"] = 31,["45"] = 34,["46"] = 35,["47"] = 36,["48"] = 37,["49"] = 37,["50"] = 37,["51"] = 37,["52"] = 37,["53"] = 39,["54"] = 40,["55"] = 40,["56"] = 40,["57"] = 40,["58"] = 40,["59"] = 41,["60"] = 43,["61"] = 44,["62"] = 45,["63"] = 46,["64"] = 47,["65"] = 48,["66"] = 49,["67"] = 50,["68"] = 52,["69"] = 22,["70"] = 55,["71"] = 56,["72"] = 57,["73"] = 58,["74"] = 59,["75"] = 55,["76"] = 62,["77"] = 63,["78"] = 62,["79"] = 66,["80"] = 67,["81"] = 66,["82"] = 70,["83"] = 71,["84"] = 71,["85"] = 71,["86"] = 71,["87"] = 72,["88"] = 73,["89"] = 74,["90"] = 74,["91"] = 74,["92"] = 74,["93"] = 75,["94"] = 75,["95"] = 75,["96"] = 75,["97"] = 76,["98"] = 77,["99"] = 70,["100"] = 80,["101"] = 81,["102"] = 82,["104"] = 84,["105"] = 80,["106"] = 88});
local ____exports = {}
local ____item = require("systems.item")
local ItemSystem = ____item.ItemSystem
local ____mainmenu = require("ui.mainmenu")
local MainMenu = ____mainmenu.MainMenu
local ____scene = require("scenes.scene")
local Scene = ____scene.Scene
local ____dispenser = require("systems.dispenser")
local DispenserSystem = ____dispenser.DispenserSystem
local ____core = require("core")
local core = ____core.core
local ____Sizes = require("Sizes")
local Sizes = ____Sizes.Sizes
local ____settings = require("ui.settings")
local SettingsUI = ____settings.SettingsUI
local ____scheduler = require("systems.scheduler")
local scheduler = ____scheduler.scheduler
local Menu = __TS__Class()
Menu.name = "Menu"
__TS__ClassExtends(Menu, Scene)
function Menu.prototype.____constructor(self)
    Scene.prototype.____constructor(self)
    self.menu = __TS__New(MainMenu)
    self.music = audio.play("event:/MUSIC/TITLE_SCREEN")
end
function Menu.create(self)
    return __TS__New(Menu)
end
function Menu.prototype.activate(self, data)
    SettingsUI:addSettings()
    local viewport = Renderer.getViewport(RenderPassTypes.Main)
    if viewport.width >= 3840 then
        UIManager.setScale(3, 3)
    elseif viewport.width >= 1366 then
        UIManager.setScale(2, 2)
    else
        UIManager.setScale(1, 1)
    end
    ItemSystem:initialize()
    DispenserSystem:initialize()
    self.menu:show()
    self.layer = Renderer.addLayer(
        100,
        RenderPassTypes.Main,
        core.cb(self, "draw")
    )
    EntityLayerManager.clear()
    self.entityLayer = EntityLayer.new(
        200,
        Vector.new(Sizes.REGION, Sizes.REGION),
        Sizes.REGION
    )
    EntityLayerManager.add(self.entityLayer)
    local simple = EntityManager.create("fx.simple")
    animator.play(simple, "apotheos_main_menu.idle", true)
    simple.render.color = Color.new(255, 255, 255, 255)
    local scale = 16 * viewport.height / 1080
    simple.transform.scale:set(scale, scale)
    simple.transform.origin:set(30, 47)
    simple.transform.position:set(viewport.width * 3 / 5, viewport.height / 2)
    self.entityLayer:add(simple)
    self.music:start()
end
function Menu.prototype.deactivate(self)
    EntityLayerManager.clear()
    Renderer.removeLayer(self.layer.pass, self.layer.index)
    self.music:stop(FMODStopMode.FMOD_STUDIO_STOP_ALLOWFADEOUT)
    self.music:release()
end
function Menu.prototype.updateStart(self, frameTime)
    scheduler:update(frameTime)
end
function Menu.prototype.update(self, frameTime)
    self.entityLayer:update(frameTime)
end
function Menu.prototype.draw(self, renderer, layer, viewport)
    local sprite = Sprite.new(
        "blackness",
        Vector.new()
    )
    sprite.material = Renderer.getMaterialHandle("gradient")
    local material = Renderer.getMaterial(sprite.material)
    material:setUniform(
        "topColor",
        Color.new(37, 33, 52)
    )
    material:setUniform(
        "bottomColor",
        Color.new(50, 55, 85)
    )
    sprite.scale:set(viewport.width, viewport.height)
    renderer:draw(sprite)
end
function Menu.prototype.handleKeyDown(self, state, mod, key)
    if key == Keyboard.KEY_C then
        self.menu.menu:handleContinueGameplay()
    end
    return false
end
____exports.scene = Menu
return ____exports
