local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__ArrayIndexOf = ____lualib.__TS__ArrayIndexOf
local __TS__ArraySplice = ____lualib.__TS__ArraySplice
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["9"] = 1,["10"] = 1,["12"] = 1,["13"] = 2,["14"] = 2,["15"] = 3,["16"] = 3,["17"] = 4,["18"] = 4,["19"] = 5,["20"] = 5,["21"] = 6,["22"] = 6,["23"] = 7,["24"] = 7,["25"] = 10,["26"] = 10,["27"] = 10,["29"] = 10,["30"] = 11,["31"] = 10,["32"] = 13,["33"] = 14,["34"] = 14,["35"] = 13,["36"] = 17,["37"] = 18,["38"] = 19,["39"] = 20,["41"] = 17,["42"] = 25,["43"] = 25,["44"] = 25,["46"] = 25,["47"] = 26,["48"] = 25,["49"] = 28,["50"] = 29,["51"] = 29,["52"] = 28,["53"] = 33,["54"] = 33,["55"] = 33});
local ____exports = {}
local System = __TS__Class()
System.name = "System"
function System.prototype.____constructor(self)
end
function System.prototype.add(self, entity, component)
end
function System.prototype.remove(self, entity, component)
end
function System.prototype.update(self, frameTime)
end
function System.prototype.updateFixed(self, fixedTime)
end
function System.prototype.simulate(self, time)
end
function System.prototype.reset(self)
end
local EntitySystem = __TS__Class()
EntitySystem.name = "EntitySystem"
__TS__ClassExtends(EntitySystem, System)
function EntitySystem.prototype.____constructor(self, ...)
    System.prototype.____constructor(self, ...)
    self.entities = {}
end
function EntitySystem.prototype.add(self, entity, component)
    local ____self_entities_0 = self.entities
    ____self_entities_0[#____self_entities_0 + 1] = entity.id
end
function EntitySystem.prototype.remove(self, entity, component)
    local index = __TS__ArrayIndexOf(self.entities, entity.id)
    if index ~= -1 then
        __TS__ArraySplice(self.entities, index, 1)
    end
end
local EntityPrefabSystem = __TS__Class()
EntityPrefabSystem.name = "EntityPrefabSystem"
__TS__ClassExtends(EntityPrefabSystem, System)
function EntityPrefabSystem.prototype.____constructor(self, ...)
    System.prototype.____constructor(self, ...)
    self.prefabs = {}
end
function EntityPrefabSystem.prototype.addPrefab(self, entity, component)
    local ____self_prefabs_1 = self.prefabs
    ____self_prefabs_1[#____self_prefabs_1 + 1] = entity.id
end
____exports.System = System
____exports.EntitySystem = EntitySystem
____exports.EntityPrefabSystem = EntityPrefabSystem
return ____exports
