local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 3,["9"] = 3,["10"] = 6,["11"] = 7,["12"] = 6,["13"] = 10,["14"] = 11,["15"] = 12,["17"] = 13,["18"] = 13,["19"] = 14,["20"] = 15,["21"] = 16,["22"] = 17,["23"] = 18,["24"] = 19,["27"] = 13,["30"] = 24,["31"] = 10,["32"] = 27,["33"] = 28,["34"] = 29,["35"] = 30,["37"] = 31,["38"] = 31,["39"] = 32,["40"] = 33,["41"] = 34,["42"] = 35,["43"] = 36,["47"] = 31,["50"] = 42,["51"] = 27,["52"] = 47});
local ____exports = {}
local ____core = require("core")
local core = ____core.core
local CollectorSystem = __TS__Class()
CollectorSystem.name = "CollectorSystem"
function CollectorSystem.prototype.____constructor(self, itemTransport)
    self.itemTransport = itemTransport
end
function CollectorSystem.prototype.add(self, entity)
    local isFull = true
    local inventories = entity.inventory:getInventories()
    do
        local i = 0
        while i < #inventories do
            local inventory = inventories[i + 1]
            if bit.band(inventory.features, InventoryFeatures.Collect) == InventoryFeatures.Collect then
                inventory.onChange:listen(core.bind(self, "handleInventoryChange", entity.id))
                local stack = inventory.collectStack > 0 and inventory.collectStack or inventory.stackOverride
                if inventory.size > 1 or inventory.items[1].quantity < stack then
                    isFull = false
                end
            end
            i = i + 1
        end
    end
    self.itemTransport:setCollectorState(entity.id, isFull)
end
function CollectorSystem.prototype.handleInventoryChange(self, entityID, index, item, isLocked, previous)
    local entity = EntityManager.get(entityID)
    local isFull = true
    local inventories = entity.inventory:getInventories()
    do
        local i = 0
        while i < #inventories do
            local inventory = inventories[i + 1]
            if bit.band(inventory.features, InventoryFeatures.Collect) == InventoryFeatures.Collect then
                local stack = inventory.collectStack > 0 and inventory.collectStack or inventory.stackOverride
                if inventory.size > 1 or inventory.items[1].quantity < stack then
                    isFull = false
                    break
                end
            end
            i = i + 1
        end
    end
    self.itemTransport:setCollectorState(entityID, isFull)
end
____exports.CollectorSystem = CollectorSystem
return ____exports
