local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["8"] = 1,["9"] = 1,["10"] = 2,["11"] = 2,["12"] = 2,["13"] = 4,["14"] = 4,["15"] = 5,["16"] = 5,["17"] = 6,["18"] = 6,["19"] = 6,["20"] = 8,["21"] = 9,["22"] = 25,["23"] = 26,["24"] = 27,["25"] = 28,["26"] = 28,["27"] = 28,["28"] = 28,["29"] = 28,["30"] = 28,["31"] = 28,["32"] = 28,["33"] = 28,["34"] = 27,["35"] = 38,["36"] = 38,["37"] = 38,["38"] = 38,["39"] = 38,["40"] = 38,["41"] = 38,["42"] = 38,["43"] = 38,["44"] = 27,["45"] = 48,["46"] = 48,["47"] = 48,["48"] = 48,["49"] = 48,["50"] = 48,["51"] = 48,["52"] = 48,["53"] = 48,["54"] = 27,["55"] = 58,["56"] = 58,["57"] = 58,["58"] = 58,["59"] = 58,["60"] = 58,["61"] = 58,["62"] = 58,["63"] = 58,["64"] = 27,["65"] = 68,["66"] = 68,["67"] = 68,["68"] = 68,["69"] = 68,["70"] = 68,["71"] = 68,["72"] = 68,["73"] = 68,["74"] = 27,["75"] = 27,["76"] = 80,["77"] = 80,["78"] = 80,["79"] = 83,["80"] = 84,["81"] = 84,["82"] = 84,["83"] = 84,["84"] = 85,["85"] = 85,["86"] = 85,["87"] = 85,["88"] = 83,["89"] = 88,["90"] = 89,["91"] = 90,["92"] = 91,["93"] = 92,["94"] = 93,["97"] = 88,["98"] = 98,["99"] = 99,["100"] = 100,["101"] = 101,["102"] = 102,["103"] = 104,["104"] = 106,["105"] = 107,["106"] = 108,["107"] = 109,["108"] = 110,["109"] = 111,["110"] = 112,["111"] = 113,["112"] = 114,["113"] = 115,["114"] = 116,["115"] = 118,["116"] = 118,["117"] = 119,["118"] = 121,["119"] = 122,["121"] = 124,["124"] = 127,["126"] = 129,["127"] = 98,["128"] = 132,["129"] = 133,["130"] = 134,["131"] = 132,["132"] = 137,["133"] = 138,["134"] = 139,["135"] = 140,["136"] = 141,["137"] = 142,["138"] = 143,["139"] = 144,["140"] = 145,["141"] = 146,["142"] = 137,["143"] = 81,["144"] = 152,["145"] = 153,["146"] = 154,["147"] = 155,["148"] = 155,["149"] = 155,["150"] = 155,["152"] = 158,["153"] = 160,["154"] = 160});
local ____exports = {}
local ____core = require("core")
local core = ____core.core
local ____event = require("event")
local Event = ____event.Event
local GameEvents = ____event.GameEvents
local ____world = require("world")
local World = ____world.World
local ____base = require("systems.base")
local EntitySystem = ____base.EntitySystem
local ____technology = require("systems.technology")
local TechnologyID = ____technology.TechnologyID
local TechnologyManager = ____technology.TechnologyManager
GameEvents.conduitInfused = __TS__New(Event)
GameEvents.conduitLeveled = __TS__New(Event)
local MANA_PREFAB_FILTER = {Prefab.getID("material.mana")}
local MANA_II_PREFAB_FILTER = {Prefab.getID("material.mana")}
local CONDUIT_TIERS = {
    {
        prefabFilter = MANA_PREFAB_FILTER,
        required = 1000,
        partitions = 4,
        power = 1000,
        animation = HashString("1_active"),
        disabled = HashString("1_dead"),
        grow = HashString("0_grow"),
        technology = TechnologyID.ConduitTapping
    },
    {
        prefabFilter = MANA_PREFAB_FILTER,
        required = 2000,
        partitions = 5,
        power = 2000,
        animation = HashString("2_active"),
        disabled = HashString("2_dead"),
        grow = HashString("1_grow"),
        technology = TechnologyID.IntermediateConduitTapping
    },
    {
        prefabFilter = MANA_PREFAB_FILTER,
        required = 5000,
        partitions = 5,
        power = 3000,
        animation = HashString("3_active"),
        disabled = HashString("3_dead"),
        grow = HashString("2_grow"),
        technology = TechnologyID.AdvancedConduitTapping
    },
    {
        prefabFilter = MANA_II_PREFAB_FILTER,
        required = 1000,
        partitions = 4,
        power = 4000,
        animation = HashString("4_active"),
        disabled = HashString("4_dead"),
        grow = HashString("3_grow"),
        technology = TechnologyID.None
    },
    {
        prefabFilter = MANA_II_PREFAB_FILTER,
        required = 2000,
        partitions = 5,
        power = 5000,
        animation = HashString("5_active"),
        disabled = HashString("5_dead"),
        grow = HashString("4_grow"),
        technology = TechnologyID.None
    }
}
local ConduitSystem = __TS__Class()
ConduitSystem.name = "ConduitSystem"
__TS__ClassExtends(ConduitSystem, EntitySystem)
function ConduitSystem.prototype.initialize(self)
    TechnologyManager:listenForLearnedTech(
        "ConduitTapping",
        core.bind(self, "handleConduitTappingResearched", 0)
    )
    TechnologyManager:listenForLearnedTech(
        "ConduitTapping2",
        core.bind(self, "handleConduitTappingResearched", 1)
    )
end
function ConduitSystem.prototype.handleConduitTappingResearched(self, tier)
    for ____, entityID in ipairs(self.entities) do
        local entity = EntityManager.get(entityID)
        local conduit = entity.conduit
        if tier == conduit.tier and self:canUnlock(conduit) then
            self:unlockTier(entity)
        end
    end
end
function ConduitSystem.prototype.infuse(self, entity)
    local conduit = entity.conduit
    entity.combat.isInvincible = false
    local inventory = entity.inventory:get()
    conduit.partition = conduit.partition + 1
    GameEvents.conduitInfused:invoke(entity, conduit.partition, conduit.partitions)
    if conduit.partition == conduit.partitions then
        local data = CONDUIT_TIERS[conduit.tier + 1]
        conduit.tier = conduit.tier + 1
        conduit.partition = 0
        conduit.partitions = -1
        animator.play(entity, data.grow, false)
        animator.queue(entity, data.animation, true)
        local producer = entity.producer
        producer.throughput = data.power
        producer.generate = data.power
        SceneManager.get().camera:shake(2800, 2)
        local ____World_stats_0, ____conduitLevel_1 = World.stats, "conduitLevel"
        ____World_stats_0[____conduitLevel_1] = ____World_stats_0[____conduitLevel_1] + 1
        GameEvents.conduitLeveled:invoke(entity, conduit.tier)
        if self:canUnlock(conduit) then
            self:unlockTier(entity)
        else
            inventory.features = InventoryFeatures.None
        end
    else
        SceneManager.get().camera:shake(200, 1)
    end
    inventory:clear()
end
function ConduitSystem.prototype.canUnlock(self, conduit)
    local id = CONDUIT_TIERS[conduit.tier + 1].technology
    return id ~= TechnologyID.None and TechnologyManager:get(id).hasResearched
end
function ConduitSystem.prototype.unlockTier(self, entity)
    local conduit = entity.conduit
    local data = CONDUIT_TIERS[conduit.tier + 1]
    conduit.required = data.required
    conduit.partitions = data.partitions
    local inventory = entity.inventory:get()
    inventory:setFilterPrefabs(data.prefabFilter)
    inventory.features = InventoryFeatures.Collect
    inventory.stackOverride = math.floor(conduit.required / conduit.partitions)
    World:get(entity.location.realm).items:setCollectorState(entity.id, false)
end
ConduitSystem.ID = HashString("ConduitSystem")
if _G.ConduitSystem == nil then
    _G.ConduitSystem = __TS__New(ConduitSystem)
    SystemManager.registerSystem(ConduitSystem.ID, _G.ConduitSystem, 1000)
    SystemManager.associate(
        ConduitSystem.ID,
        hash.hash_str32("conduit")
    )
end
local manager = _G.ConduitSystem
____exports.ConduitSystem = manager
____exports.CONDUIT_TIERS = CONDUIT_TIERS
return ____exports
