local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["8"] = 1,["9"] = 1,["10"] = 2,["11"] = 2,["12"] = 4,["13"] = 4,["14"] = 4,["15"] = 6,["16"] = 7,["17"] = 8,["18"] = 8,["19"] = 8,["20"] = 8,["21"] = 8,["22"] = 9,["23"] = 6,["24"] = 12,["25"] = 13,["26"] = 15,["27"] = 16,["29"] = 19,["30"] = 12,["31"] = 5,["32"] = 23});
local ____exports = {}
local ____input = require("components.input")
local InputComponent = ____input.InputComponent
local ____base = require("systems.base")
local EntitySystem = ____base.EntitySystem
local InputSystem = __TS__Class()
InputSystem.name = "InputSystem"
__TS__ClassExtends(InputSystem, EntitySystem)
function InputSystem.register(self)
    local system = __TS__New(InputSystem)
    SystemManager.registerSystem(
        InputSystem.ID,
        system,
        seconds(1)
    )
    SystemManager.associate(InputSystem.ID, InputComponent.cid)
end
function InputSystem.prototype.updateFixed(self, fixedTime)
    tracy.ZoneBeginN("InputSystem::update()")
    for ____, entityID in ipairs(self.entities) do
        EntityManager.get(entityID).input:updateFixed(fixedTime)
    end
    tracy.ZoneEnd()
end
InputSystem.ID = HashString("InputSystem")
____exports.InputSystem = InputSystem
return ____exports
