local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local Set = ____lualib.Set
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 5,["14"] = 5,["15"] = 5,["17"] = 5,["18"] = 7,["19"] = 8,["20"] = 5,["21"] = 14,["22"] = 14,["23"] = 16,["24"] = 5,["25"] = 18,["26"] = 18,["27"] = 19,["28"] = 16,["29"] = 22,["30"] = 23,["31"] = 24,["33"] = 22,["34"] = 6,["35"] = 10,["36"] = 32,["37"] = 33,["38"] = 34,["39"] = 35,["40"] = 35,["41"] = 35,["42"] = 35,["43"] = 36,["45"] = 39,["46"] = 41});
local ____exports = {}
local ____items = require("items")
local populateItemCategory = ____items.populateItemCategory
local ____base = require("systems.base")
local EntityPrefabSystem = ____base.EntityPrefabSystem
local ItemSystem = __TS__Class()
ItemSystem.name = "ItemSystem"
__TS__ClassExtends(ItemSystem, EntityPrefabSystem)
function ItemSystem.prototype.____constructor(self, ...)
    EntityPrefabSystem.prototype.____constructor(self, ...)
    self.items = {}
    self.known = __TS__New(Set)
end
function ItemSystem.prototype.initialize(self)
end
function ItemSystem.prototype.addPrefab(self, entity, component)
    EntityPrefabSystem.prototype.addPrefab(self, entity, component)
    local ____self_items_0 = self.items
    ____self_items_0[#____self_items_0 + 1] = Item.new(entity.id, 1)
    populateItemCategory(nil, entity, component)
end
function ItemSystem.prototype.handleLearnRecipe(self, recipe)
    for ____, item in ipairs(recipe.result) do
        self.known:add(item.entityID)
    end
end
ItemSystem.ID = HashString("ItemSystem")
ItemSystem.SCHEMA = Schema.new({SchemaField.new("known", DataTypes.SET, DataTypes.ENTITY)})
if _G.ItemSystem == nil then
    _G.ItemSystem = __TS__New(ItemSystem)
    SystemManager.registerSystem(ItemSystem.ID, _G.ItemSystem, 16)
    SystemManager.associate(
        ItemSystem.ID,
        hash.hash_str32("item")
    )
    log.info("Registering ItemSystem")
end
local manager = _G.ItemSystem
____exports.ItemSystem = manager
return ____exports
