local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["8"] = 1,["9"] = 1,["10"] = 2,["11"] = 2,["12"] = 4,["13"] = 4,["14"] = 4,["15"] = 7,["16"] = 7,["17"] = 9,["18"] = 10,["20"] = 11,["21"] = 12,["22"] = 13,["23"] = 13,["25"] = 15,["26"] = 16,["30"] = 9,["31"] = 5,["32"] = 23,["33"] = 24,["34"] = 25,["35"] = 26,["36"] = 26,["37"] = 26,["38"] = 26,["39"] = 27,["41"] = 30,["42"] = 32});
local ____exports = {}
local ____world = require("world")
local World = ____world.World
local ____base = require("systems.base")
local EntitySystem = ____base.EntitySystem
local WellspringSystem = __TS__Class()
WellspringSystem.name = "WellspringSystem"
__TS__ClassExtends(WellspringSystem, EntitySystem)
function WellspringSystem.prototype.initialize(self)
end
function WellspringSystem.prototype.updateFixed(self, frameTime)
    for ____, entityID in ipairs(self.entities) do
        do
            local entity = EntityManager.get(entityID)
            local wellspring = entity.wellspring
            if wellspring.extractor == INVALID_ENTITYID then
                goto __continue4
            end
            local source = EntityManager.get(wellspring.extractor).fluidSource
            source:setQuantity(source.quantity + math.floor(wellspring.generation * (World.stats.wellspringPumping / 100)))
        end
        ::__continue4::
    end
end
WellspringSystem.ID = HashString("WellspringSystem")
if _G.WellspringSystem == nil then
    _G.WellspringSystem = __TS__New(WellspringSystem)
    SystemManager.registerSystem(WellspringSystem.ID, _G.WellspringSystem, 16)
    SystemManager.associate(
        WellspringSystem.ID,
        hash.hash_str32("wellspring")
    )
    log.info("Registering WellspringSystem")
end
local manager = _G.WellspringSystem
____exports.WellspringSystem = manager
return ____exports
