local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["9"] = 1,["10"] = 1,["11"] = 2,["12"] = 2,["13"] = 3,["14"] = 3,["15"] = 4,["16"] = 4,["17"] = 7,["18"] = 7,["19"] = 7,["20"] = 16,["21"] = 7,["22"] = 10,["23"] = 11,["24"] = 12,["25"] = 13,["26"] = 18,["27"] = 19,["28"] = 16,["29"] = 22,["30"] = 23,["31"] = 24,["32"] = 25,["33"] = 26,["34"] = 27,["35"] = 28,["37"] = 7,["38"] = 22,["39"] = 34,["40"] = 35,["41"] = 36,["42"] = 37,["43"] = 38,["44"] = 39,["46"] = 42,["47"] = 43,["48"] = 45,["49"] = 46,["50"] = 34,["51"] = 49,["52"] = 50,["53"] = 52,["54"] = 53,["55"] = 53,["56"] = 53,["57"] = 53,["58"] = 53,["59"] = 53,["60"] = 53,["61"] = 54,["62"] = 55,["63"] = 57,["64"] = 58,["66"] = 61,["67"] = 49,["68"] = 64,["69"] = 65,["70"] = 67,["71"] = 68,["72"] = 70,["74"] = 71,["75"] = 71,["76"] = 72,["77"] = 73,["78"] = 74,["79"] = 75,["80"] = 76,["81"] = 77,["82"] = 79,["83"] = 79,["84"] = 79,["85"] = 79,["86"] = 79,["87"] = 79,["88"] = 80,["89"] = 81,["90"] = 83,["92"] = 84,["93"] = 84,["94"] = 85,["95"] = 86,["96"] = 87,["97"] = 84,["100"] = 89,["101"] = 90,["102"] = 90,["103"] = 90,["104"] = 90,["105"] = 90,["106"] = 91,["107"] = 93,["108"] = 94,["109"] = 94,["110"] = 94,["111"] = 94,["112"] = 95,["113"] = 95,["114"] = 95,["115"] = 95,["116"] = 95,["118"] = 71,["121"] = 99,["122"] = 64,["123"] = 102,["124"] = 103,["125"] = 105,["126"] = 106,["127"] = 107,["128"] = 109,["130"] = 110,["131"] = 110,["132"] = 111,["133"] = 112,["134"] = 113,["135"] = 110,["140"] = 119,["141"] = 102,["142"] = 122,["143"] = 123,["146"] = 124,["147"] = 122,["148"] = 127,["149"] = 128,["152"] = 130,["153"] = 131,["157"] = 133,["158"] = 133,["159"] = 134,["160"] = 135,["161"] = 136,["162"] = 137,["163"] = 138,["164"] = 139,["165"] = 140,["166"] = 133,["170"] = 143,["171"] = 143,["172"] = 144,["173"] = 145,["174"] = 146,["175"] = 147,["176"] = 148,["177"] = 149,["178"] = 150,["179"] = 143,["182"] = 127,["183"] = 154,["184"] = 155,["185"] = 156,["186"] = 157,["187"] = 158,["190"] = 162,["191"] = 163,["194"] = 165,["195"] = 166,["197"] = 169,["198"] = 154,["199"] = 172,["200"] = 173,["201"] = 174,["202"] = 172,["203"] = 9,["204"] = 178});
local ____exports = {}
local ____base = require("ui.base")
local EntityDialogUI = ____base.EntityDialogUI
local ____core = require("core")
local core = ____core.core
local ____item_grid = require("ui.item_grid")
local ItemGridUI = ____item_grid.ItemGridUI
local ____item_interactions = require("ui.item_interactions")
local ItemInteractionUI = ____item_interactions.ItemInteractionUI
local ContainerUI = __TS__Class()
ContainerUI.name = "ContainerUI"
__TS__ClassExtends(ContainerUI, EntityDialogUI)
function ContainerUI.prototype.____constructor(self, player)
    EntityDialogUI.prototype.____constructor(self, player)
    self.grids = __TS__New(Map)
    self.destroyCallbackID = 0
    self.inventoryCallbackID = 0
    self.inventoryLockCallbackID = 0
    self.interactions = __TS__New(ItemInteractionUI, self.playerID)
    self:initialize()
end
function ContainerUI.prototype.onHide(self)
    if self.entityID ~= INVALID_ENTITYID then
        local entity = EntityManager.get(self.entityID)
        entity.inventory.onChange:remove(self.inventoryCallbackID)
        entity.inventory.onChangeLock:remove(self.inventoryLockCallbackID)
        self.inventoryCallbackID = 0
        self.inventoryLockCallbackID = 0
    end
    EntityDialogUI.prototype.onHide(self)
end
function ContainerUI.prototype.changedEntity(self, entity, previous)
    if previous then
        previous.inventory.onChange:remove(self.inventoryCallbackID)
        previous.inventory.onChangeLock:remove(self.inventoryLockCallbackID)
        self.inventoryCallbackID = 0
        self.inventoryLockCallbackID = 0
    end
    self.interactions.entityID = entity.id
    self:populateDialog()
    self.inventoryCallbackID = entity.inventory.onChange:listen(core.cb(self, "updateInventorySlot"))
    self.inventoryLockCallbackID = entity.inventory.onChangeLock:listen(core.cb(self, "updateInventorySlot"))
end
function ContainerUI.prototype.initialize(self)
    self:create("Container", "CONTAINER", "Container", DialogPlacement.Right)
    local sections = {}
    local content = Section.new(
        SectionType.Content,
        "content",
        PixelVector.new(),
        Padding.new(10),
        false
    )
    self.dialog:associate(content)
    sections[#sections + 1] = content
    if self.entityID ~= INVALID_ENTITYID then
        self:populateDialog()
    end
    self.dialog:initialize(sections, DialogFeatures.Closable)
end
function ContainerUI.prototype.populateDialog(self)
    local entity = EntityManager.get(self.entityID)
    local content = self.dialog:getElement("content")
    content:clear()
    local inventories = entity.inventory:getInventories()
    do
        local i = 0
        while i < #inventories do
            local inventory = inventories[i + 1]
            local grid = __TS__New(ItemGridUI, ContainerUI.ROW_COUNT)
            grid.onActivate = core.bind(self, "onActivateItem", inventory.name)
            grid.onSecondaryActivate = core.bind(self, "onSecondaryActivateItem", inventory.name)
            grid.onShowTooltip = core.bind(self.interactions, "onShowTooltip", inventory.name)
            grid.onMouseEnter = core.bind(self, "onMouseEnter", inventory.name)
            content:addRelative(
                grid.group,
                Alignment.TopLeft,
                pad.top(7),
                Alignment.BottomLeft
            )
            grid:updateItems(inventory.items, inventory)
            self.grids:set(inventory.name, grid)
            if inventory.collectSize ~= -1 then
                do
                    local index = inventory.collectSize
                    while index < inventory.size do
                        local slot = grid.items[index + 1]
                        slot.closed = true
                        slot:updateClass()
                        index = index + 1
                    end
                end
                local itemGroup = content:associate(ElementGroup.new("itemslot"))
                local background = itemGroup:add(
                    Image.new("background"),
                    Alignment.Left,
                    Padding.new()
                )
                background.onActivate:listen(core.bind(self, "onActivateResize", inventory.name))
                background.onMouseEnter:listen(core.bind(self, "onMouseEnter", inventory.name, #grid.items))
                itemGroup:add(
                    Image.new("xmark"),
                    Alignment.Center
                )
                content:addRelative(
                    itemGroup,
                    Alignment.BottomLeft,
                    pad.top(4)
                )
            end
            i = i + 1
        end
    end
    self.dialog:resizeToElements(true)
end
function ContainerUI.prototype.onActivateItem(self, name, index, element)
    local inventory = EntityManager.get(self.entityID).inventory:get(name)
    if self.resizing then
        inventory.collectSize = index
        self.resizing = nil
        local grid = self.grids:get(name)
        do
            local index = inventory.collectSize
            while index < inventory.size do
                local slot = grid.items[index + 1]
                slot.closed = true
                slot:updateClass()
                index = index + 1
            end
        end
        return
    end
    self.interactions:onActivateItem(name, index, element)
end
function ContainerUI.prototype.onSecondaryActivateItem(self, name, index, element)
    if self.resizing then
        return
    end
    self.interactions:onSecondaryActivateItem(name, index, element)
end
function ContainerUI.prototype.onMouseEnter(self, name, index, element)
    if not self.resizing then
        return
    end
    local grid = self.grids:get(name)
    if grid == nil then
        return
    end
    do
        local i = 0
        while i < index do
            local slot = grid.items[i + 1]
            slot.background.layerOffset = 0
            slot.icon.layerOffset = 0
            slot.lock.layerOffset = 0
            slot.quantity.layerOffset = 0
            slot.closed = false
            slot:updateClass()
            i = i + 1
        end
    end
    do
        local i = index
        while i < #grid.items do
            local slot = grid.items[i + 1]
            slot.background.layerOffset = 1
            slot.icon.layerOffset = 1
            slot.lock.layerOffset = 1
            slot.quantity.layerOffset = 1
            slot.closed = true
            slot:updateClass()
            i = i + 1
        end
    end
end
function ContainerUI.prototype.onActivateResize(self, name, element)
    if self.resizing then
        self.resizing = nil
        local inventory = EntityManager.get(self.entityID).inventory:get()
        inventory.collectSize = inventory.size
        return
    end
    local grid = self.grids:get(name)
    if grid == nil then
        return
    end
    for ____, slot in ipairs(grid.items) do
        slot.group:clearClass()
    end
    self.resizing = EntityManager.get(self.entityID).inventory:get().size
end
function ContainerUI.prototype.updateInventorySlot(self, name, index, item, isLocked)
    local grid = self.grids:get(name)
    grid:updateItem(index, item, isLocked)
end
ContainerUI.ROW_COUNT = 10
____exports.ContainerUI = ContainerUI
return ____exports
