local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__New = ____lualib.__TS__New
local __TS__ArraySplice = ____lualib.__TS__ArraySplice
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["8"] = 1,["9"] = 1,["10"] = 2,["11"] = 2,["12"] = 5,["13"] = 5,["14"] = 16,["15"] = 6,["16"] = 17,["17"] = 18,["18"] = 18,["19"] = 18,["20"] = 18,["21"] = 18,["22"] = 16,["23"] = 21,["24"] = 22,["25"] = 21,["26"] = 25,["27"] = 26,["28"] = 28,["30"] = 29,["31"] = 29,["32"] = 30,["33"] = 30,["34"] = 29,["37"] = 33,["38"] = 34,["39"] = 35,["41"] = 38,["42"] = 39,["43"] = 40,["44"] = 40,["45"] = 40,["46"] = 40,["47"] = 40,["48"] = 40,["50"] = 42,["51"] = 42,["52"] = 44,["53"] = 45,["54"] = 46,["55"] = 47,["56"] = 47,["57"] = 47,["58"] = 47,["59"] = 47,["60"] = 47,["62"] = 50,["63"] = 51,["64"] = 53,["65"] = 53,["66"] = 53,["67"] = 53,["68"] = 53,["69"] = 53,["71"] = 53,["73"] = 53,["74"] = 54,["75"] = 55,["77"] = 58,["78"] = 59,["80"] = 62,["81"] = 63,["83"] = 66,["84"] = 67,["85"] = 42,["88"] = 70,["89"] = 25,["90"] = 73,["91"] = 74,["92"] = 73,["93"] = 78,["94"] = 79,["95"] = 78,["96"] = 82,["97"] = 83,["98"] = 82,["99"] = 86,["100"] = 87,["101"] = 86,["102"] = 90,["103"] = 91,["104"] = 90,["105"] = 94,["106"] = 95,["107"] = 96,["109"] = 99,["110"] = 100,["112"] = 94,["113"] = 104,["114"] = 105,["115"] = 107,["116"] = 108,["118"] = 104,["119"] = 113});
local ____exports = {}
local ____core = require("core")
local core = ____core.core
local ____itemslot = require("ui.itemslot")
local ItemSlotUI = ____itemslot.ItemSlotUI
local ItemGridUI = __TS__Class()
ItemGridUI.name = "ItemGridUI"
function ItemGridUI.prototype.____constructor(self, maxColumns)
    self.items = {}
    self.maxColumns = maxColumns
    self.group = Panel.new(
        "item-grid",
        PixelVector.new(),
        Padding.new(2, 3, 3, 3)
    )
end
function ItemGridUI.prototype.updateItem(self, index, item, isLocked)
    self.items[index + 1]:update(item, isLocked)
end
function ItemGridUI.prototype.updateItems(self, items, inventory)
    local difference = #items - #self.items
    if difference > 0 then
        do
            local i = 0
            while i < difference do
                local ____self_items_0 = self.items
                ____self_items_0[#____self_items_0 + 1] = __TS__New(ItemSlotUI)
                i = i + 1
            end
        end
    elseif difference < 0 then
        difference = -difference
        __TS__ArraySplice(self.items, #self.items - difference, difference)
    end
    local rowNumber = 0
    local itemRow = self.group:associate(ElementGroup.new("itemrow-0"))
    self.group:addRelative(
        itemRow,
        Alignment.TopLeft,
        Padding.new(),
        Alignment.BottomLeft
    )
    do
        local index = 0
        while index < #items do
            if index ~= 0 and index % self.maxColumns == 0 then
                rowNumber = rowNumber + 1
                itemRow = self.group:associate(ElementGroup.new("itemrow-" .. tostring(rowNumber)))
                self.group:addRelative(
                    itemRow,
                    Alignment.TopLeft,
                    pad.bottom(1),
                    Alignment.BottomLeft
                )
            end
            local slot = self.items[index + 1]
            slot:addToParent(itemRow, self.padding)
            local ____slot_3 = slot
            local ____slot_update_4 = slot.update
            local ____items_index_2 = items[index + 1]
            local ____temp_1
            if inventory ~= nil then
                ____temp_1 = inventory:isLocked(index)
            else
                ____temp_1 = false
            end
            ____slot_update_4(____slot_3, ____items_index_2, ____temp_1)
            if self.onActivate ~= nil then
                slot.background.onActivate:listen(core.bind(self, "onActivateSlot", index))
            end
            if self.onSecondaryActivate ~= nil then
                slot.background.onSecondaryActivate:listen(core.bind(self, "onSecondaryActivateSlot", index))
            end
            if self.onShowTooltip ~= nil then
                slot.background.onShowTooltip:listen(core.bind(self, "onShowTooltipSlot", index))
            end
            slot.background.onMouseEnter:listen(core.bind(self, "onMouseEnterSlot", index))
            slot.background.onMouseLeave:listen(core.bind(self, "onMouseLeaveSlot", index))
            index = index + 1
        end
    end
    self.group:resizeToElements(false)
end
function ItemGridUI.prototype.showGrabbed(self, index)
    self.items[index + 1]:showGrabbed()
end
function ItemGridUI.prototype.highlightItem(self, index)
    self.items[index + 1].group:setClass("highlighted")
end
function ItemGridUI.prototype.onActivateSlot(self, index, element)
    self.onActivate(index, element)
end
function ItemGridUI.prototype.onSecondaryActivateSlot(self, index, element)
    self.onSecondaryActivate(index, element)
end
function ItemGridUI.prototype.onShowTooltipSlot(self, index, element)
    self.onShowTooltip(index, element)
end
function ItemGridUI.prototype.onMouseEnterSlot(self, index, element)
    if self.items[index + 1].icon:isVisible() then
        UIManager.setCursor(CursorType.ItemGrab)
    end
    if self.onMouseEnter ~= nil then
        self.onMouseEnter(index, element)
    end
end
function ItemGridUI.prototype.onMouseLeaveSlot(self, index, element)
    UIManager.setCursor(CursorType.Basic)
    if self.onMouseLeave ~= nil then
        self.onMouseLeave(index, element)
    end
end
____exports.ItemGridUI = ItemGridUI
return ____exports
