local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 5,["10"] = 5,["11"] = 7,["12"] = 9,["13"] = 9,["14"] = 9,["15"] = 14,["16"] = 9,["17"] = 10,["18"] = 11,["19"] = 16,["20"] = 17,["21"] = 18,["22"] = 18,["23"] = 18,["24"] = 18,["25"] = 19,["26"] = 19,["27"] = 19,["28"] = 19,["29"] = 19,["30"] = 19,["31"] = 19,["32"] = 20,["33"] = 21,["34"] = 22,["35"] = 23,["36"] = 23,["37"] = 23,["38"] = 23,["39"] = 24,["40"] = 25,["41"] = 25,["42"] = 25,["43"] = 25,["44"] = 25,["45"] = 14,["46"] = 28,["47"] = 29,["48"] = 31,["49"] = 32,["50"] = 33,["52"] = 35,["53"] = 36,["55"] = 28,["56"] = 40,["57"] = 41,["58"] = 42,["59"] = 43,["60"] = 44,["61"] = 44,["62"] = 44,["63"] = 44,["64"] = 44,["65"] = 44,["66"] = 44,["67"] = 40,["68"] = 47,["69"] = 48,["70"] = 49,["71"] = 50,["72"] = 51,["73"] = 47,["74"] = 54,["75"] = 55,["76"] = 56,["77"] = 58,["78"] = 59,["79"] = 60,["81"] = 63,["82"] = 64,["83"] = 54,["84"] = 67,["85"] = 68,["86"] = 69,["87"] = 70,["88"] = 71,["90"] = 67,["91"] = 77});
local ____exports = {}
local ____core = require("core")
local core = ____core.core
local ____module = require("ui.modules.module")
local ModuleUI = ____module.ModuleUI
local HEADER_FILTER = "UIModalHeaderFilter"
local FilterSelectModuleUI = __TS__Class()
FilterSelectModuleUI.name = "FilterSelectModuleUI"
__TS__ClassExtends(FilterSelectModuleUI, ModuleUI)
function FilterSelectModuleUI.prototype.____constructor(self, parent, playerID)
    ModuleUI.prototype.____constructor(self)
    self.playerID = INVALID_ENTITYID
    self.entityID = INVALID_ENTITYID
    self.playerID = playerID
    self.element = parent:associate(ElementGroup.new("recipe-select-module"))
    local recipeItem = self.element:add(
        ElementGroup.new("itemslot"),
        Alignment.Top
    )
    local background = recipeItem:add(
        Panel.new(
            "recipe-select",
            PixelVector.new(28, 28)
        ),
        Alignment.Left
    )
    background.onShowTooltip:listen(core.cb(self, "onShowTooltipFilter"))
    background.onActivate:listen(core.bind(self, "onActivateFilter"))
    background.onSecondaryActivate:listen(core.cb(self, "onSecondaryActivateItem"))
    self.icon = recipeItem:add(
        Image.new("icon"),
        Alignment.Center
    )
    self.icon:hide()
    self.element:addRelative(
        Label.new("header", "UIFilterLabel"),
        Alignment.Bottom,
        pad.top(7)
    )
end
function FilterSelectModuleUI.prototype.changedEntity(self, entity, previous)
    self.entityID = entity.id
    local item = entity.filter.item
    if item:isEmpty() then
        self.icon:hide()
    else
        self.icon:setAtlas(item:entity().item.icon)
        self.icon:show()
    end
end
function FilterSelectModuleUI.prototype.onActivateFilter(self)
    local entity = EntityManager.get(self.entityID)
    local modal = UIManager.get("Modal")
    local modular = UIManager.get("Modular")
    modal:openItems(
        modular,
        HEADER_FILTER,
        core.cb(self, "onSelectedItem"),
        entity.filter.filter,
        false
    )
end
function FilterSelectModuleUI.prototype.onSecondaryActivateItem(self)
    local entity = EntityManager.get(self.entityID)
    entity.filter.item = Item.new()
    entity.splitter.outputPriority = SplitterPriority.None
    self:changedEntity(entity)
end
function FilterSelectModuleUI.prototype.onSelectedItem(self, item)
    local entity = EntityManager.get(self.entityID)
    entity.filter.item = item
    local splitter = entity.splitter
    if splitter and splitter.outputPriority == SplitterPriority.None then
        splitter.outputPriority = SplitterPriority.Left
    end
    local modular = UIManager.get("Modular")
    modular:changedEntity(entity, entity)
end
function FilterSelectModuleUI.prototype.onShowTooltipFilter(self, element)
    local entity = EntityManager.get(self.entityID)
    local item = entity.filter.item
    if not item:isEmpty() then
        UIManager.get("Tooltip"):showItem(element, item)
    end
end
____exports.FilterSelectModuleUI = FilterSelectModuleUI
return ____exports
