$input a_position, a_color0, a_texcoord0, i_data0, i_data1, i_data2, i_data3
$output v_color0

#include <bgfx_shader.sh>

void main()
{
    //Instance Data
    // Color (4) i_data0.xyzw
    // center (2) i_data1.xy
    // origin (2) i_data1.zw
    // scale (2) i_data2.xy
    // angle (1) i_data2.z
    // z (1) i_data2.w

    // vec2 origin = i_data2.xy / i_data1.zw;
    mat4 projViewWorld = mul(mul(u_proj, u_view), u_model[0]);
    mat2 rotation = mat2(cos(i_data2.z),-sin(i_data2.z), sin(i_data2.z),cos(i_data2.z));
    // SRT (Scale, Rotate, Translate)
    // position.xy -= origin;
    vec2 position = mul(rotation, a_position.xy * i_data2.xy) + i_data1.xy;
    // position.xy += origin;
    gl_Position = mul(projViewWorld, vec4(position, i_data2.w, 1.0));
    v_color0 = i_data0 / 255.0;
}