$input a_position, a_color0, a_texcoord0
$output v_color0, v_texcoord0, v_illum, v_uv

#include <bgfx_shader.sh>

SAMPLER2D(s_texture, 0);

void main()
{
    mat4 projViewWorld = mul(mul(u_proj, u_view), u_model[0]);
    vec4 position = mul(projViewWorld, vec4(a_position, 1.0));
    gl_Position = vec4(a_position.xy * 2 - 1, position.z / position.w, 1.0);
    v_color0 = a_color0;
    v_texcoord0 = a_texcoord0;
    v_texcoord0.y = 1.0 - v_texcoord0.y;
}