$input v_color0, v_texcoord0, v_illum, v_uv

#include <bgfx_shader.sh>

SAMPLER2D(s_texture, 0);
uniform vec2 texelSize;

void main()
{
    vec4 result = texture2D(s_texture, v_texcoord0.xy) * 0.2270270270;

    result += texture2D(s_texture, v_texcoord0.xy + vec2(1 * texelSize.x, 0.0)) * 0.1945945946;
    result += texture2D(s_texture, v_texcoord0.xy - vec2(1 * texelSize.x, 0.0)) * 0.1945945946;

    result += texture2D(s_texture, v_texcoord0.xy + vec2(2 * texelSize.x, 0.0)) * 0.1216216216;
    result += texture2D(s_texture, v_texcoord0.xy - vec2(2 * texelSize.x, 0.0)) * 0.1216216216;

    result += texture2D(s_texture, v_texcoord0.xy + vec2(3 * texelSize.x, 0.0)) * 0.0540540541;
    result += texture2D(s_texture, v_texcoord0.xy - vec2(3 * texelSize.x, 0.0)) * 0.0540540541;

    result += texture2D(s_texture, v_texcoord0.xy + vec2(4 * texelSize.x, 0.0)) * 0.0162162162;
    result += texture2D(s_texture, v_texcoord0.xy - vec2(4 * texelSize.x, 0.0)) * 0.0162162162;
    if (result.a > 0) {
        result.a *= 3;
    }

    gl_FragColor = result;
}
