$input a_position, a_color0, a_texcoord0, i_data0, i_data1, i_data2, i_data3
$output v_color0

#include <bgfx_shader.sh>

void main()
{
    //Instance Data
    // Color (4)
    // start (2)
    // end (2)
    // origin (2)
    // scale (2)
    // angle (1)
    // z (1)

    // Not using origin at the moment since it doesn't work with end being less than the start
    vec2 size = i_data1.zw - i_data1.xy;
    //vec2 origin = i_data2.xy / size;
    mat4 projViewWorld = mul(mul(u_proj, u_view), u_model[0]);
    mat2 rotation = mat2(cos(i_data3.x),-sin(i_data3.x), sin(i_data3.x),cos(i_data3.x));
    // SRT (Scale, Rotate, Translate)
    //a_position.xy -= origin;
    vec2 position = mul(rotation, a_position.xy * i_data2.zw * size) + i_data1.xy;
    //a_position.xy += origin;
    gl_Position = mul(projViewWorld, vec4(position, i_data3.y, 1.0));
    v_color0 = i_data0 / 255.0;
}