$input v_color0, v_texcoord0, v_illum, v_uv

#include <bgfx_shader.sh>

SAMPLER2D(s_texture, 0);
uniform float illumination;

void main()
{
    vec4 color = texture2D(s_texture, v_texcoord0).rgba;
    if (color.a == 0) {
        discard;
    }
    gl_FragColor = vec4(color.rgb, color.a);
}
